jQuery.sap.declare("sas.stress.archive.ConfigUtil");

jQuery.sap.require("sap.ui.core.format.DateFormat");
jQuery.sap.require("sap.ui.core.format.FileSizeFormat");

sas.stress.config.ConfigUtil = {

    i18n: new sap.ui.model.resource.ResourceModel({ bundleName: "sas.stress.config.messagebundle" }),

    getBundle: function () {
        return this.i18n.getResourceBundle();
    },

    formatDate: function (dttm) {
        var dateFormat = sap.ui.core.format.DateFormat.getDateInstance();
        return dateFormat.format(new Date(dttm), true);  // The true sets it to use UTC time zone;  without it, it subtracts a day
    },
    formatDateTime: function (dttm) {
        if (dttm === undefined || dttm === null) {
            return "";
        }
        var dateTimeFormat = sap.ui.core.format.DateFormat.getDateTimeInstance();
        return dateTimeFormat.format(new Date(dttm));
    },
    formatFileSize:  function (fileSizeInBytes) {
        if (fileSizeInBytes < 0) {
            return "";
        }
        var fileSizeFormatter = sap.ui.core.format.FileSizeFormat.getInstance({
            binaryFilesize: false,
            maxFractionDigits: 2
        });
        return fileSizeFormatter.format(fileSizeInBytes);
    },
    formatBooleanTip: function (bValue) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.archive");
        return bValue ? rb.getText("boolean.true.tip") : rb.getText("boolean.false.tip");
    },
    formatBooleanIcon: function (bValue) {
        return bValue ? sas.icons.HC.COMMITCHANGES : sas.icons.HC.BLANK;
    }


};