jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.stress.config.model.Hierarchy");
jQuery.sap.require("sas.stress.config.model.HierarchyMapPair");
jQuery.sap.require("sas.stress.pfd.PfdStyles");
jQuery.sap.require("sas.stress.wkbench.CapabilityManager");
jQuery.sap.require("sas.stress.wkbench.EventBusConstants");
jQuery.sap.require("sas.stress.wkbench.LeftNavManager");
jQuery.sap.require("sas.stress.wkbench.StressGoTemplates");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.ViewManager");
jQuery.sap.require("sas.stress.wkbench.widget.ProcessDiagram");

//jQuery.sap.require("sas.studiolib.ui.model.SelectedColumnObject");
//jQuery.sap.require("sas.studiolib.ui.model.ExpressionObject");
//jQuery.sap.require("sas.studiolib.ui.ExpressionBuilder.ExpressionBuilderDialog");
//jQuery.sap.require("sas.studiolib.ui.Utils");

jQuery.sap.require("sas.risk.services.Data");
jQuery.sap.require("sas.risk.common.models.RiskJSONModel");

jQuery.sap.require("sap.ui.core.Control");
jQuery.sap.require("sas.hc.graph.GraphView");
jQuery.sap.require("sas.hc.graph.UIView");
jQuery.sap.require("sas.hc.m.MessageDialog");
jQuery.sap.require("sas.hc.ui.unified.Menu");
jQuery.sap.require("sas.ltjs.commons.gestures.GestureHelper");
jQuery.sap.require("sas.ltjs.gtl.models.data.DataSetDataProvider");
jQuery.sap.require("sas.ltjs.gtl.models.Graph");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.LayoutRegion");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDModel");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDArrangementEnum");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDToolbarIconEnum");
jQuery.sap.require("sas.ltjs.gtl.models.data.Role");
jQuery.sap.require("sas.ltjs.gtl.models.data.PlotRole");
jQuery.sap.require("sas.ltjs.gtl.models.core.RelativeDirection");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.Column");
jQuery.sap.require("sas.ltjs.gtl.models.data.ClassificationRole");
jQuery.sap.require("sas.ltjs.gtl.models.core.ColorModel");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataSet");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataType");
jQuery.sap.require("sas.ltjs.commons.models.data.DataValue");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.MutableColumn");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.MutableDataSet");
jQuery.sap.require("sas.ltjs.gtl.models.data.MutableDataSetDataProvider");
//jQuery.sap.require("sas.ltjs.commons.models.data.dataset.MutableDataSetChangeEvent");
jQuery.sap.require("sas.ltjs.ltjsLoader");
jQuery.sap.require("sas.hc.m.MessageToast");

"use strict";

sap.ui.controller("sas.stress.config.view.CreateSubledgerAccounting", {

    rb: sap.ui.getCore().getLibraryResourceBundle("sas.stress.wkbench"),

    onInit: function (event) {
        var view = this.getView();
        this.navChecker = sas.stress.wkbench.StressUtil.createNavChecker(true, view);
        this.model = new sas.risk.common.models.RiskJSONModel;

        var that = this;

        var i18N = new sap.ui.model.resource.ResourceModel({bundleName: "sas.stress.config.messagebundle"});
        view.setModel(i18N, "i18N");

        if (view.getViewData().editSubledger === 0) {
            var saveBtn = sap.ui.getCore().byId("subledger.save");
            saveBtn.setEnabled(true);
        }

        that.model.setProperty("/domainId", view.getViewData().domainId);
        that.model.setProperty("/name", view.getViewData().name);
        that.model.setProperty("/subledgerId", view.getViewData().subledgerId);
        that.model.setProperty("/subledgerName", view.getViewData().subledgerName);
        that.model.setProperty("/subledgerVersion", view.getViewData().subledgerVersion);

        var domainName = sap.ui.getCore().byId("subledger.domainName");
        domainName.setText(view.getViewData().name);
        var subName = sap.ui.getCore().byId("subledger.subledgerName");
        subName.setText(view.getViewData().subledgerName);
        var version = sap.ui.getCore().byId("subledger.version");
        version.setText(view.getViewData().subledgerVersion);

        that.model.setProperty("/domains", view.getViewData().domainId);
        that._loadSubledgerData(view.getViewData().domainId, view.getViewData().subledgerId );

        view.setModel(this.model);
        //view.editPostingGroupDialog.setModel(this.model);
        view.triggerRulesDialog.setModel(this.model);
        view.commentRulesDialog.setModel(this.model);
    },
    // _loadSubledgers: function (domId, subIndex) {
    //     var that = this;
    //     sas.stress.wkbench.StressAPI.loadSubledgers(domId).done(function (subledgers) {
    //         that.model.setProperty("/subledgers", subledgers);
    //         that._loadSubledgerData(domId, subledgers[subIndex].key);
    //         console.log(subledgers);
    //     });
    // },
    // _camelToSentenceCase: function(string) {
    //     var res = string.replace(/([A-Z])/g, ' $1');
    //     return res.charAt(0).toUpperCase() + res.slice(1);
    // },
    //
    // _camelToSentenceCaseAndReplaceSpace: function(string) {
    //     var res = string.replace(/([A-Z])/g, ' $1');
    //     res = res.replace(/\' \'/g, '\n');
    //     return res.charAt(0).toUpperCase() + res.slice(1);
    // },

    _loadHierarchyLiKeys: function(hierarchyKey) {
        var that = this;
        var liKeys = [];
        sas.stress.config.StressAPI.listHierarchyLiKeys(hierarchyKey).done(function (keys) {
            for(var i = 0; i < keys.length; i++) {
                liKeys.push({'item': keys[i]});
            }
            that.model.setProperty('/hierarchyLiKeys', liKeys);
        });
    },

    _loadSubledgerData: function (domId, subId) {
        var view = this.getView();
        var that = this;

        var accountsSaved = [];
        var eventsSaved = [];
        var entitiesSaved = [];

        var eventMappingTypes = [
            {key: 'TXT', text: 'Text (TXT)'},
            {key: 'COL', text: 'Column (COL)'},
            {key: 'NUM', text: 'Number (NUM)'}
        ];

        var mappingLevels = [
            {key: '', value:'All'},
            {key:'Common', value:'Common'},
            {key:'EventClass', value:'Event Class'},
            {key:'EventType', value:'Event Type'}
        ];
        var postAmountFlags = [
            {key: 'Y'},
            {key: 'N'}
        ];

        that.model.setProperty('/mappingLevels', mappingLevels);
        that.model.setProperty('/eventMappingTypes', eventMappingTypes);
        that.model.setProperty('/postAmountFlags', postAmountFlags);

        sas.stress.config.StressAPI.listAccountHierarchies().done(function (accounts) {
            for (var i = 0; i < accounts.length; i++) {
                if (accounts[i].version !== null) {
                    var account = {
                        "id": accounts[i].id,
                        "name": accounts[i].name + "-" + accounts[i].version,
                        "code": accounts[i].code
                    };
                } else {
                    var account = {
                        "id": accounts[i].id,
                        "name": accounts[i].name,
                        "code": accounts[i].code
                    };
                }
                accountsSaved.push(account);
            }
            accountsSaved = _.sortBy(accountsSaved, "name");
            that.model.setProperty("/accountHierarchy", accountsSaved);
        });

        sas.stress.config.StressAPI.listEventHierarchies().done(function (events) {
            for (var i = 0; i < events.length; i++) {
                if (events[i].version !== null) {
                    var eventData = {
                        "id": events[i].id,
                        "name": events[i].name + "-" + events[i].version,
                        "code": events[i].code
                    };
                } else {
                    var eventData = {
                        "id": events[i].id,
                        "name": events[i].name,
                        "code": events[i].code
                    };
                }
                eventsSaved.push(eventData);
            }
            eventsSaved = _.sortBy(eventsSaved, "name");
            that.model.setProperty("/eventHierarchy", eventsSaved);
        });

        sas.stress.config.StressAPI.listEntityHierarchies().done(function (entities) {
            for (var i = 0; i < entities.length; i++) {
                if (entities[i].version !== null) {
                    var entityData = {
                        "id": entities[i].id,
                        "name": entities[i].name + "-" + entities[i].version,
                        "code": entities[i].code
                    };
                } else {
                    var entityData = {
                        "id": entities[i].id,
                        "name": entities[i].name,
                        "code": entities[i].code
                    };
                }
                entitiesSaved.push(entityData);
            }
            entitiesSaved = _.sortBy(entitiesSaved, "name");
            that.model.setProperty("/entityHierarchy", entitiesSaved);
        });

        sas.stress.wkbench.StressAPI.loadSubledgerDetails(domId, subId).done(function (subledger) {
            var postings = [];
            //var commentRules  = [];
            var commentRulesUniqueTags  = [];
            var triggerRulesUniqueLevelValues  = [];
            var candidateEventTypes = [];
            var candidateEventClasses = [];
            var eventSubledgerMappingLevels = [];
            var triggerMappingLevels = [];
            var commentMappingLevels = [];
            var eventMappings = [];
            var postingFlagMappings = {
                'y': {
                    'event': [],
                    'sub': []
                },
                'n': {
                    'event': [],
                    'sub': []
                }
            };
            var eventSourceColumns = [];
            var mappedColumnNames = [];
            var enrichmentPropertiesColumns = [];
            // //Build the Comment Rules data structure
            // for (var i = 0; i < subledger.commentRules.length; i++) {
            //     var commentRule = [];
            //     commentRule.ruleName = subledger.commentRules[i].ruleName;
            //     commentRule.ruleDescription = subledger.commentRules[i].ruleDescription;
            //     commentRule.tag = subledger.commentRules[i].tag;
            //     commentRule.entity = subledger.commentRules[i].entity;
            //     commentRule.eventType = subledger.commentRules[i].eventType;
            //     commentRule.ruleLevel = subledger.commentRules[i].ruleLevel;
            //     commentRule.ruleName = subledger.commentRules[i].ruleName;
            //     commentRule.ruleOrder = subledger.commentRules[i].ruleOrder;
            //     //commentRule.entityHierarchy = {};
            //     //commentRule.entityHierarchy.hierarchyName = subledger.commentRules[i].entityHierarchy.hierarchyName;
            //     //commentRule.entityHierarchy.id = subledger.commentRules[i].entityHierarchy.id;
            //
            //     commentRules.push(commentRule);
            // }

            commentRulesUniqueTags = that.getUniqueTags(subledger.commentRules);
            triggerRulesUniqueLevelValues = that.getUniqueLevelValues(subledger.postingTriggerRules);

            that.getCandidateEventTypes(subledger.eventHierarchy.hierarchyKey, candidateEventTypes, candidateEventClasses);


            for (var i = 0; i < subledger.postingGroups.length; i++) {
                for (var j = 0; j < subledger.postingGroups[i].postings.length; j++) {
                    var post = subledger.postingGroups[i].postings[j];
                    post.postingGroupId = subledger.postingGroups[i].postingGroupId;
                    post.postingGroupDescription = subledger.postingGroups[i].postingGroupDescription;
                    var obj = {'item': post.mappedColumnName};
                    if(!mappedColumnNames.some(function(e){ return e.item === obj.item})){
                        mappedColumnNames.push(obj);
                    }
                    postings.push(post);
                }
            }

            eventSubledgerMappingLevels.push({"item": "Common", "key": "Common"});
            eventSubledgerMappingLevels.push({"item": "Event Class", "key": "EventClass"});
            eventSubledgerMappingLevels.push({"item": "Event Type", "key": "EventType"});

            //triggerMappingLevels.push({"item": "Common"});
            triggerMappingLevels.push({"item": "Event Class", "key": "EventClass"});
            triggerMappingLevels.push({"item": "Event Type", "key": "EventType"});

            commentMappingLevels.push({"item": "Common", "key": "Common"});
            commentMappingLevels.push({"item": "Event Class", "key": "EventClass"});
            commentMappingLevels.push({"item": "Event Type", "key": "EventType"});


            var nEvent = postingFlagMappings.n.event;
            var eventCCVS = subledger.generalProperties.find(function(o) { return o.propertyName === 'EVENT_CCVS'});
            eventCCVS.propertyValue.split(' ').forEach(function(event) {
                if (!nEvent.some(function(o) { return o.item === event})) {
                    nEvent.push({'item': event});
                }
            });

            var yEvent =  postingFlagMappings.y.event;

            subledger.eventMappings.forEach(function(e) {
                if(!eventMappings.includes(e.eventColumnName)) {
                    eventMappings.push(e.eventColumnName);
                    if(!yEvent.some(function(o) { return o.item === e.eventColumnName })) {
                        yEvent.push({'item': e.eventColumnName});
                    }
                }
            });

            var journalCCVS = subledger.generalProperties.find(function(o) { return o.propertyName === 'JOURNAL_CCVS' });
            journalCCVS.propertyValue.split(' ').forEach(function(sub) {
                postingFlagMappings.n.sub.push({'item': sub});
            });

            var journalMeasures = subledger.generalProperties.find(function(o) { return o.propertyName === 'JOURNAL_MEASURES' });
            journalMeasures.propertyValue.split(' ').forEach(function(sub) {
                postingFlagMappings.y.sub.push({'item': sub});
            });

            // Dynamic column names for event sources table
            for (var col in subledger.eventSources[0]) {
                eventSourceColumns.push({
                    key: col,
                    text: col
                });
            }

            // Dynamic column names for enrichment variables table
            for (var col in subledger.enrichmentProperties[0]) {
                enrichmentPropertiesColumns.push({
                    key: col,
                    text: col,
                    tooltip: col
                });
            }

            that.model.setProperty("/eventSubledgerMappingLevels", eventSubledgerMappingLevels);
            that.model.setProperty("/triggerMappingLevels", triggerMappingLevels);
            that.model.setProperty("/commentMappingLevels", commentMappingLevels);
            that.model.setProperty("/commentRulesUniqueTags", commentRulesUniqueTags);
            that.model.setProperty("/triggerRulesUniqueLevelValues", triggerRulesUniqueLevelValues);
            that.model.setProperty("/candidateEventTypes", candidateEventTypes);
            that.model.setProperty("/candidateEventClasses", candidateEventClasses);
            that.model.setProperty("/postings", postings);
            that.model.setProperty("/subledgerData", subledger);
            that.model.setProperty("/eventMappings", eventMappings);
            that.model.setProperty("/postingFlagMappings", postingFlagMappings);
            that.model.setProperty("/mappedColumnNames", mappedColumnNames);
            that.model.setProperty("/subledgerData/eventSourceColumns", eventSourceColumns);
            that.model.setProperty("/subledgerData/enrichmentPropertiesColumns", enrichmentPropertiesColumns);

            //that.model.setProperty("/subledgerData/commentRules", commentRules);
            //that.model.setProperty("/commentRules", commentRules);

            if (that.model.getData().subledgerData.accountingHierarchy !== undefined && that.model.getData().subledgerData.accountingHierarchy !== null) {
                var id = that.model.getProperty('/subledgerData/accountingHierarchy').id;
                view.accountHierarchySelect.setSelectedKey(id);
                that._loadHierarchyLiKeys(id);
            }
            if (that.model.getData().subledgerData.eventHierarchy !== undefined && that.model.getData().subledgerData.eventHierarchy !== null) {
                view.eventHierarchySelect.setSelectedKey(that.model.getData().subledgerData.eventHierarchy.id);
            }
            if (that.model.getData().subledgerData.entityHierarchy !== undefined && that.model.getData().subledgerData.entityHierarchy !== null) {
                view.entityHierarchySelect.setSelectedKey(that.model.getData().subledgerData.entityHierarchy.id);
            }
            console.log(that.model.getProperty('/'));

        });

    },

    // getUnique: function(arr, comp) {
    //     var unique = arr
    //         .map(e => e[comp])
    //
    //         // store the keys of the unique objects
    //         .map((e, i, final) => final.indexOf(e) === i && i)
    //
    //         // eliminate the dead keys & store unique objects
    //         .filter(e => arr[e]).map(e => arr[e]);
    //
    //     return unique;
    // },
    onAccountHierarchySelectChange: function() {
        var key = this.getView().accountHierarchySelect.getSelectedKey();

        this._loadHierarchyLiKeys(key);
        this.onBaseTabDescChange(/*"Acct"*/);
    },

    onEventHierarchySelectChange: function() {
        var key = this.getView().eventHierarchySelect.getSelectedKey();

        var candidateEventTypes = [];
        var candidateEventClasses = [];

        this.getCandidateEventTypes(key, candidateEventTypes, candidateEventClasses);

        this.model.setProperty("/candidateEventTypes", candidateEventTypes);
        this.model.setProperty("/candidateEventClasses", candidateEventClasses);

        this.onBaseTabDescChange(/*"Event"*/);
    },

    onEntityHierarchySelectChange: function() {
        this.onBaseTabDescChange(/*"Entity"*/);
    },


    getUniqueTags: function(arr) {
        var uniq = [];
        var found = false;

        for (var i in arr) {
            found = false;
            for (var x in uniq) {
                if (uniq[x].tag === arr[i].tag ) {
                    found = true;
                }
            }
            if (!found) {
                uniq.push(arr[i]);
            }
        }
        return uniq;
    },

    getUniqueLevelValues: function(arr) {
        var uniq = [];
        var found = false;

        for (var i in arr) {
            found = false;
            for (var x in uniq) {
                if (uniq[x].levelValue === arr[i].levelValue ) {
                    found = true;
                }
            }
            if (!found) {
                uniq.push(arr[i]);
            }
        }
        return uniq;
    },

    getCandidateEventTypes: function(hierarchyKey, listEventTypes, listEventClasses) {
        sas.stress.config.StressAPI.levelValueCandidates(hierarchyKey).done(function (candidates) {
            for(var i=0; i < candidates.candidateEventTypes.length; i++ ) {
                listEventTypes.push({"name":candidates.candidateEventTypes[i], "key":candidates.candidateEventTypes[i] });
            }

            for(var j=0; j < candidates.candidateEventClasses.length; j++ ) {
                listEventClasses.push({"name":candidates.candidateEventClasses[j], "key":candidates.candidateEventClasses[j]});
            }
        });
    },


    validateSubledger: function(/*type*/) {

        var validateOnly= true;
        this.saveSubledgerAccountingConfigButtonPress(validateOnly/*, type*/);
    },

    onDescChangeOnly:function(){
        var controller = this;
        controller._setDirty(true);
    },

    onBaseTabDescChange: function (/*type*/){
        var controller = this;
        controller._setDirty(true);
        this.validateSubledger(/*type*/);
    },

    _setDirty: function (isDirty) {
        this.navChecker.setDirty(isDirty);
        this.getView().saveButton.setEnabled(isDirty);
    },
    handlePostAmountFlagChange: function() {
        var postAmountFlag = sap.ui.getCore().byId('eventMapping-flag');
        var subledgerSelect = sap.ui.getCore().byId('subledgerMapSelect');
        var eventSelect = sap.ui.getCore().byId('eventSelect');

        var flagValue = postAmountFlag.getSelectedItem().getKey();

        var itemTemplate = new sap.ui.core.Item({
            text: "{item}",
            tooltip: "{item}",
            key: "{item}"
        });

        if(flagValue === 'Y') {
            subledgerSelect.bindItems('/postingFlagMappings/y/sub', itemTemplate);
            eventSelect.bindItems('/postingFlagMappings/y/event', itemTemplate);
        } else {
            subledgerSelect.bindItems('/postingFlagMappings/n/sub', itemTemplate);
            eventSelect.bindItems('/postingFlagMappings/n/event', itemTemplate);
        }

    },
    handleMappingLevelSelectChange: function() {
        var view = this.getView();
        var levelValueSelect = sap.ui.getCore().byId("levelValueSelect");
        var mappingLevelSelect = sap.ui.getCore().byId("mappingLevelSelect");


        var mappingValue = mappingLevelSelect.getSelectedItem().getKey();

        var itemTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{name}"
        });

        if (mappingValue === "Common") {
            levelValueSelect.setEnabled(false);
            levelValueSelect.bindItems("/emptyBind", itemTemplate, null);
        } else if (mappingValue === "EventClass"){
            levelValueSelect.bindItems("/candidateEventClasses", itemTemplate, null);
            levelValueSelect.setEnabled(true);
        }  else if (mappingValue === "EventType"){
            levelValueSelect.bindItems("/candidateEventTypes", itemTemplate, null);
            levelValueSelect.setEnabled(true);
        }
    },

    handleMappingInputChange: function() {
        var view = this.getView();
        var levelValueSelect = sap.ui.getCore().byId("levelValueInput");
        var mappingValue = view.mappingInput.getSelectedItem().getKey();

        var itemTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{name}"
        });

        if (mappingValue === "EventClass") {
            levelValueSelect.bindItems("/candidateEventClasses", itemTemplate, null);
        } else if (mappingValue === "EventType") {
            levelValueSelect.bindItems("/candidateEventTypes", itemTemplate, null);
        }

        this.handleRuleDescriptionChange();
    },


    handleRuleDescriptionChange: function () {
        var ruleName = sap.ui.getCore().byId("ruleNameInput");
        var ruleDesc = sap.ui.getCore().byId("ruleDescriptionInput");
        var expression = sap.ui.getCore().byId("expressionInput");

        // if ((ruleName.getValueState() === sap.ui.core.ValueState.None) &&
        //     (ruleDesc.getValueState() === sap.ui.core.ValueState.None)) {
        //     sap.ui.getCore().byId("NewTriggerDialog.OkButton").setEnabled(true);
        // } else {
        //     sap.ui.getCore().byId("NewTriggerDialog.OkButton").setEnabled(false);
        // }
        if (ruleName.getValue().length > 0 && ruleDesc.getValue().length > 0  && expression.getValue().length > 0) {
            sap.ui.getCore().byId("NewTriggerDialog.OkButton").setEnabled(true);
        }
    },

    handleCommentRuleMappingChange: function () {
        var view = this.getView();
        var mappingValue = view.mappingCommentInput.getSelectedItem().getKey();

        var itemTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{name}"
        });

        if (mappingValue === "Common") {
            view.commentLevelValueInput.setEnabled(false);
            view.commentLevelValueInput.bindItems("/emptyBind", itemTemplate, null);
        } else if (mappingValue === "EventClass"){
            view.commentLevelValueInput.bindItems("/candidateEventClasses", itemTemplate, null);
            view.commentLevelValueInput.setEnabled(true);
        }  else if (mappingValue === "EventType"){
            view.commentLevelValueInput.bindItems("/candidateEventTypes", itemTemplate, null);
            view.commentLevelValueInput.setEnabled(true);
        }

        this.handleCommentRuleDescriptionChange();
    },

    handleCommentRuleDescriptionChange: function () {
        var ruleName = sap.ui.getCore().byId("ruleCommentNameInput");
        var ruleDesc = sap.ui.getCore().byId("ruleCommentDescriptionInput");
        var ruleComment = sap.ui.getCore().byId("commentInput");
        var expressionComment = sap.ui.getCore().byId("expressionCommentInput");


        // if ((ruleName.getValueState() === sap.ui.core.ValueState.None) &&
        //     (ruleDesc.getValueState() === sap.ui.core.ValueState.None) &&
        //     (ruleComment.getValueState() === sap.ui.core.ValueState.None)) {
        //     sap.ui.getCore().byId("NewCommentDialog.OkButton").setEnabled(true);
        // } else {
        //     sap.ui.getCore().byId("NewCommentDialog.OkButton").setEnabled(false);
        // }
        if (ruleName.getValue().length > 0 &&
            ruleDesc.getValue().length > 0 &&
            ruleComment.getValue().length > 0  &&
            expressionComment.getValue().length > 0) {
            sap.ui.getCore().byId("NewCommentDialog.OkButton").setEnabled(true);
        }
    },

    handleInputTypeChange: function() {
        var key = sap.ui.getCore().byId('eventMapping-type').getSelectedKey();

        if(key == 'TXT') {
            sap.ui.getCore().byId('eventMapping-inputNumber').setVisible(false);
            sap.ui.getCore().byId('eventMapping-inputText').setVisible(true);
            sap.ui.getCore().byId('eventMapping-event').setVisible(false);
        } else if(key == 'NUM') {
            sap.ui.getCore().byId('eventMapping-inputNumber').setVisible(true);
            sap.ui.getCore().byId('eventMapping-inputText').setVisible(false);
            sap.ui.getCore().byId('eventMapping-event').setVisible(false);
        } else {
            sap.ui.getCore().byId('eventMapping-inputNumber').setVisible(false);
            sap.ui.getCore().byId('eventMapping-inputText').setVisible(false);
            sap.ui.getCore().byId('eventMapping-event').setVisible(true);
        }

        this.handleSubledgerMapChange();
    },

    handleSubledgerMapChange: function() {
        if ((sap.ui.getCore().byId("eventMapping-input").getValueState() === sap.ui.core.ValueState.None) &&
            (sap.ui.getCore().byId("eventMapping-num").getValueState() === sap.ui.core.ValueState.None)) {
            sap.ui.getCore().byId("EventSubledgerMapDialog.OkButton").setEnabled(true);
        } else {
            sap.ui.getCore().byId("EventSubledgerMapDialog.OkButton").setEnabled(false);
        }
    },

    onAccountHierarchySelect: function () {
        var view = this.getView();
        var existingDialog = sap.ui.getCore().byId("sas.stress.config.view.HierarchyPropertiesDialog");
        if (existingDialog) {
            existingDialog.destroy();
        }

        var selectedItem =view.accountHierarchySelect.getSelectedItem();
        var dimKey = selectedItem.getKey();

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var dialog = sap.ui.jsfragment("sas.stress.config.view.HierarchyPropertiesDialog", this);
        var dateFormat = sap.ui.core.format.DateFormat.getDateInstance({ pattern: "yyyy-MM-dd" });
        var defaultDate = dateFormat.format(new Date(), true);
        var newProjectJSON = {
            title: rb.getText("newProjectDialog.window.title"),
            name: sas.stress.wkbench.model.Project.getNewProjectName(),
            description: "",
            definitions: [],
            asOfDate: defaultDate,
            processStartDate: defaultDate,
            processNotificationType: false,
            currentIterationNo: 1,
            worksheets: [],
            dimensionKeys: []
        };
        var model = new sas.risk.common.models.RiskJSONModel(newProjectJSON);
        // dialog.setModel(model);
        dialog.open();

        // sas.stress.config.StressAPI.getDimensionAttributes().done(function (dimKey) {
        //var sortedDimensionList = _.sortBy(dimensions, "name");
        //model.setProperty("/dimensionKeys", sortedDimensionList);
        // });

    },

    subledgerEntitySelectTableRowSelectionChange: function() {
       // enable the save button

        var entityTable = sap.ui.getCore().byId("subledgerEntitySelectDialog.entityTable");
        var selectedIndex = entityTable.getSelectedIndex();

        var saveButton = sap.ui.getCore().byId("subledgerEntitySelectDialog.saveButton");
        return (selectedIndex >= 0 ? saveButton.setEnabled(true): saveButton.setEnabled(false));
    },

    subledgerEntitySelectDialogSaveButtonPress: function() {

        var dialog = sap.ui.getCore().byId("sas.stress.config.view.subledgerEntitySelectDialog");

        var parentTriggerDialog = sap.ui.getCore().byId("NewTriggerRule");
        var parentCommentDialog = sap.ui.getCore().byId("NewCommentRule");

        var entityTable = sap.ui.getCore().byId("subledgerEntitySelectDialog.entityTable");
        var selectedIndex = entityTable.getSelectedIndex();

        var selectedNodePath = entityTable.getContextByIndex(selectedIndex).getPath();
        var selectedNode = entityTable.getModel().getProperty(selectedNodePath);

        if (parentTriggerDialog.getUIArea() != undefined) {
            var entityHierarchyInput = sap.ui.getCore().byId("entityHierarchyInput");
            entityHierarchyInput.setInputProperties({'value': selectedNode.liKey});

            parentTriggerDialog.getModel().setProperty("/ruleEntityHierarchy", selectedNode);
            this.handleRuleDescriptionChange();
        }

        if (parentCommentDialog.getUIArea() != undefined) {
            var entityHierarchyInput = sap.ui.getCore().byId("entityCommentHierarchyInput");
            entityHierarchyInput.setInputProperties({'value': selectedNode.liKey});
            parentCommentDialog.getModel().setProperty("/ruleEntityHierarchy", selectedNode);
            this.handleCommentRuleDescriptionChange();
        }

        dialog.close();
    },

    entityTreeTableExpandButtonPress: function() {
        var sourceTable = sap.ui.getCore().byId("subledgerEntitySelectDialog.entityTable");

        //@@DD  Loop and expand all selections
        // var selectedNodePath = sourceTable.getContextByIndex(0).getPath();
        // var selectedNode = sourceTable.getModel().getProperty(selectedNodePath);

        for (var i = 0; i < sourceTable.getBinding("rows").getLength(); i++) {
            var nodePath = sourceTable.getContextByIndex(i).getPath();
            var selectedNode = sourceTable.getModel().getProperty(nodePath);
            var node = sourceTable.getModel().getProperty(nodePath);
            if (node.hierarchyKey === selectedNode.hierarchyKey && node.children.length > 0) {
                sourceTable.expand(i);
            }
        }

    },

    entityTreeTableCollapseButtonPress: function() {
        var sourceTable = sap.ui.getCore().byId("subledgerEntitySelectDialog.entityTable");
        if (sourceTable.getBinding("rows") !== undefined) {
            for (var i = sourceTable.getBinding("rows").getLength() - 1; i >= 0; i--) {
                sourceTable.collapse(i);
            }
        }
    },


    updateEntitySelectList: function() {
       //DD@@ add in logic to update the entity select list
        var controller = this;
        var view = this.getView();

        var existingDialog = sap.ui.getCore().byId("sas.stress.config.view.SubledgerEntitySelectDialog");
        if (existingDialog) {
            existingDialog.destroy();
        }
        // Find the entity selected in the Base Setup Tab
        var entityLiKey = view.entityHierarchySelect.getSelectedItem().getKey();

        sas.stress.config.model.Hierarchy.getSpecificHierarchyDetails(entityLiKey).done(function (hierarchy) {
            var dialog = sap.ui.jsfragment("sas.stress.config.view.SubledgerEntitySelectDialog", controller);

            var hierarchiesRootNode = {children: []};
            var hierarchyRootNode = {
                checked: false,
                enabled: true,
                hierarchyKey: hierarchy.getHierarchyKey(),
                categoryKey: hierarchy.getCategoryKey(),
                name: hierarchy.getName(),
                version: hierarchy.getVersion(),
                description: hierarchy.getDescription(),
                updatedTimestamp: hierarchy.getUpdatedTimestamp(),
                updatedByUser: hierarchy.getUpdatedByUser(),
                topLevelNames: hierarchy.getLevelNames(),
                children: [],
                readOnly: false,
                dimensionKey: hierarchy.getDimensionKey(),
                dimensionName: hierarchy.getDimensionName(),
                defaultHierarchy: hierarchy.getDefaultHierarchy()
            };
            hierarchiesRootNode.children.push(hierarchyRootNode);
            _.each(hierarchy.getLineItems(), function (lineItem) {
                controller._addToTreeNode(hierarchyRootNode, lineItem);
            });

            controller._sortHierarchies(hierarchiesRootNode);
            var hierarchiesModel = new sas.risk.common.models.RiskJSONModel(hierarchiesRootNode);
            dialog.setModel(hierarchiesModel);

            dialog.open();
        }).fail(function(jqxhr){
            sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
        });
    },

    _sortHierarchies: function (hierarchiesRootNode) {
        //Sort by Hierarchy name ascending
        hierarchiesRootNode.children.sort(function (a, b) {
            var aName = a.name.toLowerCase();
            var bName = b.name.toLowerCase();
            return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
        });
    },

    /* Adds a branch of nodes listed in levelNames to the rootNode. */
    _addToHierarchyDetailsTable: function (rootNode, hNode, lineItem, members, globalList) {
        var curRootNode = rootNode;
        var currentNode = hNode;

        $.each(lineItem.levelNames, function (index, levelName) {
            //check if currentNode.children contains node with levelName[i].
            var node = _.find(currentNode.children, function (childNode) {
                return childNode.name === levelName;
            });
            //If not, add node with levelName[i].
            if (node === undefined) {
                node = {
                    name: levelName,
                    hierarchyKey: lineItem.getHierarchyKey(),
                    categoryKey: currentNode.categoryKey,
                    code: currentNode.code,
                    levelNum: ((lineItem.levelNum === undefined) ? -99 : lineItem.levelNum),
                    levelName: ((lineItem.levelNum === undefined) ? "" : curRootNode.levelNames[lineItem.levelNum - 1]),
                    children: [],
                    checked: false,
                    liKey: lineItem.getLiKey(),
                    enabled: true

                };
                //Check if the item is saved in the member list, if it is, set the checked value to true
                if (members !== undefined && members.length > 0) {
                    var foundMember = members.indexOf(node.liKey);
                    if (foundMember !== -1) {
                        node.checked = true;
                        //globalList.push(node.name);
                        globalList.push(node.liKey);
                    }
                }


                //set liKey and contra on the leaf node.
                //DD: commenting out below
                //if (index == lineItem.getLevelNames().length - 1) {
                //    node.liKey = lineItem.getLiKey();
                //    node.contra = lineItem.getContra();
                //    node.aggregationType = lineItem.getAggregationType();
                //    node.format = lineItem.getFormat();
                //}
                currentNode.children.push(node);
            }
            //set currentNode as the node with levelName[i] for levelName[i+1].
            currentNode = node;
        });
    },

    _getEntityHierarchies: function() {
        var that = this;
        var view = this.getView();
        var deferred = $.Deferred();
        sas.stress.config.model.Hierarchy.getHierarchyDetails().done(function (hierarchies) {
            var hierarchiesRootNode = {children: []};
            _.each(hierarchies, function (hierarchy) {
                if (hierarchy.hierarchyCode === "ENTITY") {
                    var hierarchyRootNode = {
                        hierarchyKey: hierarchy.getHierarchyKey(),
                        categoryKey: hierarchy.getCategoryKey(),
                        name: hierarchy.getName(),
                        version: hierarchy.getVersion(),
                        description: hierarchy.getDescription(),
                        updatedTimestamp: hierarchy.getUpdatedTimestamp(),
                        updatedByUser: hierarchy.getUpdatedByUser(),
                        topLevelNames: hierarchy.getLevelNames(),
                        children: [],
                        readOnly: false,
                        dimensionKey: hierarchy.getDimensionKey(),
                        dimensionName: hierarchy.getDimensionName(),
                        defaultHierarchy: hierarchy.getDefaultHierarchy()
                    };
                    hierarchiesRootNode.children.push(hierarchyRootNode);
                    // _.each(hierarchy.getLineItems(), function (lineItem) {
                    //     that._addToTreeNode(hierarchyRootNode, lineItem);
                    // });
                }
            });
            // controller._sortHierarchies(hierarchiesRootNode.children);
            var jsonModel = new sas.risk.common.models.RiskJSONModel(hierarchiesRootNode);
            //   view.hierarchiesTreeTable.setModel(jsonModel);
            //   view.hierarchiesTreeTable.bindRows("/children");
            deferred.resolve(hierarchies);
        }).fail(function (jqxhr) {
            sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
            deferred.reject();
        });
    },

    _addToTreeNode: function (rootNode, lineItem) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var aggregationTypeNone = rb.getText("hierarchiesTreeTable.column.aggregationTypeNone.txt");
        var currentNode = rootNode;
        $.each(lineItem.levelNames, function (index, levelName) {
            //check if currentNode.children contains node with levelName[i].
            var node = _.find(currentNode.children, function (childNode) {
                return childNode.name === levelName;
            });
            //If not, add node with levelName[i].
            if (node === undefined) {
                node = {
                    name: levelName,
                    hierarchyKey: lineItem.getHierarchyKey(),
                    categoryKey: currentNode.categoryKey,
                    children: [],
                    readOnly: true
                };
                //set liKey and contra on the leaf node.
                if (index === lineItem.getLevelNames().length - 1) {
                    node.liKey = lineItem.getLiKey();
                    node.contra = lineItem.getContra();
                    node.aggregationType = (lineItem.getAggregationType() === aggregationTypeNone ? "" : lineItem.getAggregationType());
                    node.format = lineItem.getFormat();
                    node.lineage = rootNode.name + " " + lineItem.levelNames.join(" ");
                    node.formula = lineItem.getFormula();
                    node.formulaCode = lineItem.getFormulaCode();
                    node.level = (rootNode.topLevelNames && lineItem.levelNum > 0 && lineItem.levelNum <= rootNode.topLevelNames.length) ? rootNode.topLevelNames[(lineItem.levelNum - 1)] : "";
                    node.workGroupNames = lineItem.getWorkGroupNames();
                    node.workGroupString = lineItem.getWorkGroupNames().join(", ");
                    //if (workGroupString && workGroupString.length > 0) {
                    //    node.workGroupString = [workGroupString, workGroupString, workGroupString].join(", ");
                    //}
                }
                currentNode.children.push(node);
            }
            //set currentNode as the node with levelName[i] for levelName[i+1].
            currentNode = node;
        });
    },

    onEntityHierarchySelect: function () {

    },

    onEventHierarchySelect: function () {
        var view = this.getView();
        var existingDialog = sap.ui.getCore().byId("sas.stress.config.view.HierarchyPropertiesDialog");
        if (existingDialog) {
            existingDialog.destroy();
        }

        var selectedItem = view.eventHierarchySelect.getSelectedItem();
        var dimKey = selectedItem.getKey();

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var dialog = sap.ui.jsfragment("sas.stress.config.view.HierarchyPropertiesDialog", this);
        var dateFormat = sap.ui.core.format.DateFormat.getDateInstance({ pattern: "yyyy-MM-dd" });
        var defaultDate = dateFormat.format(new Date(), true);
        var newProjectJSON = {
            title: rb.getText("newProjectDialog.window.title"),
            name: sas.stress.wkbench.model.Project.getNewProjectName(),
            description: "",
            definitions: [],
            asOfDate: defaultDate,
            processStartDate: defaultDate,
            processNotificationType: false,
            currentIterationNo: 1,
            worksheets: [],
            dimensionKeys: []
        };
        var model = new sas.risk.common.models.RiskJSONModel(newProjectJSON);
        // dialog.setModel(model);
        dialog.open();

        sas.stress.config.StressAPI.getDimensions().done(function (dimensions) {
            var sortedDimensionList = _.sortBy(dimensions, "name");
            model.setProperty("/dimensionKeys", sortedDimensionList);
        });



        sas.stress.config.StressAPI.loadSheetTemplates(true).done(function (worksheets) {
            var sortedDefs = _.sortBy(worksheets, "name");
            _.each(sortedDefs, function (worksheet) {
                worksheet.nameVersion =  sas.stress.wkbench.StressUtil.getNameVersion(worksheet.name, worksheet.version);
            });
            model.setProperty("/worksheets", sortedDefs);
        }).fail(function (jqxhr) {  // S1391333
            sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
        });

        sas.stress.wkbench.StressAPI.loadProcessDefinitions().done(function (definitions) {
            var sortedDefs = _.sortBy(definitions, "name");
            var rb = sas.stress.wkbench.StressUtil.getBundle();
            sortedDefs.unshift({ id: 0, name: rb.getText("none.txt") });
            model.setProperty("/definitions", sortedDefs);
        }).fail(function (jqxhr) {  // S1391333
            sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
        });

        // enable the save button if everything is filled
        // this.toggleEditProjectDialogSaveButton();
    },

    saveNewSubledgerMap: function() {
        var that = this;
        that._setDirty(true);

        // var saveBtn = sap.ui.getCore().byId("subledger.save");
        // saveBtn.setEnabled(true);

        var dialog = sap.ui.getCore().byId("EventSubledgerMapDialog");
        var table = sap.ui.getCore().byId("SubledgerTable");
        var data = {
            mappingLevel: sap.ui.getCore().byId('mappingLevelSelect').getSelectedKey(),
            levelValue: sap.ui.getCore().byId('levelValueSelect').getSelectedKey(),
            eventColumnName: sap.ui.getCore().byId('eventSelect').getSelectedItem().getText(),
            subledgerColumnName: sap.ui.getCore().byId('subledgerMapSelect').getSelectedItem().getText(),
            inputType: sap.ui.getCore().byId("eventMapping-type").getSelectedKey(),
            postingAmountFlag: sap.ui.getCore().byId("eventMapping-flag").getSelectedKey(),
        };
        if(data.inputType == 'TXT')
            data.inputText = sap.ui.getCore().byId("eventMapping-input").getValue();
        else if(data.inputType == 'NUM')
            data.inputNumber = sap.ui.getCore().byId("eventMapping-num").getValue();


        if (!that.editSubledgerDialog) {  // For the New Subledger Mapping
            var newMapping = this.model.getProperty("/subledgerData/eventMappings");
            newMapping.push(data);
            this.model.setProperty("/subledgerData/eventMappings", newMapping);
        } else {  // For Edit Subledger Mapping

            var selectedIndex = table.getSelectedIndex();

            this.model.setProperty("/subledgerData/eventMappings/" + selectedIndex, data);
            this.model.refresh();
            this.editSubledgerDialog = false;
        }

        dialog.close();

    },

    saveNewPostingGroup: function() {
        var that = this;
        that._setDirty(true);

        var idField = sap.ui.getCore().byId('PGT-dialog-id');
        var descField = sap.ui.getCore().byId('PGT-dialog-desc');
        var table = sap.ui.getCore().byId('PGT-table');

        var postings = this.model.getProperty('/postings');

        var posts = [];
        var editPosts = [];

        for(var i=0; i < postings.length; i++ ){
            if(postings[i].postingGroupId == idField.getValue()) {
                editPosts.push(postings[i]);
                postings[i].postingGroupDescription = descField.getValue();
            }
            if(!postings[i].postingGroupId.length) {
                postings[i].postingGroupId = idField.getValue();
                postings[i].postingGroupDescription = descField.getValue();
                table.setFirstVisibleRow(i);
                posts.push(postings[i]);
            }
        }

        var postingGroups = this.model.getProperty('/subledgerData/postingGroups');
        var idx = postingGroups.findIndex(function(e){
            return e.postingGroupId === idField.getValue();
        });
        if(idx > -1) {
            postingGroups[idx].postings = editPosts;
        } else {
            postingGroups.push(
                {
                    postingGroupId: idField.getValue(),
                    postingGroupDescription: descField.getValue(),
                    postings: posts
                }
            );
        }

        this.model.refresh();
        var saveBtn = sap.ui.getCore().byId("subledger.save");
        saveBtn.setEnabled(true);
        var dialog = sap.ui.getCore().byId("PGT-dialog");
        dialog.close();
    },


    saveSubledgerAccountingConfigButtonPress: function (validateOnly/*, type*/) {
        // Implement Save funtionality here...
        var view = this.getView();
        var controller = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var json = {};

        var domainId = view.getViewData().domainId;
        var subledgerId = view.getViewData().subledgerId;
        var editSubledger = view.getViewData().editSubledger;

        json = view.getModel().getData();

        json.subledgerData.version=view.getViewData().subledgerVersion;

        // var oldAcctKey = json.subledgerData.accountingHierarchy.key;
        // var oldEventKey = json.subledgerData.eventHierarchy.key;
        // var oldEntityKey = json.subledgerData.entityHierarchy.key;

        json.subledgerData.accountingHierarchy =
            {"name": (view.accountHierarchySelect.getSelectedItem() !== null) ? view.accountHierarchySelect.getSelectedItem().getText() : null,
            "id": (view.accountHierarchySelect.getSelectedItem() !== null) ? view.accountHierarchySelect.getSelectedItem().getKey() : null,
            "key":(view.accountHierarchySelect.getSelectedItem() !== null) ? view.accountHierarchySelect.getSelectedItem().getKey() : null};

        json.subledgerData.eventHierarchy =
            {"name": (view.eventHierarchySelect.getSelectedItem() !== null) ? view.eventHierarchySelect.getSelectedItem().getText() : null,
            "id": (view.eventHierarchySelect.getSelectedItem() !== null) ? view.eventHierarchySelect.getSelectedItem().getKey() : null,
            "key": (view.eventHierarchySelect.getSelectedItem() !== null) ? view.eventHierarchySelect.getSelectedItem().getKey() :null};

        json.subledgerData.entityHierarchy =
            {"name": (view.entityHierarchySelect.getSelectedItem() !== null) ? view.entityHierarchySelect.getSelectedItem().getText() : null,
            "id": (view.entityHierarchySelect.getSelectedItem() !== null) ? view.entityHierarchySelect.getSelectedItem().getKey() : null,
            "key": (view.entityHierarchySelect.getSelectedItem() !== null) ? view.entityHierarchySelect.getSelectedItem().getKey() : null};

        //If validating only, no need to save, just validate the subledger without saving

        if (validateOnly === true) {
            sas.stress.config.StressAPI.validateSubledger(domainId, json.subledgerData).done(function () {
            }).fail(function (jqxhr) {
                controller._setDirty(false);
                // if (type === "Acct") {
                //     var acctSelect = sap.ui.getCore().byId("subledgerAccounting.accountHierarchySelect");
                //     acctSelect.setSelectedKey(oldAcctKey);
                // } else if (type === "Event") {
                //     var eventSelect = sap.ui.getCore().byId("subledgerAccounting.eventHierarchySelect");
                //     eventSelect.setSelectedKey(oldEventKey);
                // } else if (type === "Entity") {
                //     var entitySelect = sap.ui.getCore().byId("subledgerAccounting.entityHierarchySelect");
                //     entitySelect.setSelectedKey(oldEntityKey);
                // }
                sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
            });
        } else {
            // Save the SubLedger
            //If Editing an existing Slam Configuration
            if (editSubledger === 1) {
                sas.stress.config.StressAPI.editSubledger(domainId, subledgerId, json.subledgerData).done(function () {
                    controller._setDirty(false);
                    sap.m.MessageToast.show(rb.getText("save.subledger.successful.msg.txt"), {at: sap.ui.core.Popup.Dock.CenterTop});
                    // Dont close out this window;
                    //    sas.eventBus.publish(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_SLAM_CONFIG_MGR, {});
                }).fail(function (jqxhr) {
                    sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
                });
            } else {
                sas.stress.config.StressAPI.createSubledger(domainId, json.subledgerData).done(function () {
                    controller._setDirty(false);
                    sap.m.MessageToast.show(rb.getText("save.subledger.successful.msg.txt"), {at: sap.ui.core.Popup.Dock.CenterTop});
                    //dont close out this window
                    //sas.eventBus.publish(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_SLAM_CONFIG_MGR, {});
                }).fail(function (jqxhr) {
                    sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
                });
            }
        }


    },

    handleHierarchyPropertiesSaveButtonPress: function () {

    },

    propertiesTableRowSelectionChange: function (event) {
        var view = this.getView();
        var selectedIndicesCnt = view.table.getSelectedIndices().length;
        var rb = sas.stress.wkbench.StressUtil.getBundle();
        var project;

        if (selectedIndicesCnt !== 0) {
            var context = view.table.getContextByIndex(view.table.getSelectedIndices()[0]);
            project = context.getObject();

            view.lockProjectMenu.setText((!project.isLocked()) ?
                rb.getText("lockProjectDialog.lock.window.title") : rb.getText("lockProjectDialog.unlock.window.title"));

        }

        view.editProjectButton.setEnabled(selectedIndicesCnt === 1 &&
            this.capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.PROJECT.UPDATE)/* &&
            project && !project.isLocked()*/);
        view.projectAccessControlsMenu.setEnabled(selectedIndicesCnt === 1 &&
            this.capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.PROJECT.UPDATE) &&
            project && !project.isLocked());
        view.openProjectMenu.setEnabled(selectedIndicesCnt === 1 &&
            this.capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.PROJECT.READ));
        view.deleteProjectButton.setEnabled(selectedIndicesCnt >= 1 &&
            this.capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.PROJECT.DELETE) &&
            project && !project.isLocked());
        view.lockProjectMenu.setEnabled(selectedIndicesCnt === 1 &&
            this.capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.PROJECT.LOCK));
    },

    _validatePGT: function() {
        var that = this;
        var view = this.getView();
        var dialog = sap.ui.getCore().byId('PGT-dialog');
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var table = sap.ui.getCore().byId('PGT-table');
        var idField = sap.ui.getCore().byId('PGT-dialog-id');
        var descField = sap.ui.getCore().byId('PGT-dialog-desc');
        var matchFound=false;

        var exist = _.find(that.model.getProperty('/subledgerData/postingGroups'), function (postingGroup) {
            if (postingGroup.postingGroupId.toLowerCase() === idField.getValue().toLowerCase() ) {
                matchFound=true;
                idField.setValueStateText(rb.getText("subledgerAccountingManagerDialog.error.PostingGroupNameAlreadyInUse.txt"));
                idField.setValueState(sap.ui.core.ValueState.Error);
                dialog.getBeginButton().setEnabled(false);
            }
        });

        if (!matchFound && idField.getValue() && descField.getValue()) {
            //Name is good.
            idField.setValueStateText("");
            idField.setValueState(sap.ui.core.ValueState.None);
            dialog.getBeginButton().setEnabled(true);
        }
        if (!idField.getValue() || !descField.getValue()) {
            dialog.getBeginButton().setEnabled(false);
        }
    },

    _validatePGTDialog: function() {
        var idField = sap.ui.getCore().byId('PGT-dialog-id');
        var descField = sap.ui.getCore().byId('PGT-dialog-desc');
        var dialog = sap.ui.getCore().byId('PGT-dialog');

        if(!idField.getValue() || !descField.getValue()) {
            dialog.getBeginButton().setEnabled(false);
        } else {
            if ((idField.getValueState() === sap.ui.core.ValueState.None) && (descField.getValueState() === sap.ui.core.ValueState.None)) {
              dialog.getBeginButton().setEnabled(true);
            }
        }
    },

    addPostingGroup: function(selectedRow) {
        var dialog = sap.ui.getCore().byId('PGT-dialog');
        var table = sap.ui.getCore().byId('editPostingGroupTable');
        var postings = JSON.parse(JSON.stringify(this.model.getProperty('/postings'))); // deep copy

        var idField = sap.ui.getCore().byId('PGT-dialog-id');
        var descField = sap.ui.getCore().byId('PGT-dialog-desc');

        var data = {
            postingGroupId: selectedRow.postingGroupId,
            postingGroupDescription: selectedRow.postingGroupDescription,
            type: selectedRow.type,
            mappedColumnName: 'POSTING_AMT'
        };

        var postingGroups = JSON.parse(JSON.stringify(this.model.getProperty('/subledgerData/postingGroups')));
        var idx = postingGroups.findIndex(function(e){
            return e.postingGroupId === selectedRow.postingGroupId;
        });
        if(idx > -1) {
            postingGroups[idx].postings.push(data);
        }
        for(var i = postings.length - 1; i >= 0; i--) {
            if(postings[i].postingGroupId == data.postingGroupId) {
                if(i < postings.length - 1)
                    postings.splice(i+1, 0, data);
                else
                    postings.push(data);
                break;
            }
        }
        this.model.setProperty('/postings', postings);
        this.model.setProperty('/subledgerData/postingGroups', postingGroups);
        this.model.refresh();
    },

    deletePostingGroup: function() {
        var table = sap.ui.getCore().byId('editPostingGroupTable');
        var selectedPaths = table.getSelectedContextPaths();
        var postings = this.model.getProperty('/postings');
        var that = this;

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var idField = sap.ui.getCore().byId('PGT-dialog-id');

        sas.hc.m.MessageDialog.warning({
            text: rb.getText("createSubledgerAccounting.deletePostingEntry.text"),
            title: rb.getText("createSubledgerAccounting.deletePostingEntry.title"),
            buttonActions: [sas.hc.m.MessageDialogAction.Delete, sas.hc.m.MessageDialogAction.Cancel],
            buttonPress: function (event) {
                var action = event.getParameter("origin").getProperty("messageDialogAction");
                if (action === sas.hc.m.MessageDialogAction.Delete) {
                    var postingGroups = that.model.getProperty('/subledgerData/postingGroups');

                    var pid = that.model.getProperty(selectedPaths[0]).postingGroupId;

                    var idx = postingGroups.findIndex(function (e) {
                        return e.postingGroupId === pid;
                    });
                    if(idx < 0) {
                        idx = postingGroups.length - 1;
                    }
                    selectedPaths.forEach(function (e) {
                        postings = postings.filter(function (post) {
                            return post !== that.model.getProperty(e);
                        });
                        postingGroups[idx].postings = postingGroups[idx].postings.filter(function (post) {
                            return post !== that.model.getProperty(e);
                        });
                    });

                    that.model.setProperty('/postings', postings);
                    that.model.setProperty('/subledgerData/postingGroups', postingGroups);
                    that.model.refresh();
                }
            }
        });



    },

    deletePosting: function() {
        var that = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        sas.hc.m.MessageDialog.warning({
            text: rb.getText("createSubledgerAccounting.deletePostingGroup.text"),
            title: rb.getText("createSubledgerAccounting.deletePostingGroup.title"),
            buttonActions: [sas.hc.m.MessageDialogAction.Delete, sas.hc.m.MessageDialogAction.Cancel],
            buttonPress: function (event) {
                var action = event.getParameter("origin").getProperty("messageDialogAction");
                if (action === sas.hc.m.MessageDialogAction.Delete) {
                    var table = sap.ui.getCore().byId('PGT-table');
                    var postings = that.model.getProperty('/postings');
                    var postingGroups = that.model.getProperty('/subledgerData/postingGroups');
                    var idx = table.getSelectedIndex();
                    var indices = table.getSelectedIndices();
                    var newPostings;

                    if(indices.length == postings.length) { // if select all
                        newPostings = [];
                        postingGroups = [];
                    } else {
                        newPostings = postings.filter(function (post) {
                            return post.postingGroupId !== postings[idx].postingGroupId;
                        });
                        postingGroups = postingGroups.filter(function (group) {
                            return group.postingGroupId !== postings[idx].postingGroupId;
                        });
                    }

                    that.model.setProperty('/postings', newPostings);
                    that.model.setProperty('/subledgerData/postingGroups', postingGroups);
                    that.model.refresh();

                    if(!newPostings.length) {
                        sap.ui.getCore().byId('PGT-delete').setEnabled(false);
                        sap.ui.getCore().byId('PGT-edit').setEnabled(false);
                    }
                    table.removeSelectionInterval(0, table.getRows().length-1);
                    that._setDirty(true);
                }
            }
        });
    },
    newPosting: function() {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var postings = [
            {
                postingGroupDescription: '',
                postingGroupId: '',
                type: rb.getText("createSubledgerAccounting.debit.label"),
                mappedColumnName: 'POSTING_AMT'
            },
            {
                postingGroupDescription: '',
                postingGroupId: '',
                type: rb.getText("createSubledgerAccounting.credit.label"),
                mappedColumnName: 'POSTING_AMT'
            }
        ];

        this.existingPostingGroups = JSON.parse(JSON.stringify(this.model.getProperty('/subledgerData/postingGroups')));
        this.existingPostings = JSON.parse(JSON.stringify(this.model.getProperty('/postings')));

        var newPostings = this.model.getProperty('/postings').concat(postings);

        this.model.setProperty('/postings', newPostings);
        this.model.refresh();
        var dialog = this.getView()._createPostingGroupDialog(postings[0]);
        dialog.setTitle(rb.getText("createSubledgerAccounting.newPostingGroup.label"));
        sap.ui.getCore().byId('PGT-dialog-id').setEnabled(true);
        sap.ui.getCore().byId('PGT-dialog-id').setValueState(sap.ui.core.ValueState.None);
        sap.ui.getCore().byId('PGT-dialog-desc').setEnabled(true);
        sap.ui.getCore().byId('PGT-dialog-desc').setValueState(sap.ui.core.ValueState.None);
        dialog.getBeginButton().setEnabled(false);

        dialog.open();
    },
    editPosting: function() {
        var table = sap.ui.getCore().byId('PGT-table');
        var rows = this.model.getProperty('/postings');
        var selectedRow = rows[table.getSelectedIndex()];

        table.removeSelectionInterval(0, rows.length-1);

        this.existingPostings = JSON.parse(JSON.stringify(rows));
        this.existingPostingGroups = JSON.parse(JSON.stringify(this.model.getProperty('/subledgerData/postingGroups')));

        var dialog = this.getView()._createPostingGroupDialog(selectedRow);
        dialog.open();
    },

    _onPGTSelect: function(event) {
        var editBtn = sap.ui.getCore().byId('PGT-edit');
        var delBtn = sap.ui.getCore().byId('PGT-delete');
        var table = sap.ui.getCore().byId('PGT-table');
        var rows = table.getBinding('rows').getContexts();
        var idx = event.getParameter('rowIndex');
        var selected = table.getSelectedIndices();


        if(event.getParameter('selectAll')) {
            editBtn.setEnabled(false);
            delBtn.setEnabled(true);
            return;
        }

        if(rows.length - 1 == selected.length) {
            editBtn.setEnabled(false);
            delBtn.setEnabled(false);
            table.removeSelectionInterval(0, rows.length - 1);
            return;
        }

        var from = -1
        var to = -1;

        try {
            for (var i = 0; i < rows.length; i++) {
                if (this.model.getProperty(rows[i].getPath()).postingGroupId
                    == this.model.getProperty(rows[idx].getPath()).postingGroupId) {
                    if (from < 0) {
                        from = i;
                    } else {
                        to = i;
                    }
                }
            }
        } catch(e) {
            console.log(e);
            // Ignoring rogue selection events
        }

        //console.log(selected.length);

        if(!selected.length) {
            editBtn.setEnabled(false);
            delBtn.setEnabled(false);
        } else if (table.getSelectedIndex() == idx) {
            table.setSelectionInterval(from, to);
            editBtn.setEnabled(true);
            delBtn.setEnabled(true);
        } else if(!table.getSelectedIndices().includes(idx)) { // deselected
            table.removeSelectionInterval(from, to);
            editBtn.setEnabled(true);
            delBtn.setEnabled(true);
        }

    },

    _onPGTMultiSelect: function(event) {
        var del = sap.ui.getCore().byId('PGT-dialog-delete');
        var table = sap.ui.getCore().byId('editPostingGroupTable');
        var rows = table.getItems();
        var selectedItems = table.getSelectedItems();

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        if(!selectedItems.length || rows.length - selectedItems.length < 2) {
            del.setEnabled(false);
            return;
        }

        var uncheckedRows = rows.filter(function(e){
            return !selectedItems.includes(e);
        });

        var enabled = uncheckedRows.some(function(e) {
            var context = e.getBindingContext();
            return context.getProperty(null,context).type == rb.getText("createSubledgerAccounting.credit.label");
        })
        && uncheckedRows.some(function(e) {
            var context = e.getBindingContext();
            return context.getProperty(null,context).type == rb.getText("createSubledgerAccounting.debit.label");
        });
        del.setEnabled(enabled);
    },

    _PGTSelectChange: function(selectedRow) {
        var that = this;
        var view = this.getView();
        this.model.refresh();
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var btn = sap.ui.getCore().byId('PGT-dialog').getBeginButton();
        var postings = this.model.getProperty('/postings');

        var posts = postings.filter(function(e) {
            return e.postingGroupId === selectedRow.postingGroupId
        });
        var flag =
            !posts.some(function(e) { return !e.mappedColumnName.length }) &&
            posts.some(function(e) { return e.type === rb.getText("createSubledgerAccounting.credit.label") }) &&
            posts.some(function(e) { return e.type === rb.getText("createSubledgerAccounting.debit.label") });

        this._validatePGTDialog();

        if(!flag) {
            btn.setEnabled(false);
        }
    },

    triggerOkButtonPress: function(event) {
        var that = this;
        var controller = this.getView();

        that._setDirty(true);
        // var saveBtn = sap.ui.getCore().byId("subledger.save");
        //
        // saveBtn.setEnabled(true);


        var dialog = sap.ui.getCore().byId("NewTriggerRule");
        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");

       // var entityObject = {};
       // entityObject = dialog.getModel().getProperty("/entityHierarchy");
       // entityObject.name = controller.entityHierarchyInput.getInputProperties().value;
       // entityObject.hierarchyName = controller.entityHierarchyInput.getInputProperties().value;
        var noOfRows= triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules.length;

        var data = {
            ruleOrder: noOfRows+1,
            ruleName: controller.ruleNameInput.getValue(),
            //entityHierarchy: entityObject,
            // entityHierarchy: {
            //     hierarchyKey: controller.entityHierarchyInput.getSelectedItem().getKey(),
            //     hierarchyName: controller.entityHierarchyInput.getSelectedItem().getText(),
            //     name: controller.entityHierarchyInput.getSelectedItem().getText()
            // },
            mappingLevel: controller.mappingInput.getSelectedItem().getKey(),
            levelValue: (controller.levelValueInput.getSelectedItem() === null) ? "":controller.levelValueInput.getSelectedItem().getText(), //@@DD
            postingGroupId: controller.postingGroupInput.getSelectedItem().getText(),
            ruleDescription: controller.ruleDescriptionInput.getValue(),
            entityLiKey: controller.entityHierarchyInput.getInputProperties().value,
            // eventType: controller.ruleLevel.getSelectedItem().getText(),
            ruleExpression: controller.expressionInput.getValue(),
            ruleLevel: controller.ruleLevelInput.getValue(),
        };

        if (!that.editTriggerRuleDialog) {  // For the New Trigger Rule
            var newTrigger = this.model.getProperty("/subledgerData/postingTriggerRules");
            newTrigger.push(data);
            this.model.setProperty("/subledgerData/postingTriggerRules", newTrigger);
        } else if (that.editTriggerRuleDialog == true) {  // For Edit Trigger Rules
            var selectedIndex = triggerRuleTable.getSelectedIndex();
            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].ruleOrder = selectedIndex+1;
            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].ruleName = data.ruleName;
            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].ruleDescription = data.ruleDescription;

            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].entityLiKey = data.entityLiKey;

            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].mappingLevel = data.mappingLevel;
            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].levelValue = data.levelValue;
            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].postingGroupId = data.postingGroupId;
            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].ruleLevel = data.ruleLevel;
            triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[selectedIndex].ruleExpression = data.ruleExpression;

            triggerRuleTable.getModel().refresh();
            that.editTriggerRuleDialog=false;
        }

        dialog.close();
    },

    onMoveUpPressed: function (event) {
        var controller = this;

        controller._setDirty(true);

        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");

        var selectedIndex = triggerRuleTable.getSelectedIndex();

        var oModel = triggerRuleTable.getModel();
        var oData = oModel.getData();
        var temp = oData.subledgerData.postingTriggerRules[selectedIndex - 1];

        var selectedRuleOrder = oData.subledgerData.postingTriggerRules[selectedIndex].ruleOrder;

        oData.subledgerData.postingTriggerRules[selectedIndex - 1] = oData.subledgerData.postingTriggerRules[selectedIndex];

        oData.subledgerData.postingTriggerRules[selectedIndex - 1].ruleOrder=temp.ruleOrder;
        temp.ruleOrder = selectedRuleOrder;

        oData.subledgerData.postingTriggerRules[selectedIndex] = temp;
        oModel.setData(oData);

        //No need to check for outOfBound condition as the up/down button gets disabled at the boundaries and check is made there
        triggerRuleTable.setSelectedIndex(selectedIndex - 1);

    },

    onMoveDownPressed: function (event) {
        var controller = this;

        controller._setDirty(true);

        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        var selectedIndex = triggerRuleTable.getSelectedIndex();

        var oModel = triggerRuleTable.getModel();
        var oData = oModel.getData();

        var temp = oData.subledgerData.postingTriggerRules[selectedIndex + 1];
        var selectedRuleOrder = oData.subledgerData.postingTriggerRules[selectedIndex].ruleOrder;

        oData.subledgerData.postingTriggerRules[selectedIndex + 1] = oData.subledgerData.postingTriggerRules[selectedIndex];

        oData.subledgerData.postingTriggerRules[selectedIndex + 1].ruleOrder=temp.ruleOrder;
        temp.ruleOrder = selectedRuleOrder;

        oData.subledgerData.postingTriggerRules[selectedIndex] = temp;
        oModel.setData(oData);

        triggerRuleTable.setSelectedIndex(selectedIndex + 1);

    },

    filterPostingGroupLiveChange: function () {
        var view = this.getView();
        var postingGroupSearchField = sap.ui.getCore().byId("PostingGroupSearchField");
        var search = postingGroupSearchField.getValue() || "";
        var pgtTable = sap.ui.getCore().byId("PGT-table");

        var postingGroupIdFilter = new sap.ui.model.Filter("postingGroupId", sap.ui.model.FilterOperator.Contains, search);
        var postingGroupDescriptionFilter = new sap.ui.model.Filter("postingGroupDescription", sap.ui.model.FilterOperator.Contains, search);

        var searchFilter = new sap.ui.model.Filter([postingGroupIdFilter, postingGroupDescriptionFilter]);

        var binding = pgtTable.getBinding("rows");
        binding.filter(searchFilter);
    },

    filterTriggerListLiveChange: function () {
        var view = this.getView();
        var triggerSearchField = sap.ui.getCore().byId("TriggerSearchField");
        var search = triggerSearchField.getValue() || "";
        var triggerTable = sap.ui.getCore().byId("PostingTriggerRulesTable");

        var ruleNameFilter = new sap.ui.model.Filter("ruleName", sap.ui.model.FilterOperator.Contains, search);
        var ruleDescriptionFilter = new sap.ui.model.Filter("ruleDescription", sap.ui.model.FilterOperator.Contains, search);
        var mappingLevelFilter = new sap.ui.model.Filter("mappingLevel", sap.ui.model.FilterOperator.Contains, search);
        var levelValueFilter = new sap.ui.model.Filter("levelValue", sap.ui.model.FilterOperator.Contains, search);
        var entityFilter = new sap.ui.model.Filter("entityLiKey", sap.ui.model.FilterOperator.Contains, search);
        var postingGroupIdFilter = new sap.ui.model.Filter("postingGroupId", sap.ui.model.FilterOperator.Contains, search);
        var ruleLevelFilter = new sap.ui.model.Filter("ruleLevel", sap.ui.model.FilterOperator.EQ, search);

        var searchFilter = new sap.ui.model.Filter([ruleNameFilter, ruleDescriptionFilter, mappingLevelFilter, levelValueFilter, entityFilter, postingGroupIdFilter, ruleLevelFilter]);

        var binding = triggerTable.getBinding("rows");
        binding.filter(searchFilter);
    },



    onTriggerRulesTableRowSelectionChanged: function (event) {
        this._toggleEditButton();
        this._enableDeleteButton();
        this._toggleUpButton();
        this._toggleDownButton();
    },

    onEventSubledgerMapTableRowSelectionChanged: function (event) {
        sap.ui.getCore().byId('SubledgerMapTableEdit').setEnabled(true);
        sap.ui.getCore().byId('SubledgerMapTableDelete').setEnabled(true);
    },

    _toggleEditButton: function () {

        var triggerEditButton = sap.ui.getCore().byId("TriggerRulesEdit");
        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        triggerEditButton.setEnabled(false);

        var selectedItem = triggerRuleTable.getSelectedIndex();

        var length = triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules.length;

        if (length < 1)
        {
            triggerEditButton.setEnabled(false);
        } else {
            triggerEditButton.setEnabled(true);
        }
    },

    _enableDeleteButton: function () {
        var triggerDeleteButton = sap.ui.getCore().byId("TriggerRulesDelete");
        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        triggerDeleteButton.setEnabled(false);
        //triggerRuleTable.getModel().refresh();

        var selectedIndex = triggerRuleTable.getSelectedIndex();
        if (selectedIndex !== -1) {
            triggerDeleteButton.setEnabled(true);
        }
    },

    _toggleDeleteButton: function () {
        var triggerDeleteButton = sap.ui.getCore().byId("TriggerRulesDelete");
        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        var targetRootNode = triggerRuleTable.getModel().getData();

        var length = targetRootNode.subledgerData.postingTriggerRules.length;

        if (length < 1) {
            triggerDeleteButton.setEnabled(false);
        } else {
            triggerDeleteButton.setEnabled(true);
        }
    },
    onEditSubledgerDialog: function(event) {
        var view = this.getView();
        var controller = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var subledgerDialog = view._createSubledgerDialog();

        var subledgerTable = sap.ui.getCore().byId("SubledgerTable");

        var selectedIndex = subledgerTable.getSelectedIndex();

        var selectedIndexPath = subledgerTable.getContextByIndex(selectedIndex).getPath();

        var selectedItemModel = subledgerTable.getModel().getProperty(selectedIndexPath);

       // console.log(selectedItemModel);

        var itemTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{key}"
        });

        if (selectedItemModel.mappingLevel === "EventClass") {
            sap.ui.getCore().byId('levelValueSelect').bindItems("/candidateEventClasses", itemTemplate, null);
        } else if (selectedItemModel.mappingLevel === "EventType") {
            sap.ui.getCore().byId('levelValueSelect').bindItems("/candidateEventTypes", itemTemplate, null);
        }

        sap.ui.getCore().byId('mappingLevelSelect').setSelectedKey(selectedItemModel.mappingLevel);
        sap.ui.getCore().byId('levelValueSelect').setSelectedKey(selectedItemModel.levelValue);
        sap.ui.getCore().byId('eventSelect').setSelectedKey(selectedItemModel.eventColumnName);
        sap.ui.getCore().byId('subledgerMapSelect').setSelectedKey(selectedItemModel.subledgerColumnName);
        sap.ui.getCore().byId("eventMapping-input").setValue(selectedItemModel.inputText);
        sap.ui.getCore().byId("eventMapping-num").setValue(selectedItemModel.inputNumber);
        sap.ui.getCore().byId("eventMapping-type").setSelectedKey(selectedItemModel.inputType);
        sap.ui.getCore().byId("eventMapping-flag").setSelectedKey(selectedItemModel.postingAmountFlag);

        controller.editSubledgerDialog = true;

        subledgerDialog.setTitle(rb.getText("createSubledgerAccounting.editSubledgerDialog.text"));

        subledgerDialog.open();
        controller.handlePostAmountFlagChange();
        controller.handleInputTypeChange();
        controller.handleMappingLevelSelectChange();


    },

    onDeleteSubledgerDialog: function(event) {
        var view = this.getView();
        var controller = this;

        var table = sap.ui.getCore().byId("SubledgerTable");

        var targetRootNode = table.getModel().getData();

        var selectedIndex = table.getSelectedIndex();

        targetRootNode.subledgerData.eventMappings.splice(selectedIndex, 1);
        table.getModel().refresh();
        //controller._setDirty(true);

        var length = table.getModel().getData().subledgerData.eventMappings.length;

        if (selectedIndex !== 0 && selectedIndex !== (length - 1)) {
            table.setSelectedIndex(selectedIndex - 1);
        }
        if (length < 1) {
            table.setSelectedIndex(-1);
            sap.ui.getCore().byId('SubledgerMapTableDelete').setEnabled(false);
            sap.ui.getCore().byId('SubledgerMapTableEdit').setEnabled(false);
        }

        controller._setDirty(true);
    },

    onDelete: function(prop, deleteButton, editButton) {
        var table = sap.ui.getCore().byId("SubledgerTable");
        var controller = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        sas.hc.m.MessageDialog.warning({
            text: rb.getText("createSubledgerAccounting.deleteSubledgerMap.text"),
            title: rb.getText("createSubledgerAccounting.deleteSubledgerMap.title"),
            buttonActions: [sas.hc.m.MessageDialogAction.Delete, sas.hc.m.MessageDialogAction.Cancel],
            buttonPress: function (event) {
                var action = event.getParameter("origin").getProperty("messageDialogAction");
                if (action === sas.hc.m.MessageDialogAction.Delete) {
                    var targetRootNode = table.getModel().getData();

                    var selectedIndex = table.getSelectedIndex();
                    targetRootNode.subledgerData[prop].splice(selectedIndex, 1);
                    table.getModel().refresh();

                    var length = targetRootNode.subledgerData[prop].length;

                    if (selectedIndex !== 0 && selectedIndex !== (length - 1)) {
                        table.setSelectedIndex(selectedIndex - 1);
                    }
                    if (length < 1) {
                        table.setSelectedIndex(-1);
                        deleteButton.setEnabled(false);
                        editButton.setEnabled(false);
                    }
                    controller._setDirty(true);
                }
            }
        });
    },

    onEditPressed: function (event) {
        var view = this.getView();
        var controller = this;

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var triggerRuleDialog = sap.ui.getCore().byId("NewTriggerRule");
        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        var targetRootNode = triggerRuleTable.getModel().getData();

        var selectedIndex = triggerRuleTable.getSelectedIndex();

        var selectedItemModel = targetRootNode.subledgerData.postingTriggerRules[selectedIndex];

        //var jsonModel = new sas.risk.common.models.RiskJSONModel(selectedItemModel);
        //triggerRuleDialog.setModel(jsonModel);

        var itemTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{name}"
        });

        if (selectedItemModel.mappingLevel === "EventClass") {
            controller.getView().levelValueInput.bindItems("/candidateEventClasses", itemTemplate, null);
        } else if (selectedItemModel.mappingLevel === "EventType") {
            controller.getView().levelValueInput.bindItems("/candidateEventTypes", itemTemplate, null);
        }

        controller.getView().ruleNameInput.setValue(selectedItemModel.ruleName);
        controller.getView().ruleNameInput.setValueState(sap.ui.core.ValueState.None);

        controller.getView().entityHierarchyInput.setInputProperties({'value':selectedItemModel.entityLiKey});

        controller.getView().mappingInput.setSelectedKey(selectedItemModel.mappingLevel);
        controller.getView().postingGroupInput.setSelectedKey(selectedItemModel.postingGroupId);

        controller.getView().ruleDescriptionInput.setValue(selectedItemModel.ruleDescription);
        controller.getView().ruleDescriptionInput.setValueState(sap.ui.core.ValueState.None);
       // controller.getView().entityInput.setSelectedItem(selectedItemModel.entity);

        controller.getView().levelValueInput.setSelectedKey(selectedItemModel.levelValue);
        controller.getView().ruleLevelInput.setValue(selectedItemModel.ruleLevel);

        controller.getView().expressionInput.setValue(selectedItemModel.ruleExpression);
        controller.getView().expressionInput.setValueState(sap.ui.core.ValueState.None);

        controller.editTriggerRuleDialog=true;

        sap.ui.getCore().byId("NewTriggerDialog.OkButton").setEnabled(false);

        triggerRuleDialog.setTitle(rb.getText("createSubledgerAccounting.editTriggerRule.label"));

        triggerRuleDialog.open();
    },

    onDeletePressed: function (event) {
        var view = this.getView();
        var controller = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        sas.hc.m.MessageDialog.warning({
            text: rb.getText("createSubledgerAccounting.deleteTriggerRule.text"),
            title: rb.getText("createSubledgerAccounting.deleteTriggerRule.title"),
            buttonActions: [sas.hc.m.MessageDialogAction.Delete, sas.hc.m.MessageDialogAction.Cancel],
            buttonPress: function (event) {
                var action = event.getParameter("origin").getProperty("messageDialogAction");
                if (action === sas.hc.m.MessageDialogAction.Delete) {
                    var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
                    var triggerRuleUpArrow = sap.ui.getCore().byId("TriggerRulesUpArrow");

                    var targetRootNode = triggerRuleTable.getModel().getData();

                    var selectedIndex = triggerRuleTable.getSelectedIndex();

                    targetRootNode.subledgerData.postingTriggerRules.splice(selectedIndex, 1);
                    triggerRuleTable.getModel().refresh();
                    //controller._setDirty(true);

                    var length = triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules.length;

                    if (selectedIndex !== 0 && selectedIndex !== (length - 1)) {
                        triggerRuleTable.setSelectedIndex(selectedIndex - 1);
                    }
                    if (length < 1) {
                        triggerRuleTable.setSelectedIndex(-1);
                        controller._toggleDeleteButton();
                        controller._toggleEditButton();
                    }

                    // Regenerate the Rule Order numbers
                    controller._regenerateRuleOrder("triggerRules");
                    controller._setDirty(true);
                }
            }
        });



    },

    _regenerateRuleOrder: function(rules) {
        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");

        //@@DD

        if (rules === "triggerRules") {
            for (var i = 0; i < triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules.length; i++) {
                triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules[i].ruleOrder = i + 1;
            }
            triggerRuleTable.getModel().refresh();
        } else if (rules === "commentRules") {
            for (var i = 0; i < commentRuleTable.getModel().getData().subledgerData.commentRules.length; i++) {
                commentRuleTable.getModel().getData().subledgerData.commentRules[i].ruleOrder = i + 1;
            }
            commentRuleTable.getModel().refresh();
        }
    },

    _toggleUpButton: function () {

        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        var triggerRuleUpArrow = sap.ui.getCore().byId("TriggerRulesUpArrow");
        triggerRuleUpArrow.setEnabled(false);

        var selectedIndex = triggerRuleTable.getSelectedIndex();
        // Only enable it if the first item is not selected
        if (selectedIndex > 0) {
            triggerRuleUpArrow.setEnabled(true);
        }
    },
    _toggleDownButton: function () {

        var triggerRuleTable = sap.ui.getCore().byId("PostingTriggerRulesTable");
        var triggerRuleDownArrow = sap.ui.getCore().byId("TriggerRulesDownArrow");
        triggerRuleDownArrow.setEnabled(false);

        var selectedIndex = triggerRuleTable.getSelectedIndex();
        //var length = view[axis + "Table"]._getRowCount();

        var length = triggerRuleTable.getModel().getData().subledgerData.postingTriggerRules.length;

        if (selectedIndex !== -1 && selectedIndex !== (length - 1)) {
            triggerRuleDownArrow.setEnabled(true);
        }
    },

    commentOkButtonPress: function(event) {
        var that = this;
        var controller = this.getView();
        that._setDirty(true);
        // var saveBtn = sap.ui.getCore().byId("subledger.save");
        //
        // saveBtn.setEnabled(true);

        var dialog = sap.ui.getCore().byId("NewCommentRule");
        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");

        var entityObject = {};
        //entityObject = dialog.getModel().getProperty("/entityHierarchy");
        //entityObject.name = controller.entityCommentHierarchyInput.getInputProperties().value;
        //entityObject.hierarchyName = controller.entityCommentHierarchyInput.getInputProperties().value;
        var noOfRows= commentRuleTable.getModel().getData().subledgerData.commentRules.length;

        var data = {
            ruleOrder: noOfRows+1,
            ruleName: controller.ruleCommentNameInput.getValue(),
           //entityHierarchy: entityObject,
            // entityHierarchyInput: {
            //     key:controller.entityCommentHierarchyInput.getSelectedItem().getKey(),
            //     hierarchyName: controller.entityCommentHierarchyInput.getSelectedItem().getText(),
            //     name: controller.entityCommentHierarchyInput.getSelectedItem().getText()
            // },
            mappingLevel: controller.mappingCommentInput.getSelectedItem().getKey(),
            tag: controller.postingCommentTagInput.getValue(),
            ruleDescription: controller.ruleCommentDescriptionInput.getValue(),
            //entity: controller.eventCommentTypeInput.getSelectedItem().getText(),
            //entity: (entityObject == undefined) ? "": entityObject.name,
            entityLiKey: controller.entityCommentHierarchyInput.getInputProperties().value,
            levelValue: (controller.commentLevelValueInput.getSelectedItem() === null) ? "":controller.commentLevelValueInput.getSelectedItem().getText(),

            comment: controller.commentInput.getValue(),
            ruleExpression: controller.expressionCommentInput.getValue(),
            ruleLevel: controller.commentRuleLevelInput.getValue(),
        }

        if (!that.editCommentRuleDialog) {  // For the New Comment Rule
            var newComment = this.model.getProperty("/subledgerData/commentRules");
            newComment.push(data);
            this.model.setProperty("/subledgerData/commentRules", newComment);
            this.model.setProperty("/commentRulesUniqueTags", newComment);
        } else if (that.editCommentRuleDialog == true) {  // For Edit Comment Rules
            var selectedIndex = commentRuleTable.getSelectedIndex();
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].ruleOrder = selectedIndex+1;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].ruleName = data.ruleName;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].ruleDescription = data.ruleDescription;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].entityLiKey = data.entityLiKey;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].mappingLevel = data.mappingLevel;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].levelValue = data.levelValue;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].tag = data.tag;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].comment = data.comment;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].ruleLevel = data.ruleLevel;
            commentRuleTable.getModel().getData().subledgerData.commentRules[selectedIndex].ruleExpression = data.ruleExpression;

            commentRuleTable.getModel().refresh();
            that.editCommentRuleDialog=false;
        }


        // var update = this.model.getProperty("/subledgerData/commentRules");
        // update.push(data);
        // this.model.setProperty("/subledgerData/commentRules", update);
        // commentRuleTable.getModel().refresh();
        dialog.close();
    },

    onCommentMoveUpPressed: function (event) {
        var controller = this;

        controller._setDirty(true);

        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");

        var selectedIndex = commentRuleTable.getSelectedIndex();

        var oModel = commentRuleTable.getModel();
        var oData = oModel.getData();
        var temp = oData.subledgerData.commentRules[selectedIndex - 1];
        var selectedRuleOrder = oData.subledgerData.commentRules[selectedIndex].ruleOrder;

        oData.subledgerData.commentRules[selectedIndex - 1] = oData.subledgerData.commentRules[selectedIndex];

        oData.subledgerData.commentRules[selectedIndex - 1].ruleOrder=temp.ruleOrder;
        temp.ruleOrder = selectedRuleOrder;

        oData.subledgerData.commentRules[selectedIndex] = temp;
        oModel.setData(oData);

        //No need to check for outOfBound condition as the up/down button gets disabled at the boundaries and check is made there
        commentRuleTable.setSelectedIndex(selectedIndex - 1);

    },

    onCommentMoveDownPressed: function (event) {
        var controller = this;

        controller._setDirty(true);

        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
        var selectedIndex = commentRuleTable.getSelectedIndex();

        var oModel = commentRuleTable.getModel();
        var oData = oModel.getData();
        var temp = oData.subledgerData.commentRules[selectedIndex + 1];
        var selectedRuleOrder = oData.subledgerData.commentRules[selectedIndex].ruleOrder;

        oData.subledgerData.commentRules[selectedIndex + 1] = oData.subledgerData.commentRules[selectedIndex];

        oData.subledgerData.commentRules[selectedIndex + 1].ruleOrder=temp.ruleOrder;
        temp.ruleOrder = selectedRuleOrder;

        oData.subledgerData.commentRules[selectedIndex] = temp;
        oModel.setData(oData);

        commentRuleTable.setSelectedIndex(selectedIndex + 1);

    },

    filterCommentListLiveChange: function () {
        var view = this.getView();
        var commentSearchField = sap.ui.getCore().byId("CommentSearchField");
        var search = commentSearchField.getValue() || "";
        var commentTable = sap.ui.getCore().byId("CommentRulesTable");

        var ruleNameFilter = new sap.ui.model.Filter("ruleName", sap.ui.model.FilterOperator.Contains, search);
        var ruleDescriptionFilter = new sap.ui.model.Filter("ruleDescription", sap.ui.model.FilterOperator.Contains, search);
        var EntityHierarchyFilter = new sap.ui.model.Filter("mappingLevel", sap.ui.model.FilterOperator.Contains, search);
        var entityFilter = new sap.ui.model.Filter("entityLiKey", sap.ui.model.FilterOperator.Contains, search);
        var commentFilter = new sap.ui.model.Filter("comment", sap.ui.model.FilterOperator.Contains, search);
        var tagFilter = new sap.ui.model.Filter("tag", sap.ui.model.FilterOperator.Contains, search);

        var searchFilter = new sap.ui.model.Filter([ruleNameFilter, ruleDescriptionFilter, EntityHierarchyFilter, entityFilter, commentFilter, tagFilter]);

        var binding = commentTable.getBinding("rows");
        binding.filter(searchFilter);
    },

    onCommentRulesTableRowSelectionChanged: function (event) {
        this._toggleCommentEditButton();
        this._enableCommentDeleteButton();
        this._toggleCommentUpButton();
        this._toggleCommentDownButton();
    },

    _toggleCommentEditButton: function () {

        var commentEditButton = sap.ui.getCore().byId("CommentRulesEdit");
        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
        commentEditButton.setEnabled(false);

        var selectedItem = commentRuleTable.getSelectedIndex();

        var length = commentRuleTable.getModel().getData().subledgerData.commentRules.length;

        if (length < 1)
        {
            commentEditButton.setEnabled(false);
        } else {
            commentEditButton.setEnabled(true);
        }
    },

    _enableCommentDeleteButton: function () {
        var commentDeleteButton = sap.ui.getCore().byId("CommentRulesDelete");
        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
        commentDeleteButton.setEnabled(false);
        //triggerRuleTable.getModel().refresh();

        var selectedIndex = commentRuleTable.getSelectedIndex();
        if (selectedIndex !== -1) {
            commentDeleteButton.setEnabled(true);
        }
    },

    _toggleCommentDeleteButton: function () {
        var view = this.getView();
        var controller = this;

        var commentDeleteButton = sap.ui.getCore().byId("CommentRulesDelete");
        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
        var targetRootNode = commentRuleTable.getModel().getData();

        var length = targetRootNode.subledgerData.commentRules.length;

        if (length < 1) {
            commentDeleteButton.setEnabled(false);
        } else {
            commentDeleteButton.setEnabled(true);
        }
        controller._setDirty(true);
    },

    onTriggerNewPressed: function (event) {
        var view = this.getView();
        var controller = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var triggerRuleDialog = sap.ui.getCore().byId("NewTriggerRule");
        controller.editTriggerRuleDialog=false;

        controller.getView().ruleNameInput.setValue("");
        controller.getView().ruleNameInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().ruleDescriptionInput.setValue("");
        controller.getView().ruleDescriptionInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().ruleLevelInput.setValue("");
        controller.getView().expressionInput.setValue("");
        controller.getView().expressionInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().entityHierarchyInput.setInputProperties({'value': ""});

        triggerRuleDialog.setTitle(rb.getText("createSubledgerAccounting.newTriggerRule.label"));
        sap.ui.getCore().byId("NewTriggerDialog.OkButton").setEnabled(false);

        triggerRuleDialog.open();
    },

    onCommentNewPressed: function (event) {
        var view = this.getView();
        var controller = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var commentRuleDialog = sap.ui.getCore().byId("NewCommentRule");
        controller.editCommentRuleDialog=false;

        // selectedItemModel = {
        //     ruleCommentDescInput: "",
        //     ruleCommentDescriptionInput: "",
        //     commentInput: "",
        //     expressionCommentInput: ""
        // };
        //
        // var jsonModel = new sas.risk.common.models.RiskJSONModel(selectedItemModel);
        // commentRuleDialog.setModel(jsonModel);
        controller.getView().ruleCommentNameInput.setValue("");
        controller.getView().ruleCommentNameInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().ruleCommentDescriptionInput.setValue("");
        controller.getView().ruleCommentDescriptionInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().commentInput.setValue("");
        controller.getView().commentInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().commentRuleLevelInput.setValue("");
        controller.getView().expressionCommentInput.setValue("");
        controller.getView().expressionCommentInput.setValueState(sap.ui.core.ValueState.None);

        controller.getView().entityCommentHierarchyInput.setInputProperties({'value': ""});

        commentRuleDialog.setTitle(rb.getText("createSubledgerAccounting.newCommentRule.label"));
        sap.ui.getCore().byId("NewCommentDialog.OkButton").setEnabled(false);
        commentRuleDialog.open();
    },

    onCommentEditPressed: function (event) {  //DD Needs work
        var view = this.getView();
        var controller = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var commentRuleDialog = sap.ui.getCore().byId("NewCommentRule");
        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
        var targetRootNode = commentRuleTable.getModel().getData();

        var selectedIndex = commentRuleTable.getSelectedIndex();

        var selectedItemModel = targetRootNode.subledgerData.commentRules[selectedIndex];

        // var jsonModel = new sas.risk.common.models.RiskJSONModel(selectedItemModel);
        // commentRuleDialog.setModel(jsonModel);

        var itemTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{name}"
        });
        if (selectedItemModel.mappingLevel  === "Common") {
            controller.getView().commentLevelValueInput.bindItems("/emptyBind", itemTemplate, null);
        } else if (selectedItemModel.mappingLevel  === "EventClass") {
            controller.getView().commentLevelValueInput.bindItems("/candidateEventClasses", itemTemplate, null);
        } else if (selectedItemModel.mappingLevel  === "EventType") {
            controller.getView().commentLevelValueInput.bindItems("/candidateEventTypes", itemTemplate, null);
        }

        controller.getView().ruleCommentNameInput.setValue(selectedItemModel.ruleName);
        controller.getView().ruleCommentNameInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().ruleCommentDescriptionInput.setValue(selectedItemModel.ruleDescription);
        controller.getView().ruleCommentDescriptionInput.setValueState(sap.ui.core.ValueState.None);
        if (selectedItemModel.mappingLevel != undefined) {
            controller.getView().mappingCommentInput.setSelectedKey(selectedItemModel.mappingLevel);
        }
        if (selectedItemModel.levelValue != undefined) {
            controller.getView().commentLevelValueInput.setSelectedKey(selectedItemModel.levelValue);
        }
        controller.getView().postingCommentTagInput.setValue(selectedItemModel.tag);

        controller.getView().entityCommentHierarchyInput.setInputProperties({'value':selectedItemModel.entityLiKey});
        controller.getView().commentInput.setValue(selectedItemModel.comment);
        controller.getView().commentInput.setValueState(sap.ui.core.ValueState.None);
        controller.getView().expressionCommentInput.setValue(selectedItemModel.ruleExpression);
        controller.getView().expressionCommentInput.setValueState(sap.ui.core.ValueState.None);



        // controller.getView().entityCommentInput.setSelectedItem(selectedItemModel.entity);

        controller.getView().commentRuleLevelInput.setValue(selectedItemModel.ruleLevel);

        controller.editCommentRuleDialog=true;
        commentRuleDialog.setTitle(rb.getText("createSubledgerAccounting.editCommentRule.label"));
        sap.ui.getCore().byId("NewCommentDialog.OkButton").setEnabled(false);
        commentRuleDialog.open();
    },

    onCommentDeletePressed: function (event) {
        var view = this.getView();
        var controller = this;

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        sas.hc.m.MessageDialog.warning({
            text: rb.getText("createSubledgerAccounting.deleteCommentRule.text"),
            title: rb.getText("createSubledgerAccounting.deleteCommentRule.title"),
            buttonActions: [sas.hc.m.MessageDialogAction.Delete, sas.hc.m.MessageDialogAction.Cancel],
            buttonPress: function (event) {
                var action = event.getParameter("origin").getProperty("messageDialogAction");
                if (action === sas.hc.m.MessageDialogAction.Delete) {
                    var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
                    var commentRuleUpArrow = sap.ui.getCore().byId("CommentRulesUpArrow");

                    var targetRootNode = commentRuleTable.getModel().getData();

                    var selectedIndex = commentRuleTable.getSelectedIndex();

                    targetRootNode.subledgerData.commentRules.splice(selectedIndex, 1);
                    commentRuleTable.getModel().refresh();
                    //controller._setDirty(true);

                    var length = commentRuleTable.getModel().getData().subledgerData.commentRules.length;

                    if (selectedIndex !== 0 && selectedIndex !== (length - 1)) {
                        commentRuleTable.setSelectedIndex(selectedIndex - 1);
                    }

                    if (length < 1) {
                        commentRuleTable.setSelectedIndex(-1);
                        controller._toggleCommentEditButton();
                        controller._toggleCommentDeleteButton();
                    }
                    controller._regenerateRuleOrder("commentRules");
                    controller._setDirty(true);
                }
            }
        });

    },


    _toggleCommentUpButton: function () {

        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
        var commentRuleUpArrow = sap.ui.getCore().byId("CommentRulesUpArrow");
        commentRuleUpArrow.setEnabled(false);

        var selectedIndex = commentRuleTable.getSelectedIndex();
        // Only enable it if the first item is not selected
        if (selectedIndex > 0) {
            commentRuleUpArrow.setEnabled(true);
        }
    },
    _toggleCommentDownButton: function () {

        var commentRuleTable = sap.ui.getCore().byId("CommentRulesTable");
        var commentRuleDownArrow = sap.ui.getCore().byId("CommentRulesDownArrow");
        commentRuleDownArrow.setEnabled(false);

        var selectedIndex = commentRuleTable.getSelectedIndex();
        //var length = view[axis + "Table"]._getRowCount();

        var length = commentRuleTable.getModel().getData().subledgerData.commentRules.length;

        if (selectedIndex !== -1 && selectedIndex !== (length - 1)) {
            commentRuleDownArrow.setEnabled(true);
        }
    },

    cancelSubledgerAccountingConfigButtonPress: function() {
        var view = this.getView();
        if (sas.stress.wkbench.StressUtil.confirmToContinue(this.navChecker.getDirty())) {
            sas.eventBus.publish(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_SLAM_CONFIG_MGR, {});
        }
    },

    // _createExpressionBuilder: function () {
    //     try {
    //         var dataServices = new sas.risk.services.Data();
    //         Utils.setDataServices(dataServices);
    //
    //         var tables = [];//this.oData.getQueryTables();
    //         var selColumns = [];//this.oData.getSelectedColumns();
    //         var calcColumns = [];//this.oData.getCalculatedColumns();
    //
    //         var formattedFilter = "";//this.oView.getExpressionText();
    //         var filter = "";
    //         if (formattedFilter) {
    //             // replace newlines with spaces for a filter that can be executed
    //             filter = formattedFilter.replace(/[\n]/g, " ");
    //         }
    //
    //         var tableObjs = [];
    //         /*
    //         for (var t = 0; t < tables.length; t++) {
    //             var table = tables[t];
    //             var libname = table.libname;
    //             var tableName = table.member;
    //             var isReadOnly = table.data.readOnly;
    //             var tableAlias = table.alias;
    //             var tableObject = new TableObject();
    //             tableObject.setName(tableName);
    //             tableObject.setLibrary(libname);
    //             tableObject.setIsReadOnly(isReadOnly);
    //             tableObject.setTableAlias(tableAlias);
    //             var tableColumns = [];
    //
    //             var data = table.data;
    //
    //             // loop through columns in the data and add to TableObject
    //             for (var i = 0; i < data.columns.length; i++) {
    //                 tableColumns.push(data.columns[i]);
    //             }
    //             tableObject.setColumns(tableColumns);
    //
    //             tableObjs.push(tableObject);
    //
    //         }
    //         */
    //         // build the list of SelectedColumnObject"s for the selColumns that came in from the Select panel
    //         var selectedColumnObjects = [];
    //         /*
    //         if (selColumns) {
    //             for (var i = 0; i < selColumns.length; i++) {
    //                 var selCol = selColumns[i];
    //                 var selColObj = new SelectedColumnObject();
    //                 selColObj.setName(selCol.name);
    //                 selColObj.setLibname(selCol.libname);
    //                 selColObj.setMember(selCol.member);
    //                 selColObj.setTableAlias(selCol.tableAlias);
    //                 selColObj.setLabel(selCol.label);
    //                 selColObj.setFormat(selCol.format);
    //                 selColObj.setAggregate(selCol.aggregate);
    //                 selColObj.setAlias(selCol.alias);
    //                 selColObj.setSourceColumn(selCol.sourceColumn);
    //                 selectedColumnObjects.push(selColObj);
    //             }
    //         }
    //         */
    //         // build the ExpressionObject the ExpressionBuilderDialog needs
    //         var expressionObject = new ExpressionObject();
    //
    //         expressionObject.setTables(tableObjs);
    //         expressionObject.setSelectedColumns(selectedColumnObjects);
    //         expressionObject.setCalculatedColumns(calcColumns);
    //         expressionObject.setFilter(filter);
    //         expressionObject.setFormattedFilter(formattedFilter);
    //         expressionObject.setIsJoin(false);
    //         expressionObject.setTitle("New Comment Rule");
    //
    //         ExpressionBuilderDialog.show({
    //             expressionObject: expressionObject,
    //             /*
    //             dismissCallback: jQuery.proxy(function (properties) {
    //                 var ok = arguments[0];
    //                 if (ok === true) {
    //                     var expressionObj = arguments[1];
    //                     this.oData.setWhereFilter(expressionObj.getFilter());
    //                     this.oData.setWhereFormattedFilter(expressionObj.getFormattedFilter());
    //                     callback(this);
    //                 }
    //             }, this),
    //             */
    //         });
    //     } catch (e) {
    //         console.log(e);
    //     }
    // },

    addEventSubledgerMap: function () {
        var that = this;
        var data = {
            inputText: sap.ui.getCore().byId("eventMapping-text").getValue(),
            inputNumber: sap.ui.getCore().byId("eventMapping-num").getValue(),
            inputType: sap.ui.getCore().byId("eventMapping-type").getSelectedKey(),
            postingAmountFlag: sap.ui.getCore().byId("eventMapping-flag").getSelectedKey()
        };
        var update = this.model.getProperty("/subledgerData/eventMappings");
        update.push(data);
        this.model.setProperty("/subledgerData/eventMappings", update);
        console.log(data);
        //oModel.setData({firstName: sap.ui.getCore().byId("txtField").getValue()}, true);
    },

    onExit: function () {
        sas.eventBus.publish(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_SLAM_CONFIG_MGR, {});
        //S1312016: Need to make sure the router is back working after save or navigate to another page under configure without hash change
        var router = sap.ui.core.routing.Router.getRouter("router");
        if (!router._bIsInitialized) {
            router.initialize();
        }

        this.navChecker.stop();

    }
});