jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
jQuery.sap.require("sas.hc.ui.commons.verticalTab.VerticalTab");
jQuery.sap.require("sas.hc.ui.commons.verticalTab.VerticalTabBar");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutRow");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutCell");

jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.m.HelpPopup");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.hc.m.IconTabBar");
jQuery.sap.require("sas.hc.m.Select");

jQuery.sap.require("sas.risk.common.widgets.RiskToolbar");
jQuery.sap.require("sas.risk.common.widgets.RiskPage");
jQuery.sap.require("sas.risk.common.widgets.WidgetFactory");
jQuery.sap.require("sas.risk.common.layout.BarLayout");
jQuery.sap.require("sas.risk.common.layout.BarLayoutSpacer");

jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.ViewManager");

sap.ui.jsview("sas.stress.config.view.CreateSubledgerAccounting", {

    getControllerName: function () {
        return "sas.stress.config.view.CreateSubledgerAccounting";
    },

    createContent: function (controller) {
        this.setHeight("100%");

        // this.subledgerSelect = new sas.hc.m.Select({
        //     id: "subledger.subledgerSelect",
        //     change: function(oEvent) {
        //         $.proxy(controller._loadSubledgerData(
        //                 that.domainSelect.getSelectedKey(),
        //                 oEvent.getParameter("selectedItem").getKey()), controller);
        //     }
        // });
        // var itemTemplate = new sap.ui.core.Item({
        //     text: "{name}",
        //     tooltip: "{name}",
        //     key: "{key}"
        // });
        // this.subledgerSelect.bindItems("/subledgers", itemTemplate, null);
        //
        // this.domainSelect = new sas.hc.m.Select({
        //     id: "subledger.domainSelect",
        //     change: function(oEvent) {
        //         $.proxy(controller._loadSubledgers(oEvent.getParameter("selectedItem").getKey(), 0), controller);
        //     }
        // });
        // this.domainSelect.bindItems("/domains", itemTemplate, null);
        //
        // var versionTemplate = new sap.ui.core.Item({
        //     text: "{version}",
        //     tooltip: "{version}",
        //     key: "{version}"
        // });
        //
        // this.versionSelect = new sas.hc.m.Select({
        //     items: [
        //         new sap.ui.core.ListItem({
        //             text: "{/subledgerData/version}",
        //             tooltip: "{/subledgerData/version}",
        //             key: "{/subledgerData/version}"
        //         })
        //     ]
        // });

        this.tabBar = new sas.hc.m.IconTabBar({
            firstTabClosable: false,
            showOverflowPopOver: false,
            stretchContentHeight: true,
            layoutData: new sas.hc.m.FlexItemData({ growFactor: 2 }),
        });

        // new sas.hc.ui.layout.FixFlex("MainFixFlexPanel", {
        //     fixContent: this._createTopDomainPanel(controller),
        //     flexContent: this.tabBar
        // });

        this.basicSetupTab = this._createBasicSetupTab(controller);
        this.tabBar.addItem(this.basicSetupTab);

        this.subledgerPropertiesTab = this._createSubledgerPropertiesTab();
        this.tabBar.addItem(this.subledgerPropertiesTab);
        this.eventSourcesTab = this._createEventSourcesTab();
        this.tabBar.addItem(this.eventSourcesTab);
        this.eventSubledgerMapTab = this._createEventSubledgerMapTab(controller);
        this.tabBar.addItem(this.eventSubledgerMapTab);
        this.postingGroupsTab = this._createPostingGroupsTab();
        this.tabBar.addItem(this.postingGroupsTab);
        this.postingTriggerRulesTab = this._createPostingTriggerRulesTab(controller);
        this.tabBar.addItem(this.postingTriggerRulesTab);
        this.commentRulesTab = this._createCommentRulesTab(controller);
        this.tabBar.addItem(this.commentRulesTab);

        //this.tabBar.setHeight("100%");
        //this.tabBar.setExpandable(true);
        //this.tabBar.addStyleClass("slamtabbarheight");
        return sas.risk.common.widgets.WidgetFactory.buildPanel({

            //top: this.barLayout.addStyleClass("sapUiTinyMarginTop"),
            top: this._createTopDomainPanel(controller),
            content: this.tabBar
        });
    },

    _createTopDomainPanel: function(controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var domainLayout = new sas.hc.m.VBox({
            items: [
                new sas.hc.m.HBox({
                    items: [
                        new sas.hc.m.Label({ id: "subledger.domainNameHeader",
                            text: rb.getText("createSubledgerAccounting.domainName.label"),
                            design: sap.m.LabelDesign.Bold }).addStyleClass("subledgerCreateHeaderLabel"),
                        new sas.hc.m.Label({ id: "subledger.domainName",
                            text: rb.getText("createSubledgerAccounting.domainName.label"),
                            design: sap.m.LabelDesign.Standard }).addStyleClass("subledgerCreateHeaderLabelLeftTextPadding")
                    ]
                }),
                new sas.hc.m.HBox({
                    items: [
                        new sas.hc.m.Label({ id: "subledger.subledgerNameHeader",
                            text: rb.getText("createSubledgerAccounting.subledgerName.label"),
                            design: sap.m.LabelDesign.Bold }).addStyleClass("subledgerCreateHeaderLabelLeftPadding"),
                        new sas.hc.m.Label({ id: "subledger.subledgerName",
                            text: rb.getText("createSubledgerAccounting.subledgerName.label"),
                            design: sap.m.LabelDesign.Standard }).addStyleClass("subledgerCreateHeaderLabelLeftPadding")
                    ]
                }),
                new sas.hc.m.HBox({
                    items: [
                        new sas.hc.m.Label({ id: "subledger.versionHeader",
                            text: rb.getText("createSubledgerAccounting.versionName.label"),
                            design: sap.m.LabelDesign.Bold}).addStyleClass("subledgerCreateHeaderLabel"),
                        new sas.hc.m.Label({ id: "subledger.version",
                            text: rb.getText("createSubledgerAccounting.versionName.label"),
                            design: sap.m.LabelDesign.Standard}).addStyleClass("subledgerCreateHeaderLabelLeftTextPadding2")
                    ]
                })
            ]
        }).addStyleClass("subledgerCreateHeaderForm");

        this.cancelButton = new sas.hc.m.Button({
            // icon: sas.icons.HC.CANCEL,
            text: rb.getText("createSubledgerAccounting.cancel.label"),
            enabled: true,
            press: $.proxy(controller.cancelSubledgerAccountingConfigButtonPress, controller)
        });

        this.saveButton = new sas.hc.m.Button({
            // icon: sas.icons.HC.SAVE,
            id: "subledger.save",
            text: rb.getText("createSubledgerAccounting.save.label"),
            enabled: false,
            press: $.proxy(controller.saveSubledgerAccountingConfigButtonPress, controller)
        }).addStyleClass("sasPrimaryButton");

        this.barLayout = new sas.risk.common.layout.BarLayout({
            content: [
                domainLayout,
                new sas.risk.common.layout.BarLayoutSpacer,
                this.cancelButton,
                this.saveButton
            ],
            customData:[ new sap.ui.core.CustomData({key: "size", value: "6rem"})
            ]
        }).removeStyleClass("sapMTB").addStyleClass('Left');

        return this.barLayout;
    },

    _createBasicSetupTab: function(controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        this.accountHierarchySelect = new sas.hc.m.Select({
            id: "subledgerAccounting.accountHierarchySelect",
            change: $.proxy(controller.onAccountHierarchySelectChange, controller),
        }).addStyleClass('sapUiSmallMarginBottom');
        this.accountHierarchySelect.bindItems("/accountHierarchy",
            new sap.ui.core.Item({
                text: "{name}",
                tooltip: "{name}",
                key: "{id}"
            }), null);

        this.eventHierarchySelect = new sas.hc.m.Select({
            // todo: change: $.proxy(ctrl.handleExpressionSelection, ctrl)
            id: "subledgerAccounting.eventHierarchySelect",
            change: $.proxy(controller.onEventHierarchySelectChange, controller)
        }).addStyleClass('sapUiSmallMarginBottom');
        this.eventHierarchySelect.bindItems("/eventHierarchy",
            new sap.ui.core.Item({
                text: "{name}",
                tooltip: "{name}",
                key: "{id}"
            }), null);

        this.entityHierarchySelect = new sas.hc.m.Select({
            id: "subledgerAccounting.entityHierarchySelect",
            change: $.proxy(controller.onEntityHierarchySelectChange, controller)
        }).addStyleClass('sapUiSmallMarginBottom');
        this.entityHierarchySelect.bindItems("/entityHierarchy",
            new sap.ui.core.Item({
                text: "{name}",
                tooltip: "{name}",
                key: "{id}"
            }), null);

        this.subledgerDescription = new sas.hc.m.TextArea({
            autoExpandable: true,
            rows: 5,
            maxLength: 256,
            liveChange: $.proxy(controller.onDescChangeOnly, controller)
        }).bindValue("/subledgerData/description");


        var that = this;
        var layout = new sas.hc.ui.layout.VerticalLayout({
            content: [
                new sas.hc.m.Label({
                    text: rb.getText("createSubledgerAccounting.accountHierarchy.label")
                }).addStyleClass('sapUiTinyMarginBottom'),
                new sas.hc.ui.layout.HorizontalLayout({
                    content: [
                        that.accountHierarchySelect,
                        new sas.hc.m.Button({
                            icon: sas.icons.HC.EDIT,
                            press: $.proxy(controller.onAccountHierarchySelect, controller),
                            tooltip: "{i18N>subLedgerAccounting.accountHierarchySelect.tip}",
                            visible: false  // Holding off till we get to send phase of slam
                        })
                    ]
                }),
                new sas.hc.m.Label({
                    text: rb.getText("createSubledgerAccounting.eventHierarchy.label")
                }).addStyleClass('sapUiTinyMarginBottom'),
                new sas.hc.ui.layout.HorizontalLayout({
                    content: [
                        that.eventHierarchySelect,
                        new sas.hc.m.Button({
                            icon: sas.icons.HC.EDIT,
                            press: $.proxy(controller.onEventHierarchySelect, controller),
                            tooltip: "{i18N>subLedgerAccounting.accountHierarchySelect.tip}",
                            visible: false  // Holding off till we get to send phase of slam
                        })
                    ]
                }),

                new sas.hc.m.Label({
                    text: rb.getText("createSubledgerAccounting.entityHierarchy.label")
                }).addStyleClass('sapUiTinyMarginBottom'),
                new sas.hc.ui.layout.HorizontalLayout({
                    content: [
                        that.entityHierarchySelect,
                        new sas.hc.m.Button({
                            icon: sas.icons.HC.EDIT,
                            press: $.proxy(controller.onEntityHierarchySelect, controller),
                            tooltip: "{i18N>subLedgerAccounting.accountHierarchySelect.tip}",
                            visible: false  // Holding off till we get to send phase of slam
                        })
                    ]
                })
                // //DD end
                // new sas.hc.m.Label({
                //     text: rb.getText("createSubledgerAccounting.subledgerDescription.label")
                // }).addStyleClass('sapUiTinyMarginBottom'),
                // that.subledgerDescription
            ]
        });

        // var hlayout = new sas.hc.ui.layout.HorizontalLayout({
        //     content: [
        //         layout,
        //         new sas.hc.ui.layout.VerticalLayout({
        //             content:[
        //                 new sas.hc.m.Label({
        //                     text: rb.getText("createSubledgerAccounting.subledgerDescription.label")
        //                 }).addStyleClass('sapUiTinyMarginBottom'),
        //                 that.subledgerDescription
        //             ]
        //         })
        //     ]
        // });


        var hlayout = new sas.hc.m.HBox({
            items: [
                layout,
                new sas.hc.m.ToolbarSpacer({ width: "3rem" }),
                new sas.hc.m.VBox({
                    items:[
                        new sas.hc.m.Label({
                            text: rb.getText("createSubledgerAccounting.subledgerDescription.label")
                        }).addStyleClass('sapUiTinyMarginBottom'),
                        that.subledgerDescription
                    ],
                    layoutData:new sas.hc.m.FlexItemData({growFactor: 1000})
                })
            ]
        });



        var editorTab = new sas.hc.m.IconTabFilter({
            key: "basicSetup",
            text: rb.getText("createSubledgerAccounting.baseSetUp.label"),
            closable: false
        });

        editorTab.addContent(hlayout);
        return editorTab;
    },

    _createGeneralPropertiesTable: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var table = new sas.hc.ui.table.Table({
            width: '100%',
            showTableOptions: true,
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.Row,
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            noData: "{i18N>subledgerAccountingManager.subledgerAccountingTable.noData.txt}",
            toolbar: new sas.hc.m.ResponsiveToolbar({
                content: [
                    new sas.hc.m.Label({
                        text: rb.getText("createSubledgerAccounting.factTable.label")
                    }).addStyleClass('sapUiTinyMarginBottom')
                ]
            }),
            columns: [
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.SLColumnName.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{propertyValue}" }).bindProperty("text", "propertyValue"),
                    sortProperty: "propertyValue",
                    width: "50%"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.propertyValue.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{propertyName}" }).bindProperty("text", "propertyName"),
                    sortProperty: "propertyName",
                    width: "50%"
                })
            ]
        });

        table.bindRows("/subledgerData/generalProperties");

        //S1256573: Default sort by Name asc.
        var bindingInfo = table.getBindingInfo("rows");
        if (bindingInfo) {
            var sorters = [new sap.ui.model.Sorter("name", false)];
            bindingInfo.sorter = sorters;
        }
        return table;
    },

    _createEnrichmentPropertiesTable: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var table = new sas.hc.ui.table.Table({
            width: '100%',
            showTableOptions: true,
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.Row,
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            noData: "{i18N>subledgerAccountingManager.subledgerAccountingTable.noData.txt}",
            toolbar: new sas.hc.m.ResponsiveToolbar({
                content: [
                    new sas.hc.m.Label({
                        text: rb.getText("createSubledgerAccounting.EnrichmentVariables.label")
                    }).addStyleClass('sapUiTinyMarginBottom')
                ]
            }),

        });

        table.bindColumns('/subledgerData/enrichmentPropertiesColumns', function(sId, oContext){
            var col = oContext.getObject();
            var column = new sas.hc.ui.table.Column({
                label: new sas.hc.m.Label({text: col.text}),
                template: new sas.hc.m.Text({
                    tooltip: '{' + col.key +'}',
                    wrapping: false,
                    text: '{' + col.key + '}'
                }),
                width: '175px'

            });
            return column;
        });

        table.bindRows("/subledgerData/enrichmentProperties");

        //S1256573: Default sort by Name asc.
        var bindingInfo = table.getBindingInfo("rows");
        if (bindingInfo) {
            var sorters = [new sap.ui.model.Sorter("name", false)];
            bindingInfo.sorter = sorters;
        }
        return table;
    },

    _createSourceMappingTable: function (controller) {
        var table = new sas.hc.ui.table.Table({
            showTableOptions: true,
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.Row,
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            noData: "{i18N>subledgerAccountingManager.subledgerAccountingTable.noData.txt}",
            toolbar: this._createEventSourcesTableToolbar(controller),
        });
        table.bindColumns('/subledgerData/eventSourceColumns', function(sId, oContext) {
            var col = oContext.getObject();
            var column = new sas.hc.ui.table.Column({
                label: new sas.hc.m.Label({ text: col.text }),
                template: new sas.hc.m.Text({
                    tooltip: '{' + col.key + '}',
                    text: '{' + col.key + '}'
                }),
                width: '175px'
            });
            return column;
        });

        table.bindRows("/subledgerData/eventSources");

        return table;
    },

    _createEventSourcesTableToolbar: function(controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        return new sas.hc.m.ResponsiveToolbar({
            content: [
                new sas.hc.m.Label({
                    text: rb.getText("createSubledgerAccounting.sourceMapping.label")
                }).addStyleClass('sapUiTinyMarginBottom')
            ]
        });
    },

    _createSubledgerTable: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var table = new sas.hc.ui.table.Table("SubledgerTable", {
            showTableOptions: true,
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.Row,
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            rowSelectionChange: $.proxy(controller.onEventSubledgerMapTableRowSelectionChanged, controller),
            noData: "{i18N>subledgerAccountingManager.subledgerAccountingTable.noData.txt}",
            columns: [
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.mappingLevel.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{mappingLevel}" }).bindProperty("text", "mappingLevel"),
                    sortProperty: "mappingLevel"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.levelValue2.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{levelValue}" }).bindProperty("text", "levelValue"),
                    sortProperty: "levelValue"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.EventSubledgerMapSLColumnName.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{subledgerColumnName}" }).bindProperty("text", "subledgerColumnName"),
                    sortProperty: "subledgerColumnName"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.inputType.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{inputType}" }).bindProperty("text", "inputType"),
                    sortProperty: "inputType"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.eventColumnName.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{eventColumnName}" }).bindProperty("text", "eventColumnName"),
                    sortProperty: "eventColumnName"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.inputText.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{inputText}" }).bindProperty("text", "inputText"),
                    sortProperty: "inputText"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.inputNumber.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{inputNumber}" }).bindProperty("text", "inputNumber"),
                    sortProperty: "inputNumber"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.postAmountFlag.label")  }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{postingAmountFlag}" }).bindProperty("text", "postingAmountFlag"),
                    sortProperty: "postingAmountFlag"
                })
            ],
            toolbar: this._createSubledgerTableToolbar(controller)
        });

        table.bindRows("/subledgerData/eventMappings");

        //S1256573: Default sort by Name asc.
        var bindingInfo = table.getBindingInfo("rows");
        if (bindingInfo) {
            var sorters = [new sap.ui.model.Sorter("name", false)];
            bindingInfo.sorter = sorters;
        }
        return table;
    },

    _createSubledgerTableToolbar: function(controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var that = this;
        var editButton = new sas.hc.m.Button('SubledgerMapTableEdit', {
            icon: sas.icons.HC.EDIT,
            press: $.proxy(controller.onEditSubledgerDialog, controller),
            enabled: false
        });
        var deleteButton = new sas.hc.m.Button('SubledgerMapTableDelete', {
            icon: sas.icons.HC.DELETE,
            press: $.proxy(controller.onDelete, controller, "eventMappings", this, editButton),
            enabled: false
        });
        return new sas.hc.m.Toolbar({
            content: [
                new sas.hc.m.Label({
                    text: rb.getText("createSubledgerAccounting.eventMapping.label")
                }),
                new sas.risk.common.layout.BarLayoutSpacer,
                new sas.hc.m.Button({
                    icon: sas.icons.HC.NEWSTARBURST,
                    press: function() {
                        var dialog = that._createSubledgerDialog();
                        dialog.open();
                        controller.handleInputTypeChange();
                        controller.handleMappingLevelSelectChange();
                    }
                }),
                editButton,
                deleteButton,
            ]
        })
    },

    _createSubledgerDialog: function() {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var that = this;
        var controller = this.getController();

        var itemTemplate = new sap.ui.core.Item({
            text: "{item}",
            tooltip: "{item}",
            key: "{key}"
        });

        var mappingLevelSelect = new sas.hc.m.Select("mappingLevelSelect", {
            items: {
                path: '/eventSubledgerMappingLevels',
                template: itemTemplate
            },
            change: $.proxy(controller.handleMappingLevelSelectChange, controller)
        });

        var levelValueSelect = new sas.hc.m.Select("levelValueSelect", {
            items: {
                path: '/emptyBind',
                template: itemTemplate
            },
        });

        var inputText = new sas.hc.m.Input('eventMapping-input', {
            type: sap.m.InputType.Text,
            disableValidation: false,
            maxLength: 64,
            liveChange: $.proxy(controller.handleSubledgerMapChange, controller),
            change: $.proxy(controller.handleSubledgerMapChange, controller),
            required: true
        });
        var inputNumber = new sas.hc.m.Input("eventMapping-num", {
            type: sap.m.InputType.Number,
            disableValidation: false,
            maxLength: 64,
            liveChange: $.proxy(controller.handleSubledgerMapChange, controller),
            change: $.proxy(controller.handleSubledgerMapChange, controller),
            required: true
        });
        var inputType = new sas.hc.m.Select("eventMapping-type",{
            items: {
                path: '/eventMappingTypes',
                template: new sap.ui.core.Item({
                    text: '{text}',
                    tooltip: '{text}',
                    key: '{key}'
                })
            },
            change: $.proxy(controller.handleInputTypeChange, controller),
            required: true
        });
        var postAmountFlag = new sas.hc.m.Select("eventMapping-flag", {
            items: {
                path: '/postAmountFlags',
                template: new sap.ui.core.Item({
                    text: '{key}',
                    tooltip: '{key}',
                    key: '{key}'
                })
            },
            change: $.proxy(controller.handlePostAmountFlagChange, controller)
        });
        postAmountFlag.setSelectedKey('N');

        var subledgerMapSelect = new sas.hc.m.Select('subledgerMapSelect', {
            width: '300px',
            items: {
                path: '/postingFlagMappings/n/sub',
                template: new sap.ui.core.Item({
                    text: "{item}",
                    tooltip: "{item}",
                    key: "{item}"
                }),
            }
        });

        var eventSelect = new sas.hc.m.Select('eventSelect', {
            //width: "50%",
            items: {
                path: "/postingFlagMappings/n/event",
                template: new sap.ui.core.Item({
                    text: "{item}",
                    tooltip: "{item}",
                    key: "{item}"
                })
            }
        });

        var topPanel = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 1,
                columnsM: 1,
               // columnsS: 1,
                labelSpanL: 4,
                labelSpanM: 4,
                labelSpanS: 4,
            }).addStyleClass("newSubledgerMapDialog"),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer( {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.mapping.label")}),
                            fields: [mappingLevelSelect]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.levelValue.label")}),
                            fields: [levelValueSelect]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: rb.getText("createSubledgerAccounting.subledger.label"),
                            fields: [subledgerMapSelect],
                        })
                    ]
                })
            ]
        });
        var bottomPanel = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 1,
                columnsM: 1,
                labelSpanS: 4,
                labelSpanM: 4,
                labelSpanL: 4
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: rb.getText("createSubledgerAccounting.inputType2.label"),
                            fields: [inputType],
                        }),
                        new sas.hc.ui.layout.form.FormElement('eventMapping-event', {
                            label: rb.getText("createSubledgerAccounting.event.label"),
                            fields: [eventSelect],
                            visible: false
                        }),
                        new sas.hc.ui.layout.form.FormElement('eventMapping-inputText', {
                            label: rb.getText("createSubledgerAccounting.inputText2.label"),
                            fields: [inputText],
                        }),
                        new sas.hc.ui.layout.form.FormElement('eventMapping-inputNumber',{
                            label: rb.getText("createSubledgerAccounting.inputNumber2.label"),
                            fields: [inputNumber],
                            visible: false
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: rb.getText("createSubledgerAccounting.postAmountFlag2.label"),
                            fields: [postAmountFlag],
                        })
                    ]
                }),
            ]
        });

        var dialog = new sas.hc.m.Dialog("EventSubledgerMapDialog", {
            title: rb.getText("createSubledgerAccounting.newEventSubledgerMap.label"),
            //contentWidth: "50rem",
            // contentHeight: "35rem",
            content: [
                new sas.hc.ui.layout.VerticalLayout({
                    content:[
                        topPanel,
                        bottomPanel
                    ]
                })
            ],
            beginButton: new sas.hc.m.Button({
                id: "EventSubledgerMapDialog.OkButton",
                text: rb.getText("createSubledgerAccounting.ok.label"),
                enabled: false,
                press: $.proxy(controller.saveNewSubledgerMap, controller)
            }),
            endButton: new sas.hc.m.Button({
                text: rb.getText("button.cancel.action.label"),
                press: function () {
                    dialog.close();
                }
            }),
            afterClose: function() {
                topPanel.destroyFormContainers();
                topPanel.destroy();
                bottomPanel.destroyFormContainers();
                bottomPanel.destroy();
                this.destroy();
            }
        });
        dialog.setModel(this.getModel());
        return dialog;
    },

    _createPostingGroupsTable: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var table = new sas.hc.ui.table.Table({
            id: "PGT-table",
            showTableOptions: true,
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.Row,
            selectionMode: sas.hc.ui.table.SelectionMode.MultiToggle,
            noData: "{i18N>subledgerAccountingManager.subledgerAccountingTable.noData.txt}",
            toolbar: this._createPostingGroupsTableToolbar(controller),
            columns: [
                new sas.hc.ui.table.Column({
                    id: "PGpostingGroupId",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.postingGroupId.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{postingGroupId}", text: "{postingGroupId}" }),
                    sortProperty: "postingGroupId"
                }),
                new sas.hc.ui.table.Column({
                    id: "postingGroupDescription",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.postingGroupDesc.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{postingGroupDescription}", text: "{postingGroupDescription}"}),
                    sortProperty: "postingGroupDescription"
                }),
                new sas.hc.ui.table.Column({
                    id: "glAccount",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.glAccount.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{generalLedgerAccountLiKey}", text: "{generalLedgerAccountLiKey}" }),
                    sortProperty: "glAccount"
                }),
                new sas.hc.ui.table.Column({
                    id: "DCtype",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.type.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{type}", text: "{type}" }),
                    sortProperty: "type"
                }),
                new sas.hc.ui.table.Column({
                    id: "mappedColumnName",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.mappedColumnName.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{mappedColumnName}", text: "{mappedColumnName}"}),
                    sortProperty: "mappedColumnName"
                })
            ],
            rowSelectionChange: $.proxy(controller._onPGTSelect, controller)
        });

        table.bindRows("/postings");

        //S1256573: Default sort by Name asc.
        var bindingInfo = table.getBindingInfo("rows");
        if (bindingInfo) {
            var sorters = [new sap.ui.model.Sorter("name", false)];
            bindingInfo.sorter = sorters;
        }
        return table;
    },

    _createPostingGroupsTableToolbar: function (controller) {
        var table = sap.ui.getCore().byId("PGT-table");
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var that = this;
        return new sas.hc.m.ResponsiveToolbar({
            content: [
                new sas.hc.m.SearchField({
                    id: "PostingGroupSearchField",
                    liveChange: $.proxy(controller.filterPostingGroupLiveChange, controller),
                    visible: true,
                    search: $.proxy(controller.filterPostingGroupLiveChange, controller),
                    filterMode: true
                }),
                new sas.hc.m.HelpPopup("PGHelpPopup",{
                    library: "sas.stress",
                    key: "subledgerAccounting.PostingGroupSearch"
                }),
                new sas.hc.m.ToolbarSpacer(),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.NEWSTARBURST,
                    press: $.proxy(controller.newPosting, controller),
                }),
                new sas.hc.m.Button({
                    id: "PGT-edit",
                    icon: sas.icons.HC.EDIT,
                    press: $.proxy(controller.editPosting, controller),
                    enabled: false
                }),
                new sas.hc.m.Button({
                    id: "PGT-delete",
                    icon: sas.icons.HC.DELETE,
                    press: $.proxy(controller.deletePosting, controller),
                    enabled: false
                })
            ]
        });
    },

    _createTriggerRulesTable: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var table = new sas.hc.ui.table.Table({
            id: "PostingTriggerRulesTable",
            showTableOptions: true,
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.Row,
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            rowSelectionChange: $.proxy(controller.onTriggerRulesTableRowSelectionChanged, controller),
            noData: "{i18N>refineHierarchyDetailsDialog.noDataText}",
            toolbar: this._createTriggerRulesTableToolbar(controller),
            columns: [
                new sas.hc.ui.table.Column({
                    id: "entity",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.entity.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{entityLiKey}", text: "{entityLiKey}" })
                    //sortProperty: "entity"
                }),
                new sas.hc.ui.table.Column({
                    id: "MappingLevel",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.mappingLevel.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{mappingLevel}", text: "{mappingLevel}" })
                    //sortProperty: "MappingLevel"
                }),
                new sas.hc.ui.table.Column({
                    id: "LevelValue",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.levelValue2.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{levelValue}", text: "{levelValue}" })
                    //sortProperty: "levelValue"
                }),
                new sas.hc.ui.table.Column({
                    id: "ruleOrder",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleOrder.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{ruleOrder}.toString()", text: "{ruleOrder}" }),
                    visible: false
                    //sortProperty: "ruleOrder"
                }),
                new sas.hc.ui.table.Column({
                    id: "ruleName",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleName.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{ruleName}", text: "{ruleName}" })
                    //sortProperty: "ruleName"
                }),
                new sas.hc.ui.table.Column({
                    id: "ruleDescription",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleDescription.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{ruleDescription}", text: "{ruleDescription}" })
                    //sortProperty: "ruleDescription"
                }),
                new sas.hc.ui.table.Column({
                    id: "postingGroupId",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.postingGroup.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{postingGroupDescription}", text: "{postingGroupId}" })
                    //sortProperty: "postingGroupId"
                }),
                new sas.hc.ui.table.Column({
                    id: "ruleLevel",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleLevel.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, text: "{ruleLevel}"})
                    //sortProperty: "ruleLevel"
                })
            ]
        });

        table.bindRows("/subledgerData/postingTriggerRules");

        //S1256573: Default sort by Name asc.
        var bindingInfo = table.getBindingInfo("rows");
        if (bindingInfo) {
            var sorters = [new sap.ui.model.Sorter("name", false)];
            bindingInfo.sorter = sorters;
        }
        return table;
    },

    _createTriggerRulesTableToolbar:function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        return new sas.hc.m.ResponsiveToolbar({
            content: [
                // new sas.risk.common.layout.BarLayoutSpacer,
                new sas.hc.m.SearchField({
                    id: "TriggerSearchField",
                    liveChange: $.proxy(controller.filterTriggerListLiveChange, controller),
                    visible: true,
                    search: $.proxy(controller.filterTriggerListLiveChange, controller),
                    filterMode: true
                }),
                new sas.hc.m.ToolbarSpacer(),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.NEWSTARBURST,
                    press: $.proxy(controller.onTriggerNewPressed, controller),
                    // press: function() {
                    //
                    //     that.triggerRulesDialog.open();
                    // }
                }),
                new sas.hc.m.Button({
                    id: "TriggerRulesEdit",
                    icon: sas.icons.HC.EDIT,
                    press: $.proxy(controller.onEditPressed, controller),
                    enabled: false
                }),
                new sas.hc.m.Button({
                    id: "TriggerRulesDelete",
                    icon: sas.icons.HC.DELETE,
                    press: $.proxy(controller.onDeletePressed, controller),
                    enabled: false,
                }),
                new sas.hc.m.Button({
                    id: "TriggerRulesUpArrow",
                    icon: sas.icons.HC.ARROWSMALLUP,
                    press: $.proxy(controller.onMoveUpPressed, controller),
                    enabled: false,
                }),
                new sas.hc.m.Button({
                    id: "TriggerRulesDownArrow",
                    icon: sas.icons.HC.ARROWSMALLDOWN,
                    press: $.proxy(controller.onMoveDownPressed, controller),
                    enabled: false,
                })
            ]
        })
    },

    _createCommentRulesTable: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var table = new sas.hc.ui.table.Table({
            id: "CommentRulesTable",
            showTableOptions: true,
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.Row,
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            //width: "100%",
            rowSelectionChange: $.proxy(controller.onCommentRulesTableRowSelectionChanged, controller),
            noData: "{i18N>refineHierarchyDetailsDialog.noDataText}",
            toolbar: this._createCommentRulesTableToolbar(controller),
            columns: [
                new sas.hc.ui.table.Column({
                    id: "CRentity",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.entity.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{entityLiKey}", text: "{entityLiKey}" }),
                    sortProperty: "entity"
                }),
                new sas.hc.ui.table.Column({
                    id: "CRmappingLevel",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.mappingLevel.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{mappingLevel}", text: "{mappingLevel}" }),
                    sortProperty: "mappingLevel"
                }),
                new sas.hc.ui.table.Column({
                    id: "CRlevelValue",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.levelValue2.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{levelValue}", text: "{levelValue}" }),
                    sortProperty: "levelValue"
                }),
                new sas.hc.ui.table.Column({
                    id: "CRruleOrder",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleOrder.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{ruleOrder}.toString()", text: "{ruleOrder}" }),
                    sortProperty: "ruleOrder",
                    visible: false
                }),
                new sas.hc.ui.table.Column({
                    id: "CRruleName",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleName.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{ruleName}", text: "{ruleName}"}),
                    sortProperty: "ruleName"
                }),
                new sas.hc.ui.table.Column({
                    id: "CRruleDescription",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleDescription.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{ruleDescription}", text: "{ruleDescription}" }),
                    sortProperty: "ruleDescription"
                }),

                new sas.hc.ui.table.Column({
                    id: "CRcomment",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.comment.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{comment}", text: "{comment}" }),
                    sortProperty: "comment"
                }),
                new sas.hc.ui.table.Column({
                    id: "CRtag",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.tag.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, tooltip: "{tag}", text: "{tag}"}),
                    sortProperty: "tag"
                }),
                new sas.hc.ui.table.Column({
                    id: "CRruleLevel",
                    label: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.ruleLevel.label") }),
                    template: new sas.hc.m.Text({ wrapping: false, text: "{ruleLevel}"}),
                    sortProperty: "ruleLevel"
                })
            ]
        });

        table.bindRows("/subledgerData/commentRules");

        //S1256573: Default sort by Name asc.
        var bindingInfo = table.getBindingInfo("rows");
        if (bindingInfo) {
            var sorters = [new sap.ui.model.Sorter("name", false)];
            bindingInfo.sorter = sorters;
        }
        return table;
    },

    _createCommentRulesTableToolbar: function(controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        return new sas.hc.m.ResponsiveToolbar({
            content :[
                // new sas.risk.common.layout.BarLayoutSpacer,
                new sas.hc.m.SearchField({
                    id: "CommentSearchField",
                    liveChange: $.proxy(controller.filterCommentListLiveChange, controller),
                    visible: true,
                    search: $.proxy(controller.filterCommentListLiveChange, controller),
                    filterMode: true
                }),
                new sas.hc.m.ToolbarSpacer(),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.NEWSTARBURST,
                    press: $.proxy(controller.onCommentNewPressed, controller),
                    //  press: function() {
                    //      that.commentRulesDialog.open();   //DD@@
                    //  }
                }),
                new sas.hc.m.Button({
                    id: "CommentRulesEdit",
                    icon: sas.icons.HC.EDIT,
                    press: $.proxy(controller.onCommentEditPressed, controller),
                    enabled: false
                }),
                new sas.hc.m.Button({
                    id: "CommentRulesDelete",
                    icon: sas.icons.HC.DELETE,
                    press: $.proxy(controller.onCommentDeletePressed, controller),
                    enabled: false,
                }),
                new sas.hc.m.Button({
                    id: "CommentRulesUpArrow",
                    icon: sas.icons.HC.ARROWSMALLUP,
                    press: $.proxy(controller.onCommentMoveUpPressed, controller),
                    enabled: false,
                }),
                new sas.hc.m.Button({
                    id: "CommentRulesDownArrow",
                    icon: sas.icons.HC.ARROWSMALLDOWN,
                    press: $.proxy(controller.onCommentMoveDownPressed, controller),
                    enabled: false,
                })
            ]
        })
    },

    _createSubledgerPropertiesTab: function() {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var generalPropertiesTable = this._createGeneralPropertiesTable();
        var enrichmentPropertiesTable = this._createEnrichmentPropertiesTable();

        var tab = new sas.hc.m.IconTabFilter({
            key: "subledgerProperties",
            text: rb.getText("createSubledgerAccounting.subledgerProperties.label"),// todo: "{i18N>HPRisk.ComputedVariables.Editor.Tab.title.txt}",
            closable: false
        });

        var panel = new sas.hc.ui.layout.VerticalLayout({
            width: '100%',
         //   height: '100%',
            content: [
                generalPropertiesTable.addStyleClass('sapUiSmallMarginBottom'),
                enrichmentPropertiesTable
            ]
        });

        panel = new sas.hc.ui.layout.Splitter({
            contentAreas: [
                generalPropertiesTable,
                enrichmentPropertiesTable
            ],
            orientation: sap.ui.core.Orientation.Vertical,
            width: '100%',
            height: '100%'
        });

        tab.addContent(panel);
        return tab;
    },

    _createEventSourcesTab: function() {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var tab = new sas.hc.m.IconTabFilter({
            key: "eventSources",
            text: rb.getText("createSubledgerAccounting.eventSources.label"),
            closable: false,
        });

        tab.addContent(this._createSourceMappingTable());
        return tab;
    },

    _createEventSubledgerMapTab: function(controller) {
        var subledgerTable = this._createSubledgerTable(controller);

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");


        this.mappingLevel = new sas.hc.m.Select({
            items: {
                path: '/mappingLevels',
                template: new sap.ui.core.Item({
                    text: "{value}",
                    tooltip: "{value}",
                    key: "{key}"
                })
            },
            change: function(oEvent) {
                var selected = oEvent.getParameter('selectedItem').getKey();
                if(selected) {
                    subledgerTable.getBinding('rows').filter(
                        new sap.ui.model.Filter('mappingLevel', sap.ui.model.FilterOperator.EQ,
                            oEvent.getParameter('selectedItem').getKey())
                    );
                } else {
                    subledgerTable.getBinding('rows').filter([]);
                }
            }
        });

        var panel = sas.risk.common.widgets.WidgetFactory.buildPanelNoPadding({
            content: new sas.hc.ui.layout.FixFlex({
                fixContent: new sas.hc.m.VBox({
                    items: [
                            new sas.hc.ui.layout.HorizontalLayout({
                                content: [
                                    new sas.hc.m.Label({
                                        text: rb.getText("createSubledgerAccounting.mappingLevel.label")
                                    }).addStyleClass('sapUiTinyMarginBottom'),
                                    new sas.hc.m.HelpPopup({
                                        library: "sas.stress",
                                        key: "subledgerAccounting.MappingTable"
                                    }),
                                ]
                            }),
                            this.mappingLevel.addStyleClass('sapUiSmallMarginBottom')
                        ]
                    }),
                flexContent: subledgerTable
            })
        });

        var tab = new sas.hc.m.IconTabFilter({
            key: "eventSubledgerMap",
            text: rb.getText("createSubledgerAccounting.eventSubledgerMap.label"),
            closable: false
        });

        tab.addContent(panel);
        return tab;
    },

    _createPostingGroupDialogTable: function(selectedRowObject) {
        var controller = this.getController();
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var model = this.getModel();
        var paymentType = new sas.hc.m.Select({
            selectedKey: '{type}',
            items: [
                new sap.ui.core.Item({
                    text: rb.getText("createSubledgerAccounting.debit.label"),
                    tooltip: rb.getText("createSubledgerAccounting.debit.label"),
                    key: 'Debit'
                }),
                new sap.ui.core.Item({
                    text: rb.getText("createSubledgerAccounting.credit.label"),
                    tooltip: rb.getText("createSubledgerAccounting.credit.label"),
                    key: 'Credit'
                })
            ],
            change: $.proxy(controller._PGTSelectChange, controller, selectedRowObject)
        });
        var glAccountField = new sas.hc.m.Select({
            selectedKey: '{generalLedgerAccountLiKey}',
            items: {
                path: "/hierarchyLiKeys",
                template: new sap.ui.core.Item({
                    text: '{item}',
                    tooltip: '{item}',
                    key: '{item}'
                })
            }
        });
        var mappedColumnNameField = new sas.hc.m.ComboBox({
            change: $.proxy(controller._PGTSelectChange, controller, selectedRowObject),
            required: true,
            items: {
                path: "/mappedColumnNames",
                template: new sap.ui.core.Item({
                    text: "{item}",
                    tooltip: "{item}",
                    key: "{item}"
                })
            },
            value: "{mappedColumnName}"
        });
        var table = new sas.hc.m.Table('editPostingGroupTable', {
            mode: sap.m.ListMode.MultiSelect,
            includeItemInSelection: true,
            columns: [
                new sas.hc.m.Column({
                    header: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.glAccount.label") }),
                }),
                new sas.hc.m.Column({
                    header: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.type.label") }),
                }),
                new sas.hc.m.Column({
                    header: new sas.hc.m.Label({ text: rb.getText("createSubledgerAccounting.mappedColumnName.label")}),
                }),
            ],
            items: {
                path: '/postings',
                template: new sas.hc.m.ColumnListItem({
                    cells: [
                        glAccountField,
                        paymentType,
                        mappedColumnNameField,
                    ]
                }),
                filters: [
                    new sap.ui.model.Filter({
                        path: 'postingGroupId',
                        operator: sap.ui.model.FilterOperator.EQ,
                        value1: selectedRowObject.postingGroupId
                    }),
                ],
            },
            selectionChange: $.proxy(controller._onPGTMultiSelect, controller),
        });
        table.setModel(model);
        return table;
    },
    _createPostingGroupDialog: function(selectedRowObject) {
        var that = this;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var controller = this.getController();

        var table = this._createPostingGroupDialogTable(selectedRowObject);

        var model = this.getModel();

        var dialog = new sas.hc.m.Dialog('PGT-dialog', {
            title: rb.getText("createSubledgerAccounting.editPostingGroup.label"),
            content: [

                new sas.hc.ui.commons.layout.VerticalLayout({
                    content: [
                        new sas.hc.m.Text({
                            text: rb.getText("createSubledgerAccounting.postingGroupId2.label")
                        }),
                        new sas.hc.m.Input('PGT-dialog-id', {
                            enabled: false,
                            required: true,
                            maxLength: 32,
                            disableValidation: false,
                            value: selectedRowObject.postingGroupId,
                            change: $.proxy(controller._validatePGT, controller),
                            liveChange: $.proxy(controller._validatePGT, controller)
                        }).addStyleClass('sapUiSmallMarginBottom'),
                        new sas.hc.m.Text({
                            text: rb.getText("createSubledgerAccounting.postingGroupDesc2.label")
                        }),
                        new sas.hc.m.TextArea('PGT-dialog-desc',{
                            required: true,
                            value: selectedRowObject.postingGroupDescription,
                            change: $.proxy(controller._validatePGTDialog, controller),
                            liveChange: $.proxy(controller._validatePGTDialog, controller)
                        }).addStyleClass('sapUiSmallMarginBottom'),
                        new sas.risk.common.layout.BarLayout({
                            content: [
                                new sas.risk.common.layout.BarLayoutSpacer,
                                new sas.hc.m.Button({
                                    icon: sas.icons.HC.ADD,
                                    press: $.proxy(controller.addPostingGroup, controller, selectedRowObject)
                                }),
                                new sas.hc.m.Button('PGT-dialog-delete', {
                                    icon: sas.icons.HC.DELETE,
                                    press: $.proxy(controller.deletePostingGroup, controller),
                                    enabled: false
                                })
                            ]
                        }),
                        table
                    ]
                })
            ],
            beginButton: new sas.hc.m.Button({
                text: rb.getText("createSubledgerAccounting.ok.label"),
                press: $.proxy(controller.saveNewPostingGroup, controller)
            }),
            endButton: new sas.hc.m.Button({
                text: rb.getText("button.cancel.action.label"),
                press: function() {
                    dialog.close();
                    model.setProperty('/postings', controller.existingPostings);
                    model.setProperty('/subledgerData/postingGroups', controller.existingPostingGroups);

                    model.refresh();
                }
            }),
            afterClose: function () {
                table.destroy();
                this.destroy();
            }
        }).addStyleClass('createSubledgerWideDialog'); //@@DD: temporary only, to allow long GL accounts
        return dialog;
    },

    _createPostingGroupsTab: function() {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        var controller = this.getController();

        var table = this._createPostingGroupsTable(controller);
        var tab = new sas.hc.m.IconTabFilter({
            key: "postingGroups",
            text: rb.getText("createSubledgerAccounting.postingGroups.label"),
            closable: false
        });

        tab.addContent(table);
        return tab;
    },

    _createPostingTriggerRulesTab: function(controller) {

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var that = this;

        var existingDialog = sap.ui.getCore().byId("NewTriggerRule");
        if (existingDialog) {
            existingDialog.destroy();
        }

        this.editTriggerRuleDialog = false;  // To determine if you are creating a new/edit Trigger Rule

        this.triggerRulesDialog = new sas.hc.m.Dialog({
             title: rb.getText("createSubledgerAccounting.newTriggerRule.label"),
             id:  "NewTriggerRule",
            contentWidth: "45rem", // S1387014
            contentHeight: "38rem",
            content: this._createTriggerRulePanel(controller),
             beginButton: new sas.hc.m.Button({
                 id: "NewTriggerDialog.OkButton",
                 text: rb.getText("createSubledgerAccounting.ok.label"),
                 enabled: false,
                 press: $.proxy(controller.triggerOkButtonPress, controller)
             }),
             endButton: new sas.hc.m.Button({
                 text: rb.getText("button.cancel.action.label"),
                 press: function () {
                     that.triggerRulesDialog.close();
                 }
             })
            //,
             // afterClose: function () {
             //     that.triggerRulesDialog.destroy();
             // }
         });


        /*var panel = new sas.hc.ui.layout.VerticalLayout({
                content: [
                    new sas.risk.common.layout.BarLayout({
                        content: [
                           // new sas.risk.common.layout.BarLayoutSpacer,
                            new sas.hc.m.SearchField({
                                id: "TriggerSearchField",
                                liveChange: $.proxy(controller.filterTriggerListLiveChange, controller),
                                visible: true,
                                search: $.proxy(controller.filterTriggerListLiveChange, controller),
                                filterMode: true
                            }),
                            new sas.risk.common.layout.BarLayoutSpacer,
                            new sas.hc.m.Button({
                                icon: sas.icons.HC.NEWSTARBURST,
                                press: $.proxy(controller.onTriggerNewPressed, controller),
                                // press: function() {
                                //
                                //     that.triggerRulesDialog.open();
                                // }
                            }),
                            new sas.hc.m.Button({
                                id: "TriggerRulesEdit",
                                icon: sas.icons.HC.EDIT,
                                press: $.proxy(controller.onEditPressed, controller),
                                enabled: false
                            }),
                            new sas.hc.m.Button({
                                id: "TriggerRulesDelete",
                                icon: sas.icons.HC.DELETE,
                                press: $.proxy(controller.onDeletePressed, controller),
                                enabled: false,
                            }),
                            new sas.hc.m.Button({
                                id: "TriggerRulesUpArrow",
                                icon: sas.icons.HC.ARROWSMALLUP,
                                press: $.proxy(controller.onMoveUpPressed, controller),
                                enabled: false,
                            }),
                            new sas.hc.m.Button({
                                id: "TriggerRulesDownArrow",
                                icon: sas.icons.HC.ARROWSMALLDOWN,
                                press: $.proxy(controller.onMoveDownPressed, controller),
                                enabled: false,
                            })
                        ]
                    }),
                    this._createTriggerRulesTable(controller)
                ]
            });*/
        var tab = new sas.hc.m.IconTabFilter({
            key: "postingTriggerRules",
            text: rb.getText("createSubledgerAccounting.postingTriggerRules.label"),
            closable: false
        });

        tab.addContent(this._createTriggerRulesTable(controller));
        return tab;
    },

    _createTriggerRulePanel: function (controller) {
        this.setHeight("100%");
        return new sas.hc.ui.layout.FixFlex("TRMainFixFlexPanel", {
            fixContent: this._createTopPanel(controller),
            flexContent: this._createBottomPanel(controller)
        });
    },

    _createTopPanel: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var layout = new sas.hc.ui.layout.form.ResponsiveGridLayout("TriggerRuleLayout",{
            columnsL: 3,
            columnsM: 3,
            //emptySpanL: 1,
            //emptySpanM: 1,
            //emptySpanS: 1,
            labelSpanS: 12,
            labelSpanM: 12,
            labelSpanL: 12
        });
        var form = new sas.hc.ui.layout.form.Form("TriggerRuleForm", {
            layout: layout,
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer("TGFormContainer1", {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.ruleName2.label")}),
                            fields: [this._createRuleNameInput(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.ruleDescription2.label")}),
                            fields: [this._createRuleDescriptionInput(controller)]
                        })
                    ]
                }),
                new sas.hc.ui.layout.form.FormContainer("TGFormContainer3", {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            //label: new sas.hc.m.Label({text: "Entity Hierarchy:"}),
                            fields: [this._createEntityHierarchyInput(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.ruleLevel2.label")})/*.addStyleClass('subledgerRulesRuleLevelLabel')*/,
                            fields: [this._createTriggerRuleLevelInput(controller)]
                        })

                    ]
                }),

                new sas.hc.ui.layout.form.FormContainer("TGFormContainer2", {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.mapping.label")}),
                            fields: [this._createMappingInput(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.levelValue.label")}),
                            fields: [this._createLevelValueInput(controller)]
                        })
                    ]
                }),
            ]
        });

        return form;
    },

    _createBottomPanel: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        return new sas.hc.ui.layout.VerticalLayout({
            width: "100%",
            content: [
                new sas.hc.ui.layout.HorizontalLayout({
                    content: [
                        new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.expression.label")}),
                        new sas.hc.m.HelpPopup("TGHelpPopup",{
                            library: "sas.stress",
                            key: "subledgerAccounting.TriggerExpressionHelp"
                        })
                    ]
                }),
                this._createExpressionInput(controller),
                new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.postingGroup2.label")}).addStyleClass('createSubledgerLabelBorder'),
                this._createPostingGroupInput(controller)
            ],
            //width: "100%",
            //height: "100%"
        });
    },

    _createCRPanel: function (controller) {
        this.setHeight("100%");
        return new sas.hc.ui.layout.FixFlex("CRMainFixFlexPanel", {
            fixContent: this._createCRTopPanel(controller),
            flexContent: this._createCRBottomPanel(controller)
        });
    },

    _createCRTopPanel: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var layout = new sas.hc.ui.layout.form.ResponsiveGridLayout("CRLayout",{
            columnsL: 4,
            columnsM: 4,
            //emptySpanL: 1,
            //emptySpanM: 1,
            //emptySpanS: 1,
            labelSpanS: 12,
            labelSpanM: 12,
            labelSpanL: 12
        });
        var form = new sas.hc.ui.layout.form.Form("CRForm", {
            layout: layout,
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer("CRFormContainer1", {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.ruleName2.label"),
                                                       labelFor: this.ruleCommentNameInput}),
                            fields: [this._createCommentRuleNameInput(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.ruleDescription2.label"),
                                                       labelFor: this.ruleCommentDescriptionInput}),
                            fields: [this._createCommentRuleDescriptionInput(controller)]
                        })
                    ]
                }),
                new sas.hc.ui.layout.form.FormContainer("CRFormContainer3", {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            //label: new sas.hc.m.Label({text: "Entity Hierarchy:"}),
                            fields: [this._createCommentEntityHierarchyInput(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.ruleLevel2.label")}),
                            fields: [this._createCommentRuleLevelInput(controller)]
                        })
                        // new sas.hc.ui.layout.form.FormElement({
                        //    // label: new sas.hc.m.Label({text: "Entity:"}),
                        //     fields: [this._createCommentEntityInput(controller)],
                        //     visible: false
                        // })
                    ]
                }),

                new sas.hc.ui.layout.form.FormContainer("CRFormContainer2", {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.mapping.label")}),
                            fields: [this._createCommentMappingInput(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.levelValue.label")}),
                            fields: [this._createCommentLevelValueInput(controller)]
                        })
                    ]
                }),
                new sas.hc.ui.layout.form.FormContainer("CRFormContainer4", {
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.tag2.label")}),
                            fields: [this._createCommentTagInput(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.comment2.label")}),
                            fields: [this._createCommentInput(controller)]
                        })
                    ]
                })
            ]
        });

        return form;
    },
    _createCRBottomPanel: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
        return new sas.hc.ui.layout.VerticalLayout({
            width: "100%",
            content: [
                new sas.hc.ui.layout.HorizontalLayout({
                    content: [
                        new sas.hc.m.Label({text: rb.getText("createSubledgerAccounting.expression.label")}),
                        new sas.hc.m.HelpPopup("CRHelpPopup",{
                            library: "sas.stress",
                            key: "subledgerAccounting.CommentRulesExpressionHelp"
                        })
                    ]
                }),
                this._createCommentExpressionInput(controller)
            ],
            //width: "100%",
            //height: "100%"
        });
    },

    _createRuleNameInput: function (controller) {
        this.ruleNameInput = new sas.hc.m.Input({
            id: "ruleNameInput",
            value: "{/ruleName}",
            type: sap.m.InputType.Text,
            width: "95%",
            disableValidation: false,
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            maxLength: 64,
            liveChange: $.proxy(controller.handleRuleDescriptionChange, controller),
            change: $.proxy(controller.handleRuleDescriptionChange, controller),
            required: true
        });
        return this.ruleNameInput;
    },
    _createEntityHierarchyInput: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        this.entityHierarchyInput = new sas.hc.m.CompositeInput({
            id: "entityHierarchyInput",
            inputProperties: {
                label: rb.getText("subledgerAccountingManagerDialog.userSearch.label.txt"),
                labelPosition: sas.hc.m.InputLabelPosition.Top,
                type: sap.m.InputType.Text,
                editable: false,
                disableValidation: false,
                maxLength: 32,
                selectTextOnPress:false,
                validateOnBindingValueChange:false,
            },
            //attachPress: controller.updateEntitySelectList(),
            buttonProperties: {
                //icon: sas.icons.HC.ADD,
                text: rb.getText("subledgerAccountingManagerDialog.userSearch.button.txt")
            },
            customData: new sap.ui.core.CustomData({
                key: "membername",
                value: "{membername}"
            })
        })//.addStyleClass('subledgerRulesCompositeInput');

        this.entityHierarchyInput.attachPress(function(e) {
            controller.updateEntitySelectList(e);
        });

        return this.entityHierarchyInput;
    },


    _createMappingInput: function (controller) {
        this.mappingInput = new sas.hc.m.Select({
            id: "mappingInput",
        });

        var itemTemplate = new sap.ui.core.Item({
            text: "{item}",
            tooltip: "{item}",
            key: "{key}"
        });
        this.mappingInput.bindItems("/triggerMappingLevels", itemTemplate, null);
        this.mappingInput.attachChange($.proxy(controller.handleMappingInputChange, controller));
        return this.mappingInput;
    },

    _createPostingGroupInput: function (controller) {

        this.postingGroupInput = new sas.hc.m.Select({
            id: "postingGroupInput"
        });

        var itemTemplate = new sap.ui.core.Item({
            text: "{postingGroupId}",
            tooltip: "{postingGroupDescription}",
            key: "{postingGroupId}"
        });
        this.postingGroupInput.bindItems("/subledgerData/postingGroups", itemTemplate, null);
        this.postingGroupInput.attachChange($.proxy(controller.handleRuleDescriptionChange, controller));
        return this.postingGroupInput;
    },

    _createRuleDescriptionInput: function (controller) {

        this.ruleDescriptionInput = new sas.hc.m.Input({
            id: "ruleDescriptionInput",
            value: "{/ruleDescription}",
            // label: "Rule Description:",
            // labelPosition: sas.hc.m.InputLabelPosition.Top,
            type: sap.m.InputType.Text,
            width: "95%",
            disableValidation: false,
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            maxLength: 64,
            liveChange: $.proxy(controller.handleRuleDescriptionChange, controller),
            change: $.proxy(controller.handleRuleDescriptionChange, controller),
            required: true
        });
        return this.ruleDescriptionInput;
    },

    _createEntityInput: function (controller) {
        this.entityInput = new sas.hc.m.Select({
            id: "entityInput",
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            items: {
                path: "/subledgerData/postingTriggerRules",
                template: new sas.hc.ui.core.Item({
                    key: "{entityLiKey}",
                    tooltip: "{entityLiKey}",
                    text:  "{entityLiKey}"
                })
            }
        });
        this.entityInput.attachChange($.proxy(controller.handleRuleDescriptionChange, controller));
        return this.entityInput;
    },

    _createLevelValueInput: function (controller) {
        this.levelValueInput = new sas.hc.m.Select({
            id: "levelValueInput",
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            // items: {
            //     template: new sas.hc.ui.core.Item({
            //         key: "{name}",
            //         tooltip: "{name}",
            //         text: "{name}"
            //     })
            // }
        });

        var itemTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{name}"
        });

        this.levelValueInput.bindItems("/candidateEventClasses", itemTemplate, null);
        this.levelValueInput.attachChange($.proxy(controller.handleRuleDescriptionChange, controller));
        return this.levelValueInput;
    },

    _createTriggerRuleLevelInput: function (controller) {
        this.ruleLevelInput = new sas.hc.m.Input({
            id: "ruleLevelInput",
            value: "{/ruleLevel}",
            type: sap.m.InputType.Number,
            allowIntegerOnly: true
        });
        var oRangeValidator = new sas.hc.m.RangeValidationAdapter({
            minValue: 0,
            maxValue: 100,
            inclusive: false
        });
        this.ruleLevelInput.setValidator(oRangeValidator);
        this.ruleLevelInput.attachLiveChange($.proxy(controller.handleRuleDescriptionChange, controller));
        return this.ruleLevelInput;
    },

    _createExpressionInput: function (controller) {
        this.expressionInput = new sas.hc.m.TextArea({
            id: "expressionInput",
            autoExpandable: false,
            //type: sap.m.InputType.Text,
            maxLength: 5000,
            value: "{/description}",
            rows: 10,
            //width: "100",
            liveChange: $.proxy(controller.handleRuleDescriptionChange, controller),
            required: true
        });
        return this.expressionInput;
    },

    _createCommentRuleNameInput: function (controller) {
        this.ruleCommentNameInput = new sas.hc.m.Input({
            id: "ruleCommentNameInput",
            value: "{/ruleName}",
            type: sap.m.InputType.Text,
            width: "95%",
            disableValidation: false,
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            maxLength: 64,
            liveChange: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            change: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            required: true
        });
        //this.ruleCommentNameInput.bindItems("/subledgerData/commentRules", itemTemplate, null);
        return this.ruleCommentNameInput;
    },
    _createCommentEntityHierarchyInput: function (controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        this.entityCommentHierarchyInput = new sas.hc.m.CompositeInput({
            id: "entityCommentHierarchyInput",
            inputProperties: {
                label: rb.getText("subledgerAccountingManagerDialog.userSearch.label.txt"),
                labelPosition: sas.hc.m.InputLabelPosition.Top,
                type: sap.m.InputType.Text,
                editable: false,
                //value: // @@DD
                disableValidation: false,
                maxLength: 32,
                selectTextOnPress:false,
                validateOnBindingValueChange:false,
            },
            //attachPress: controller.updateEntitySelectList(),
            buttonProperties: {
                //icon: sas.icons.HC.ADD,
                text: rb.getText("subledgerAccountingManagerDialog.userSearch.button.txt")
            },
            customData: new sap.ui.core.CustomData({
                key: "membername",
                value: "{membername}"
            })

        });

        this.entityCommentHierarchyInput.attachPress(function(e) {
            controller.updateEntitySelectList(e);
        });

        return this.entityCommentHierarchyInput;


        // this.entityCommentHierarchyInput = new sas.hc.m.Select({
        //     id: "entityCommentHierarchyInput"
        // });
        // var itemTemplate = new sap.ui.core.Item({
        //     text: "{entityHierarchy/name}",
        //     tooltip: "{entityHierarchy/name}",
        //     key: "{entityHierarchy/id}"
        // });
        // this.entityCommentHierarchyInput.bindItems("/subledgerData/commentRules", itemTemplate, null);
        // //this.entityHierarchyInput.attachChange($.proxy(this.getController().worksheetCategoryChange, this.getController()));
        // return this.entityCommentHierarchyInput;
    },

    _createCommentMappingInput: function (controller) {
        this.mappingCommentInput = new sas.hc.m.Select({
            id: "mappingCommentInput",
            change: $.proxy(controller.handleCommentRuleMappingChange, controller),
        });

        var itemTemplate = new sap.ui.core.Item({
            text: "{item}",
            tooltip: "{item}",
            key: "{key}"
        });
        this.mappingCommentInput.bindItems("/commentMappingLevels", itemTemplate, null);
        return this.mappingCommentInput;
    },

    _createCommentTagInput: function (controller) {
        this.postingCommentTagInput = new sas.hc.m.ComboBox({
            id: "postingCommentTagInput",
            change: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            items: {
                path: "/commentRulesUniqueTags",
                 template: new sap.ui.core.Item({
                     text: "{tag}",
                     tooltip: "{tag}",
                     key: "{tag}"
                 })
            }
        });

        return this.postingCommentTagInput;
    },

    _createCommentRuleDescriptionInput: function (controller) {
        this.ruleCommentDescriptionInput = new sas.hc.m.Input({
            id: "ruleCommentDescriptionInput",
            value: "{/ruleDescription}",
            type: sap.m.InputType.Text,
            width: "95%",
            disableValidation: false,
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            maxLength: 64,
            liveChange: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            change: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            required: true
        });
        return this.ruleCommentDescriptionInput;
    },

    _createCommentEntityInput: function (controller) {

        this.entityCommentInput = new sas.hc.m.Select({
            id: "entityCommentInput",
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            items: {
                path: "/subledgerData/commentRules",
                template: new sas.hc.ui.core.Item({
                    key: "{entityLiKey}",
                    tooltip: "{entityLiKey}",
                    text:  "{entityLiKey}"
                })
            }
        });
        this.entityCommentInput.attachChange($.proxy(controller.handleCommentRuleDescriptionChange, controller));
        return this.entityCommentInput;
    },

    _createCommentLevelValueInput: function (controller) {

        this.commentLevelValueInput = new sas.hc.m.Select({
            id: "commentLevelValueInput",
            items: {
                path: "/subledgerData/commentRules",
                template: new sas.hc.ui.core.Item({
                    key: "{levelValue}",
                    tooltip: "{levelValue}",
                    text: "{levelValue}"
                })
            }
        });
        this.commentLevelValueInput.attachChange($.proxy(controller.handleCommentRuleDescriptionChange, controller));

        return this.commentLevelValueInput;
    },

    _createCommentInput: function (controller) {

        this.commentInput = new sas.hc.m.Input({
            id: "commentInput",
            value: "{/comment}",
            type: sap.m.InputType.Text,
            width: "100%",
            disableValidation: false,
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            maxLength: 64,
            liveChange: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            //change: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            required: true
        });
        return this.commentInput;
    },


    _createCommentExpressionInput: function (controller) {
        this.expressionCommentInput = new sas.hc.m.TextArea({
            id: "expressionCommentInput",
            autoExpandable: false,
            //type: sap.m.InputType.Text,
            maxLength: 5000,
            value: "{/description}",
            rows: 10,
            liveChange: $.proxy(controller.handleCommentRuleDescriptionChange, controller),
            required: true
        });
        return this.expressionCommentInput;
    },

    _createCommentRuleLevelInput: function (controller) {
        this.commentRuleLevelInput = new sas.hc.m.Input({
            id: "commentRuleLevelInput",
            value: "{/ruleLevel}",
            type: sap.m.InputType.Number,
            allowIntegerOnly: true
        });
        var oRangeValidator = new sas.hc.m.RangeValidationAdapter({
            minValue: 0,
            maxValue: 100,
            inclusive: false
        });
        this.commentRuleLevelInput.setValidator(oRangeValidator);
        this.commentRuleLevelInput.attachLiveChange($.proxy(controller.handleCommentRuleDescriptionChange, controller));
        return this.commentRuleLevelInput;
    },


    _createCommentRulesTab: function(controller) {
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var that = this;

        var existingDialog = sap.ui.getCore().byId("NewCommentRule");
        if (existingDialog) {
            existingDialog.destroy();
        }
        this.commentRulesDialog = new sas.hc.m.Dialog({
            title: rb.getText("createSubledgerAccounting.newCommentRule.label"),
            id:  "NewCommentRule",
            contentWidth: "60rem",
            contentHeight: "35rem",
            content: this._createCRPanel(controller),
            beginButton: new sas.hc.m.Button({
                id: "NewCommentDialog.OkButton",
                text: rb.getText("createSubledgerAccounting.ok.label"),
                enabled: false,
                press: $.proxy(controller.commentOkButtonPress, controller)
            }),
            endButton: new sas.hc.m.Button({
                text: rb.getText("button.cancel.action.label"),
                press: function () {
                    that.commentRulesDialog.close();
                }
            })
        });

        var tab = new sas.hc.m.IconTabFilter({
            key: "commentRules",
            text: rb.getText("createSubledgerAccounting.commentRules.label"),
            closable: false
        });

        tab.addContent(this._createCommentRulesTable(controller));
        return tab;
    },

    // attachClosing: function (callBack, listener) {
    //     this.attachEvent(this.getId() + "_CLOSING", callBack, listener);
    // },
    //
    //
     destroy: function () {
         sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
     }
});