jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.CheckBox");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.hc.m.Input");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.ui.layout.HorizontalLayout");
jQuery.sap.require("sas.hc.ui.layout.VerticalLayout");
jQuery.sap.require("sas.hc.ui.table.TreeTable");
jQuery.sap.require("sas.hc.ui.table.Column");

sap.ui.jsfragment("sas.stress.config.view.SubledgerEntitySelectDialog", {
    createContent: function (controller) {
        //var view = this.getView();
        // var memberList = this.getModel().getData().selectedMemberList;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");


        // var hierarchyDesc = new sas.hc.m.Label({text: rb.getText("refineHierarchyDetailsDialog.column.name.header.title")});

        var table = new sas.hc.ui.table.TreeTable({
            //visibleRowCount: 10,
            id: this.createId("subledgerEntitySelectDialog.entityTable"),
            //width: "90%",
            width: "40rem",
            toolbar: _createEntityTableToolbar(controller),
            noData: rb.getText("subledgerEntitySelectDialog.noDataText"),
            //visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            columns: [
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("subledgerEntitySelectDialog.column.name.header.title") }),
                    template: new sas.hc.m.Text({
                        text: "{name}",
                        tooltip: "{name}",
                        wrapping: false
                    }),
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: rb.getText("subledgerEntitySelectDialog.column.version.header.title") }),
                    template: new sas.hc.m.Text({
                        text: '{version}',
                        tooltip: '{version}',
                        //enabled: '{enabled}',
                        wrapping: false
                    }),
                    width: "10rem"
                })
            ],
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            selectionBehavior: sas.hc.ui.table.SelectionBehavior.RowOnly,
            rowSelectionChange: $.proxy(controller.subledgerEntitySelectTableRowSelectionChange, controller),
            //expandAll : true,
        });

        table.bindRows("/children");

        function _createEntityTableToolbar(controller) {
            return new sas.hc.m.ResponsiveToolbar({
                content: [
                    // this.searchField,
                    new sas.hc.m.ToolbarSpacer(),
                    new sas.hc.m.Button({
                        id: "entityTreeTableExpandButton",
                        icon: sas.icons.HC.SHOWALL,
                        tooltip: rb.getText("subledgerEntitySelectDialog.entityTable.expandCollapseButton.tip"),
                        press: $.proxy(controller.entityTreeTableExpandButtonPress, controller)
                    }),
                    new sas.hc.m.Button({
                        id: "entityTreeTableCollapseButton",
                        icon: sas.icons.HC.HIDEALL,
                        tooltip: rb.getText("subledgerEntitySelectDialog.entityTable.collapseButton.tip"),
                        press: $.proxy(controller.entityTreeTableCollapseButtonPress, controller)
                    })
                ]
            });
        }

        var verticalLayout=new sas.hc.ui.layout.VerticalLayout({
            content: [
                table,
            ]
        });

        var dialog = new sas.hc.m.Dialog({
            id: this.createId("sas.stress.config.view.subledgerEntitySelectDialog"),
            //modal: true,
            title: rb.getText("subledgerEntitySelectDialog.window.title"),
            //initialFocus: searchField,

            content: verticalLayout,
            beginButton: new sas.hc.m.Button({
                id: this.createId("subledgerEntitySelectDialog.saveButton"),
                text: rb.getText("subledgerEntitySelectDialog.button.save.action.label"),
                press: $.proxy(controller.subledgerEntitySelectDialogSaveButtonPress, controller),
                enabled: false //will be enabled when a hierarchy is selected in the table.
            }),
            endButton: new sas.hc.m.Button({
                text: rb.getText("subledgerEntitySelectDialog.button.cancel.action.label"),
                press: function () {
                    dialog.close();
                }
            }),
            afterClose: function () {
                dialog.destroy();
            }
        });

        return dialog;
    }
});
