/**
 * Created by sinsrj on 8/30/2017.
 */

jQuery.sap.require({ modName: "sas.stress.scripts.view.EditScriptParameter", type: "controller" });
jQuery.sap.require("sap.ui.core.CustomData");
jQuery.sap.require("sap.ui.core.Orientation");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.FlexItemData");
jQuery.sap.require("sas.hc.m.IconTabBar");
jQuery.sap.require("sas.hc.m.IconTabFilter");
jQuery.sap.require("sas.hc.m.Input");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.hc.m.Text");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.ui.commons.codeEditor.CodeEditor");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutCell");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutRow");
jQuery.sap.require("sas.hc.ui.table.Column");
jQuery.sap.require("sas.hc.ui.table.Table");
jQuery.sap.require("sas.risk.common.widgets.WidgetFactory");
jQuery.sap.require("sas.stress.wkbench.widget.CustomBreadcrumb");
jQuery.sap.require("sas.stress.wkbench.CapabilityManager");
jQuery.sap.require("sas.stress.wkbench.widget.InputSpellCheck");
jQuery.sap.require("sas.risk.common.widgets.HelpLabel");

sap.ui.jsview("sas.stress.scripts.view.EditScriptParameter", {

    getControllerName: function () {
        return "sas.stress.scripts.view.EditScriptParameter";
    },

    createContent: function (controller) {
        var rb=sas.stress.wkbench.StressUtil.getBundle();
        var capabilityManager=sas.stress.wkbench.CapabilityManager.getInstance();

        var text=rb.getText("projectConflictDialog.button.OK.label.txt");
        this.beginbutton = new sas.hc.m.Button({
            text: text, //editScriptParameterView.endbutton
            layoutData: new sas.hc.m.FlexItemData({ growFactor: 1 }),
            press: $.proxy(controller._okPressed, controller),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
        });
        text=rb.getText("compareDialog.button.cancel.txt");
        this.endbutton = new sas.hc.m.Button({
            text: text, // {i18N>script.edit.parameter.cancel.button.txt}
            layoutData: new sas.hc.m.FlexItemData({ growFactor: 1 }),
            press: $.proxy(controller.cancel, controller)
        });

        return         this._scriptParameterDefinitionPanel(controller);
    },

    _scriptParameterDefinitionPanel:function(controller) {
        this.setHeight("100%");
        return new sas.hc.m.VBox("EditScriptParameterPanel", {
            width: "100%",
            height: "100%",
            items: [
                this._scriptParameterDefinitionTopPanel(controller),
                this._scriptParameterDefinitionTypePanel(controller),
                /* the following panels (forms) are dynamic depending on button selections */
                this._scriptParameterDefinitionSingleValuePanel(controller),
                this._scriptParameterDefinitionSASCodePanel(controller),
                this._scriptParameterDefinitionUserDefinedListPanel(controller),
                this._scriptParameterDefinitionObjectPanel(controller)
            ]
        });
    },

    _scriptParameterDefinitionTopPanel:function(controller) {
        var capabilityManager=sas.stress.wkbench.CapabilityManager.getInstance();

        var parameterNameInput = new sas.stress.wkbench.widget.InputSpellCheck({
            id: this.createId("EditScriptDefinitionDialog.parameterNameInput"),
            value: "{/name}",
            type: sap.m.InputType.Text,
            required: false,
            disableValidation: false,
            maxLength: {    // if type === "SystemObject" the name cannot be more than 28
                path:"/parameterType",
                formatter:function(parameterType){
                    return parameterType&&parameterType.toLowerCase()==="systemobject"?28:32;
                }
            },
            //change: $.proxy(controller._scriptParameterNameChange, controller),
            liveChange: $.proxy(controller._scriptParameterNameChange, controller),
            customData: new sap.ui.core.CustomData({
                key: "id",
                value: "{/id}"
            }),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE),
            //validateOnBindingValueChange:false
        });

        var parameterDescriptionInput = new sas.hc.m.TextArea({
            id: this.createId("EditScriptDefinitionDialog.parameterDescriptionInput"),
            value: "{/description}",
            maxLength: 1024,
            rows:2,
            autoExpandable:true,
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE),
            liveChange: $.proxy(controller.onDescChange, controller)
        });

        var form = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 2,
                columnsM: 2,
                labelSpanS: 12,
                labelSpanM: 12,
                labelSpanL: 12
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: "{i18N>scriptParameter.name.control.label}",
                                required: true
                            }),
                            fields: [parameterNameInput]
                        })
                    ]
                }),
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: ("{i18N>scriptParameter.description.control.label}")
                            }),
                            fields: [parameterDescriptionInput]
                        })
                    ]
                })
            ]
        });

        return form;
    },

    _scriptParameterDefinitionTypePanel:function(controller){
        var capabilityManager=sas.stress.wkbench.CapabilityManager.getInstance();

        this.nameValuePairButton = new sas.hc.m.Button({
            id:"nameValuePairButton",
            text: ("{i18N>script.parameter.freeform.header.title}"),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
        });
        this.userDefinedListButton = new sas.hc.m.Button({
            id:"userDefinedListButton",
            text: ("{i18N>script.parameter.list.header.title}"),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
        });
        this.sasCodeButton = new sas.hc.m.Button({
            id:"sasCodeButton",
            text: ("{i18N>script.parameter.sascode.header.title}"),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
        });
        this.objectButton = new sas.hc.m.Button({
            id:"objectButton",
            text: ("{i18N>script.parameter.object.header.title}"),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
        });
        /*this.fileButton = new sas.hc.m.Button({
            id:"fileButton",
            text: ("{i18N>script.parameter.file.header.title}"),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE),
            visible: false  /!* this is stretch goal for RFW 3.1 *!/
        });*/

        this.segmentedTabs=new sas.hc.m.SegmentedButton({
            buttons: [
                this.nameValuePairButton,
                this.userDefinedListButton,
                this.sasCodeButton,
                this.objectButton/*,
                this.fileButton*/
            ],
            width:"100%",
            select: $.proxy(controller._onSegementedButtonPress,controller),
            enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
        });

        var form = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 1,
                columnsM:1,
                labelSpanS: 12,
                labelSpanM: 12,
                labelSpanL: 12
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: ("{i18N>scriptParameter.type.control.label}"),
                                required: true
                            }),
                            fields: [this.segmentedTabs]
                        })
                    ]
                })
            ]
        }).addStyleClass("sapUiTinyMarginTop");

        return form;
    },
    _scriptParameterDefinitionSingleValuePanel:function(controller){
        var capabilityManager=sas.stress.wkbench.CapabilityManager.getInstance();

        this.valueField=new sas.hc.m.Input({
            value: "{/textValue}", //
            type: sap.m.InputType.Text,
            width: "100%",
            maxLength: 1024,
            required: false,
            liveChange: $.proxy(controller._onSingleValueChange, controller),
            editable:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE),
            visible:"{/nameValueEnabled}"
        });

        var form = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 1,
                columnsM:1,
                labelSpanS: 12,
                labelSpanM: 12,
                labelSpanL: 12
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: ("{i18N>scriptParameter.value.control.label}"),
                                // required: true // S1388739
                            }),
                            fields: [this.valueField]
                        })
                    ]
                })
            ],
            visible:"{/nameValueEnabled}"
        }).addStyleClass("sapUiTinyMarginTop")/*.addStyleClass("stressFormSmall")*/;

        return form;
    },
    _scriptParameterDefinitionSASCodePanel:function(controller){
        var form = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 1,
                columnsM:1,
                labelSpanS: 12,
                labelSpanM: 12,
                labelSpanL: 12
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: ("{i18N>scriptParameter.sas.code.control.label}"),
                                required: true
                            }),
                            fields: [this._createSASCodeTabLayout(controller)]
                        })
                    ]
                })
            ],
            visible:"{/sasCodeEnabled}"
        }).addStyleClass("sapUiTinyMarginTop");

        return form;
    },
    _scriptParameterDefinitionUserDefinedListPanel:function(controller){
        var capabilityManager=sas.stress.wkbench.CapabilityManager.getInstance();

        this.userDefinedList=new sas.hc.m.Input({
            value: "{/parameterValue}", //
            type: sap.m.InputType.Text,
            width: "100%",
            maxLength: 1024,
            required: false,
            //liveChange: $.proxy(controller._bizAssumptionValueLiveChange, controller),
            editable:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE),
            visible:"{/userDefinedListEnabled}",
            placeholder:("{i18N>scriptParameter.user.defined.list.values.example.txt}"),
            liveChange: $.proxy(controller._userDefinedListValueChange, controller)
        });
        this.userDefinedListDefaultValue=new sas.hc.m.Input({
            value: "{/parameterDefaultValue}", //
            type: sap.m.InputType.Text,
            width: "100%",
            maxLength: 1024,
            required: false,
            liveChange: $.proxy(controller._parameterDefaultValueLiveChange, controller),
            editable:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE),
            visible:"{/userDefinedListEnabled}",
            placeholder:("{i18N>scriptParameter.user.defined.list.value.example.txt}"),
            enabled:false
        });

        var form = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 1,
                columnsM:1,
                labelSpanS: 12,
                labelSpanM: 12,
                labelSpanL: 12
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: ("{i18N>scriptParameter.user.defined.list.control.label}"),
                                required: true
                            }),
                            fields: [this.userDefinedList]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: ("{i18N>scriptParameter.user.defined.value.control.label}"),
                                required: false
                            }),
                            fields: [this.userDefinedListDefaultValue]
                        })
                    ]
                })
            ],
            visible:"{/userDefinedListEnabled}"
        }).addStyleClass("sapUiTinyMarginTop")/*.addStyleClass("stressFormSmall")*/;

        return form;
    },
    _scriptParameterDefinitionObjectPanel:function(controller){
        var self=this;
        var form = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 2,
                columnsM:2,
                labelSpanS: 12,
                labelSpanM: 12,
                labelSpanL: 12
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.hc.m.Label({
                                text: ("{i18N>scriptParameter.object.types.control.label}"),
                                required: true
                            }),
                            fields: [this._createObjectTypesSelect(controller)]
                        }),
                        new sas.hc.ui.layout.form.FormElement({
                            label: new sas.risk.common.widgets.HelpLabel({
                                text: "{i18N>scriptParameter.object.types.macro.vars.control.label}",
                                library: "sas.stress",
                                key: "scriptParameter.macro.variables"
                            }),
                            fields: [
                                new sas.hc.m.TextArea({
                                    rows: 4,
                                    //width: "39.4rem",
                                    value: {
                                        parts:["/name","/objectTypeParameterValues/objectTypeCode"],
                                        formatter: $.proxy(self._getFormattedMacroVariables, self)
                                    },
                                    editable:false,
                                    autoExpandable:true,
                                    layoutData: new sas.hc.m.FlexItemData({growFactor: 1000})
                                })
                            ]
                        })
                    ]
                })
            ],
            visible:"{/objectEnabled}"
        })/*.addStyleClass("stressFormSmall")*/;

        return form;
    },
    /*
     * Creates a borderlayout for the UDL code editor. The top will be the tool bar specific to
     * UDL editor and the center will be the editor itself.
     *
     */
    _createSASCodeTabLayout: function (controller) {
        var contentLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "99%", height: "22rem" }).addStyleClass("codeEditorBorder");    // fixes for S1250303
        var toolbarArea = new sas.hc.ui.commons.layout.BorderLayoutArea({ content: this._createToolbarForSASEditor(controller),size: "2.5rem" });
        contentLayout.setTop(toolbarArea);
        var codeEditorArea = new sas.hc.ui.commons.layout.BorderLayoutArea({ content: this._createSASCodeEditor(controller) });
        contentLayout.setCenter(codeEditorArea);

        var form = new sas.hc.ui.layout.form.Form({
            layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                columnsL: 1,
                columnsM:1,
                labelSpanS: 12,
                labelSpanM: 12,
                labelSpanL: 12
            }),
            formContainers: [
                new sas.hc.ui.layout.form.FormContainer({
                    formElements: [
                        new sas.hc.ui.layout.form.FormElement({
                            fields: [contentLayout]
                        })
                    ]
                })
            ]
        });

        //this.sasCodeLayout=contentLayout;
        return form;
    },

    _createSASCodeEditor: function (controller) {
        var capabilityManager=sas.stress.wkbench.CapabilityManager.getInstance();
        var rb= sap.ui.getCore().getLibraryResourceBundle("sas.stress.scripts");

        var codeSettings = {
            content: "/*\n" + rb.getText("scriptParameter.parameter.type.SASCODE.comment.txt") +"*/\n",
            langMode: sas.hc.ui.commons.codeEditor.LanguageMode.SasCode,
            lineHighlightingVisible: true,
            lineNumberVisible: true,
            tabSize: 4,
            autoCompleteEnabled: true,
            hintEnabled: true,
            indentEnabled: true,
            syntaxHighlighting: true,
            tabAsSpace: false,
            foldingEnabled: true
        };
        this.udlCodeEditor = new sas.hc.ui.commons.codeEditor.CodeEditor("scriptParametercode", codeSettings);
        this.udlCodeEditor.readOnly(!capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE));
        this.udlCodeEditor.resize("100%", "19.5rem");
        //this.udlCodeEditor.addStyleClass("modelCodeEditor");
        /*S1194392 and S1203139*/
        this.udlCodeEditor.attachTextChanged($.proxy(controller._udlTextChanged, controller));
        this.udlCodeEditor.setLayoutData(new sas.hc.m.FlexItemData({growFactor: 100}));
        return this.udlCodeEditor;
    },
    /*
     * The tool bar for the UDL editor. The user would be able to do more things.
     *
     */
    _createToolbarForSASEditor: function (controller) {
        var capabilityManager=sas.stress.wkbench.CapabilityManager.getInstance();

        var that = this;
        return new sas.hc.m.ResponsiveToolbar({
            content: [
                new sas.hc.m.Button({
                    icon: sas.icons.HC.UNDO,
                    press: function(){
                        that.udlCodeEditor.undo();
                    },
                    enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
                }),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.REDO,
                    press: function(){
                        that.udlCodeEditor.redo();
                    },
                    enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
                }),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.CUT,
                    press: function () {
                        that.udlCodeEditor.cut();
                    },
                    enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
                }),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.COPY,
                    press: function () {
                        that.udlCodeEditor.copy();
                    },
                    enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
                }),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.PASTE,
                    press: function () {
                        that.udlCodeEditor.paste();
                    },
                    enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
                }),
                new sas.hc.m.Button({
                    tooltip: '{i18N>script.codeEditor.FindReplace.Tooltip.tip}',
                    icon: sas.icons.HC.FIND,
                    press: function () {
                        that.udlCodeEditor.showFindReplaceDialog();
                    }
                }),
                new sas.hc.m.Button({
                    icon: sas.icons.HC.CLEARALL,
                    press: function () {
                        that.udlCodeEditor.clear();
                    },
                    enabled:capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE)
                }),
                new sas.hc.m.Button({
                    id: "scriptParametercodeEditorPrint",
                    icon: sas.icons.HC.PRINT,
                    press: $.proxy(controller._onPrint, controller)
                })
            ]
        }).addStyleClass("stressToolbarColor");
    },
    _createObjectTypesSelect:function(controller){
        var dd = new sas.hc.m.Select({
            //displaySecondaryValues: true,
            enableUnselected: true,
            maxWidth:"100%"
        });
        dd.attachChange($.proxy(controller._selectObject, controller));
        var itemTemplate = new sas.hc.ui.core.ListItem({
            text: "{name}",
            key: "{key}"
        });
        dd.bindAggregation("items", {
            path: "/objectTypes",
            template: itemTemplate,
            templateShareable: false
        });
        this._objectTypesSelect=dd;
        return dd;
    },
    _createMacroVarsInformation:function(controller){
        var self=this;

        var content=new sas.hc.m.HBox({
            items:[
                new sas.hc.m.TextArea({
                    rows: 4,
                    //width: "39.4rem",
                    value: {
                        parts:["/name","/objectTypeParameterValues/objectTypeCode"],
                        formatter: $.proxy(self._getFormattedMacroVariables, self)
                    },
                    editable:false,
                    autoExpandable:true,
                    layoutData: new sas.hc.m.FlexItemData({growFactor: 1000})
                })
            ],
            width:"100%"
        });
        return content;

/*
        var textArea=new sas.hc.m.MessageStrip({
            text: {
                parts:["/name","/objectTypeParameterValues/objectTypeCode"],
                formatter: $.proxy(self._getFormattedMacroVariables, self)
            },
            type: sap.ui.core.MessageType.Information,
            showIcon: true
        });
        return textArea*/;
    },
    destroy: function () {
        this.udlCodeEditor.destroy();
        sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
    },
    attachClosing: function (callBack, listener) {
        this.attachEvent(this.getId() + "_CLOSING", callBack, listener);
    },
    getSelectedObjectTypeKey: function () {
        return this._objectTypesSelect.getSelectedKey();
    },
    getSelectedDefaultValueItem: function(){
        return this._defaultValuesSelect.getSelectedItem();
    },
    _getFormattedMacroVariables:function(name,type){
        var rb=sap.ui.getCore().getLibraryResourceBundle("sas.stress.scripts");
        if (name/*&&type*/) {
            if (type&&type.toLowerCase()!=="project")  {
                return rb.getText("script.parameter.macro.variable.info.fmt", [name, name, name]);
            }else{
                return rb.getText("script.parameter.macro.variable.no.ver.info.fmt", [name, name]);
            }
        }
        return rb.getText("script.parameter.macro.variable.no.ver.info.fmt", [name, name]);
    }
});

