sap.ui.base.Object.extend("sas.stress.wkbench.CapabilityManager", {

    _instance: null,
    _capabilities:[],

    constructor: function(capabilityKeys) {

        var capabilityMap = sas.stress.wkbench.CapabilityManager.buildCapabilityMap();
        var capabilities = [];

        _.each(capabilityKeys, function(capabilityKey) {
            capabilities = _.union(capabilities, capabilityMap[capabilityKey]);
        });
        this._capabilities = capabilities;
    },

    isCapableOf: function (action) {
        var capabilityFound = _.find(this._capabilities, function (capability) {
            return capability === action;
        });
        return (!!capabilityFound);
    }
});

sas.stress.wkbench.CapabilityManager.createInstance = function (capabilities) {
    if (!capabilities || capabilities.length === 0) {
        capabilities = [sas.stress.wkbench.CapabilityManager.RFW_USER];
    }
    sas.stress.wkbench.CapabilityManager._instance = new sas.stress.wkbench.CapabilityManager(capabilities);
};

sas.stress.wkbench.CapabilityManager.getInstance = function () {
    if (!sas.stress.wkbench.CapabilityManager._instance) {
        sas.stress.wkbench.CapabilityManager.createInstance();
    }
    return sas.stress.wkbench.CapabilityManager._instance;
};

//Capability Keys
sas.stress.wkbench.CapabilityManager.RFW_ADMIN = "StressTestingAdmin";
sas.stress.wkbench.CapabilityManager.RFW_USER = "ManageStressTesting";

sas.stress.wkbench.CapabilityManager.STRESSTESTINGCREATEPROJECT = "StressTestingCreateProject";
sas.stress.wkbench.CapabilityManager.STRESSTESTINGUPDATE = "StressTestingUpdate";
sas.stress.wkbench.CapabilityManager.STRESSTESTINGDELETE = "StressTestingDelete";
sas.stress.wkbench.CapabilityManager.STRESSTESTINGUPDATEDATA = "StressTestingUpdateData";
sas.stress.wkbench.CapabilityManager.STRESSTESTINGCREATEMODELGROUP = "StressTestingCreateModelGroup";
sas.stress.wkbench.CapabilityManager.STRESSTESTINGREADCONFIG = "StressTestingReadConfig";

//Groove Bar Capabilities
sas.stress.wkbench.CapabilityManager.CONFIGURATION =  "CONFIGURATION_CAPABILITY";

//Project Capabilities
sas.stress.wkbench.CapabilityManager.PROJECT = {
    CREATE: "PROJECT_CREATE_CAPABILITY",
    READ:   "PROJECT_READ_CAPABILITY",
    UPDATE: "PROJECT_UPDATE_CAPABILITY",
    DELETE: "PROJECT_DELETE_CAPABILITY",
    LOCK:   "PROJECT_LOCK_CAPABILITY"
};
//Worksheet Capabilities
sas.stress.wkbench.CapabilityManager.WORKSHEET = {
    CREATE: "WORKSHEET_CREATE_CAPABILITY",
    READ:   "WORKSHEET_READ_CAPABILITY",
    UPDATE: "WORKSHEET_UPDATE_CAPABILITY",
    DELETE: "WORKSHEET_DELETE_CAPABILITY"
};
//Model Group Run Capabilities
sas.stress.wkbench.CapabilityManager.MGR = {
    CREATE: "MGR_CREATE_CAPABILITY",
    READ:   "MGR_READ_CAPABILITY",
    UPDATE: "MGR_UPDATE_CAPABILITY",
    DELETE: "MGR_DELETE_CAPABILITY",
    RUN:    "MGR_RUN_CAPABILITY",
    RESULT: "MGR_RESULT_CAPABILITY"
};
//Project Scenario Capabilities
sas.stress.wkbench.CapabilityManager.SCENARIO = {
    IMPORT: "SCENARIO_IMPORT_CAPABILITY",
    UPDATE: "SCENARIO_UPDATE_CAPABILITY",
    READ:   "SCENARIO_READ_CAPABILITY",
    DELETE: "SCENARIO_DELETE_CAPABILITY"
};
//Project Report Capabilities
sas.stress.wkbench.CapabilityManager.REPORT = {
    CREATE: "REPORT_CREATE_CAPABILITY",
    READ:   "REPORT_READ_CAPABILITY",
    UPDATE: "REPORT_UPDATE_CAPABILITY",
    DELETE: "REPORT_DELETE_CAPABILITY",
    RUN:    "REPORT_RUN_CAPABILITY",
    DOWNLOAD:"REPORT_DOWNLOAD_CAPABILITY",
    PUBLISH:"REPORT_PUBLISH_CAPABILITY",
    EXPORT: "REPORT_EXPORT_CAPABILITY"
};
//Project Data Capabilities
sas.stress.wkbench.CapabilityManager.DATA = {
    READ:   "DATA_READ_CAPABILITY",
    IMPORT: "DATA_IMPORT_CAPABILITY",
    CREATE_MAP: "DATA_LOAD_MAP_CREATE_CAPABILITY",
    UPDATE_MAP: "DATA_LOAD_MAP_UPDATE_CAPABILITY",
    DELETE_MAP: "DATA_LOAD_MAP_DELETE_CAPABILITY"
};
//Filing Package Capabilities
sas.stress.wkbench.CapabilityManager.PACKAGE = {
    CREATE: "PACKAGE_CREATE_CAPABILITY",
    READ:   "PACKAGE_READ_CAPABILITY",
    UPDATE: "PACKAGE_UPDATE_CAPABILITY",
    DELETE: "PACKAGE_DELETE_CAPABILITY",
    RUN:    "PACKAGE_RUN_CAPABILITY"
};
//Hierarchy Capabilities
sas.stress.wkbench.CapabilityManager.HIERARCHY = {
    CREATE: "HIERARCHY_CREATE_CAPABILITY",
    READ:   "HIERARCHY_READ_CAPABILITY",
    UPDATE: "HIERARCHY_UPDATE_CAPABILITY",
    DELETE: "HIERARCHY_DELETE_CAPABILITY",
    CONFIGURE: "HIERARCHY_CONFIGURE_CAPABILITY"
};
//Dimension Capabilities
sas.stress.wkbench.CapabilityManager.DIMENSION = {
    CREATE: "DIMENSION_CREATE_CAPABILITY",
    READ:   "DIMENSION_READ_CAPABILITY",
    UPDATE: "DIMENSION_UPDATE_CAPABILITY",
    DELETE: "DIMENSION_DELETE_CAPABILITY",
    CONFIGURE: "DIMENSION_CONFIGURE_CAPABILITY"
};
//Dimension Crossings (found under New Project)
sas.stress.wkbench.CapabilityManager.DIMENSIONCROSSING = {
    CREATE: "DIMENSIONCROSSING_CREATE_CAPABILITY"
};
//Sheet Template Capabilities
sas.stress.wkbench.CapabilityManager.TEMPLATE = {
    CREATE: "TEMPLATE_CREATE_CAPABILITY",
    READ:   "TEMPLATE_READ_CAPABILITY",
    UPDATE: "TEMPLATE_UPDATE_CAPABILITY",
    DELETE: "TEMPLATE_DELETE_CAPABILITY"
};
//Process Definition/Task Capabilities
sas.stress.wkbench.CapabilityManager.PROCESS = {
    IMPORT:                 "PROCESS_IMPORT_CAPABILITY",
    READ:                   "PROCESS_READ_CAPABILITY",
    DELETE:                 "PROCESS_DELETE_CAPABILITY",
    ACTION:                 "PROCESS_ACTION_CAPABILITY",
    START_NEW_ITERATION:    "PROCESS_START_NEW_ITERATION_CAPABILITY"
};
// Model Capabilities
sas.stress.wkbench.CapabilityManager.MODEL = {
    IMPORT:         "MODEL_IMPORT_CAPABILITY",   // we do not create models, we only import them
    READ:           "MODEL_READ_CAPABILITY",
    UPDATE:         "MODEL_UPDATE_CAPABILITY",  // one cannot update models, it is delete and re-import
    DELETE:         "MODEL_DELETE_CAPABILITY"
};
//Model Group Capabilities
sas.stress.wkbench.CapabilityManager.MODELGROUP = {
    CREATE:         "MODEL_GROUP_CREATE_CAPABILITY",
    READ:           "MODEL_GROUP_READ_CAPABILITY",
    UPDATE:         "MODEL_GROUP_UPDATE_CAPABILITY",
    DELETE:         "MODEL_GROUP_DELETE_CAPABILITY",
    ADD_MODELS:     "MODEL_GROUP_ASSOCIATE_MODELS_CAPABILITY",
    DELETE_MODELS:  "MODEL_GROUP_DELETE_MODELS_CAPABILITY",
    VIEW_MODELS:    "MODEL_GROUP_VIEW_MODELS_CAPABILITY"
};
//Scripts Capabilities
sas.stress.wkbench.CapabilityManager.SCRIPT = {
    CREATE: "SCRIPT_CREATE_CAPABILITY",
    READ:   "SCRIPT_READ_CAPABILITY",
    UPDATE: "SCRIPT_UPDATE_CAPABILITY",
    DELETE: "SCRIPT_DELETE_CAPABILITY",
    IMPORT: "SCRIPT_IMPORT_CAPABILITY",
    RUN:    "SCRIPT_RUN_CAPABILITY"
};
//Archives Capabilities
sas.stress.wkbench.CapabilityManager.ARCHIVE = {
    CREATE:  "ARCHIVE_CREATE_CAPABILITY",
    READ:    "ARCHIVE_READ_CAPABILITY",
    DELETE:  "ARCHIVE_DELETE_CAPABILITY",
    IMPORT:  "ARCHIVE_IMPORT_CAPABILITY",
    UPLOAD:  "ARCHIVE_UPLOAD_CAPABILITY",
    DOWNLOAD:"ARCHIVE_DOWNLOAD_CAPABILITY"
};

// ideally, the map should be defined in meta data, serving from the mid-tier.
sas.stress.wkbench.CapabilityManager.buildCapabilityMap = function () {
    var capabilityMap = {};

    // RFW Admin's capabilities
    capabilityMap[sas.stress.wkbench.CapabilityManager.RFW_ADMIN] = [
        //StressGrooveBar (LeftNavManager does not support capability)
        sas.stress.wkbench.CapabilityManager.CONFIGURATION,
        //Dimensions
        sas.stress.wkbench.CapabilityManager.DIMENSION.DELETE,
        sas.stress.wkbench.CapabilityManager.DIMENSION.UPDATE,
        sas.stress.wkbench.CapabilityManager.DIMENSION.CREATE,
        sas.stress.wkbench.CapabilityManager.DIMENSION.CONFIGURE,
        sas.stress.wkbench.CapabilityManager.DIMENSION.READ,
        sas.stress.wkbench.CapabilityManager.DIMENSIONCROSSING.CREATE,
        //ProjectManager
        sas.stress.wkbench.CapabilityManager.PROJECT.CREATE,
        sas.stress.wkbench.CapabilityManager.PROJECT.READ,
        sas.stress.wkbench.CapabilityManager.PROJECT.UPDATE,
        sas.stress.wkbench.CapabilityManager.PROJECT.DELETE,
        sas.stress.wkbench.CapabilityManager.PROJECT.LOCK,
        //ProjectReportsEditor
        sas.stress.wkbench.CapabilityManager.REPORT.READ,
        sas.stress.wkbench.CapabilityManager.REPORT.CREATE,
        sas.stress.wkbench.CapabilityManager.REPORT.UPDATE,
        sas.stress.wkbench.CapabilityManager.REPORT.DELETE,
        sas.stress.wkbench.CapabilityManager.REPORT.RUN,
        sas.stress.wkbench.CapabilityManager.REPORT.DOWNLOAD,
        sas.stress.wkbench.CapabilityManager.REPORT.PUBLISH,
        sas.stress.wkbench.CapabilityManager.REPORT.EXPORT,
        //PackageManager
        sas.stress.wkbench.CapabilityManager.PACKAGE.READ,
        sas.stress.wkbench.CapabilityManager.PACKAGE.CREATE,
        sas.stress.wkbench.CapabilityManager.PACKAGE.UPDATE,
        sas.stress.wkbench.CapabilityManager.PACKAGE.DELETE,
        sas.stress.wkbench.CapabilityManager.PACKAGE.RUN,
        //ProjectConfiguration
        sas.stress.wkbench.CapabilityManager.HIERARCHY.CREATE,
        sas.stress.wkbench.CapabilityManager.HIERARCHY.READ,
        sas.stress.wkbench.CapabilityManager.HIERARCHY.UPDATE,
        sas.stress.wkbench.CapabilityManager.HIERARCHY.DELETE,
        sas.stress.wkbench.CapabilityManager.HIERARCHY.CONFIGURE,
        //SheetTemplateManager
        sas.stress.wkbench.CapabilityManager.TEMPLATE.CREATE,
        sas.stress.wkbench.CapabilityManager.TEMPLATE.READ,
        sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE,
        sas.stress.wkbench.CapabilityManager.TEMPLATE.DELETE,
        //ProcessDefinitions
        sas.stress.wkbench.CapabilityManager.PROCESS.IMPORT,
        sas.stress.wkbench.CapabilityManager.PROCESS.DELETE,
        sas.stress.wkbench.CapabilityManager.PROCESS.READ,
        sas.stress.wkbench.CapabilityManager.PROCESS.ACTION,
        sas.stress.wkbench.CapabilityManager.PROCESS.START_NEW_ITERATION,
        //ScenarioManager
        sas.stress.wkbench.CapabilityManager.SCENARIO.READ,
        sas.stress.wkbench.CapabilityManager.SCENARIO.IMPORT,
        sas.stress.wkbench.CapabilityManager.SCENARIO.UPDATE,
        sas.stress.wkbench.CapabilityManager.SCENARIO.DELETE,
        //DataEditor
        sas.stress.wkbench.CapabilityManager.DATA.READ,
        sas.stress.wkbench.CapabilityManager.DATA.IMPORT,
        sas.stress.wkbench.CapabilityManager.DATA.CREATE_MAP,
        sas.stress.wkbench.CapabilityManager.DATA.UPDATE_MAP,
        sas.stress.wkbench.CapabilityManager.DATA.DELETE_MAP,
        //BrowseModelInventory
        sas.stress.wkbench.CapabilityManager.MODEL.READ,
        sas.stress.wkbench.CapabilityManager.MODEL.IMPORT,
        sas.stress.wkbench.CapabilityManager.MODEL.UPDATE,
        sas.stress.wkbench.CapabilityManager.MODEL.DELETE,
        //ModelGroups
        sas.stress.wkbench.CapabilityManager.MODELGROUP.CREATE,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.READ,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.UPDATE,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.DELETE,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.ADD_MODELS,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.DELETE_MODELS,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.VIEW_MODELS,
        //ModelGroupRunsManager
        sas.stress.wkbench.CapabilityManager.MGR.READ,
        sas.stress.wkbench.CapabilityManager.MGR.CREATE,
        sas.stress.wkbench.CapabilityManager.MGR.UPDATE,
        sas.stress.wkbench.CapabilityManager.MGR.DELETE,
        sas.stress.wkbench.CapabilityManager.MGR.RUN,
        sas.stress.wkbench.CapabilityManager.MGR.RESULT,
        //ScriptManager
        sas.stress.wkbench.CapabilityManager.SCRIPT.CREATE,
        sas.stress.wkbench.CapabilityManager.SCRIPT.READ,
        sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE,
        sas.stress.wkbench.CapabilityManager.SCRIPT.DELETE,
        sas.stress.wkbench.CapabilityManager.SCRIPT.RUN,
        sas.stress.wkbench.CapabilityManager.SCRIPT.IMPORT,

        //ArchiveManager
        sas.stress.wkbench.CapabilityManager.ARCHIVE.CREATE,
        sas.stress.wkbench.CapabilityManager.ARCHIVE.READ,
        sas.stress.wkbench.CapabilityManager.ARCHIVE.IMPORT,
        sas.stress.wkbench.CapabilityManager.ARCHIVE.UPLOAD,
        sas.stress.wkbench.CapabilityManager.ARCHIVE.DOWNLOAD,
        sas.stress.wkbench.CapabilityManager.ARCHIVE.DELETE,
        //Worksheet
        sas.stress.wkbench.CapabilityManager.WORKSHEET.READ,
        sas.stress.wkbench.CapabilityManager.WORKSHEET.CREATE,
        sas.stress.wkbench.CapabilityManager.WORKSHEET.UPDATE,
        sas.stress.wkbench.CapabilityManager.WORKSHEET.DELETE
    ];

    // RFW User's capabilities
    capabilityMap[sas.stress.wkbench.CapabilityManager.RFW_USER] = [
        //StressGrooveBar (LeftNavManager does not support capability)
        sas.stress.wkbench.CapabilityManager.PROJECT.READ,
        sas.stress.wkbench.CapabilityManager.SCENARIO.READ,
        sas.stress.wkbench.CapabilityManager.DATA.READ,
        sas.stress.wkbench.CapabilityManager.MODEL.READ,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.READ,
        sas.stress.wkbench.CapabilityManager.SCRIPT.READ,
        sas.stress.wkbench.CapabilityManager.DIMENSION.READ,

        //StressIconBar
        sas.stress.wkbench.CapabilityManager.PROCESS.READ,
        sas.stress.wkbench.CapabilityManager.WORKSHEET.READ,
        sas.stress.wkbench.CapabilityManager.MGR.READ,
        sas.stress.wkbench.CapabilityManager.SCENARIO.READ,
        sas.stress.wkbench.CapabilityManager.REPORT.READ,
        sas.stress.wkbench.CapabilityManager.DATA.READ,
        sas.stress.wkbench.CapabilityManager.PACKAGE.READ,
        //HomePage
        sas.stress.wkbench.CapabilityManager.PROCESS.ACTION,
        //ModelGroupRunsManager
        sas.stress.wkbench.CapabilityManager.MGR.RUN,
        sas.stress.wkbench.CapabilityManager.MGR.RESULT,
        //ProjectReportsEditor
        sas.stress.wkbench.CapabilityManager.REPORT.RUN,
        sas.stress.wkbench.CapabilityManager.REPORT.DOWNLOAD,
        sas.stress.wkbench.CapabilityManager.REPORT.PUBLISH,
        //PackageManager
        sas.stress.wkbench.CapabilityManager.PACKAGE.RUN,
        //ProjectConfiguration
        sas.stress.wkbench.CapabilityManager.HIERARCHY.READ,
        //SheetTemplateManager
        sas.stress.wkbench.CapabilityManager.TEMPLATE.READ,
        //ScenarioManager
        sas.stress.wkbench.CapabilityManager.SCENARIO.READ,
        //DataEditor
        sas.stress.wkbench.CapabilityManager.DATA.READ,
        sas.stress.wkbench.CapabilityManager.DATA.IMPORT,
        //BrowseModelInventory
        sas.stress.wkbench.CapabilityManager.MODEL.READ,
        //ModelGroups
        sas.stress.wkbench.CapabilityManager.MODELGROUP.READ,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.VIEW_MODELS,
        //ScriptManager
        sas.stress.wkbench.CapabilityManager.SCRIPT.READ,
        //ArchiveManager
        sas.stress.wkbench.CapabilityManager.ARCHIVE.READ
    ];

    capabilityMap[sas.stress.wkbench.CapabilityManager.STRESSTESTINGREADCONFIG] = [
        sas.stress.wkbench.CapabilityManager.CONFIGURATION
    ];

    capabilityMap[sas.stress.wkbench.CapabilityManager.STRESSTESTINGCREATEPROJECT] = [
        sas.stress.wkbench.CapabilityManager.PROJECT.CREATE
    ];

    capabilityMap[sas.stress.wkbench.CapabilityManager.STRESSTESTINGUPDATE] = [
        sas.stress.wkbench.CapabilityManager.PROJECT.UPDATE,
        sas.stress.wkbench.CapabilityManager.PROJECT.LOCK,
        sas.stress.wkbench.CapabilityManager.PROCESS.START_NEW_ITERATION,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.UPDATE
    ];

    capabilityMap[sas.stress.wkbench.CapabilityManager.STRESSTESTINGDELETE] = [
        sas.stress.wkbench.CapabilityManager.PROJECT.DELETE,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.DELETE,
        sas.stress.wkbench.CapabilityManager.MODEL.DELETE,
        sas.stress.wkbench.CapabilityManager.MGR.DELETE,
        sas.stress.wkbench.CapabilityManager.SCRIPT.DELETE
    ];

    capabilityMap[sas.stress.wkbench.CapabilityManager.STRESSTESTINGUPDATEDATA] = [
        sas.stress.wkbench.CapabilityManager.DATA.IMPORT
    ];

    capabilityMap[sas.stress.wkbench.CapabilityManager.STRESSTESTINGCREATEMODELGROUP] = [
        sas.stress.wkbench.CapabilityManager.MODELGROUP.CREATE,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.ADD_MODELS,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.VIEW_MODELS,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.DELETE_MODELS,
        sas.stress.wkbench.CapabilityManager.MODELGROUP.UPDATE,
        sas.stress.wkbench.CapabilityManager.MGR.CREATE,
        sas.stress.wkbench.CapabilityManager.MGR.UPDATE,
        sas.stress.wkbench.CapabilityManager.MGR.RUN,
        sas.stress.wkbench.CapabilityManager.MGR.RESULT,
        sas.stress.wkbench.CapabilityManager.SCRIPT.CREATE,
        sas.stress.wkbench.CapabilityManager.SCRIPT.READ,
        sas.stress.wkbench.CapabilityManager.SCRIPT.UPDATE,
        sas.stress.wkbench.CapabilityManager.SCRIPT.RUN,
        sas.stress.wkbench.CapabilityManager.SCRIPT.IMPORT
    ];

    return capabilityMap;
};