jQuery.sap.declare("sas.stress.wkbench.EventBusConstants");
jQuery.sap.require("sap.ui.base.Object");

sap.ui.base.Object.extend("sas.stress.wkbench.EventBusConstants", {
    constructor: function () {
    }
});

sas.stress.wkbench.EventBusConstants.CHANNEL_NAME = "stressWkbench";

/**
 * Fired when resetting config to top-level views.
 *
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.VIEW_CONFIG_ROOT = "viewConfigRoot";


/**
 * Fired when viewing hierarchy table view from the mapping view.
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.VIEW_HIERARCHIES = "viewHierarchies";

/**
 * Fired when viewing hierarchy mapping details  from the global view.
 *
 * Event Parameters:
 * hierarchyKey - {string} the hierarchy key of the hierarchy to view
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.EDIT_HIERARCHY_MAPPING = "editHierarchyMapping";

/**
 * Fired when save is successful after Creating a Worksheet Template from the global view.
 *
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.VIEW_WORKSHEET_TEMPLATES = "viewWorksheetTemplates";

/**
 * Fired to go to Worksheet Template Editor from the global view.
 *
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.EDIT_WORKSHEET_TEMPLATE = "editWorksheetTemplate";

/**
 * Fired when creating a new Slam Configuration
 *
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.VIEW_SLAM_CONFIG_MGR = "viewSlamConfigMgr";

/**
 * Fired when editing an existing Slam Configuration
 *
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.EDIT_SLAM_CONFIGURATION = "createSlamConfiguration";

/**
 * Handle clicks to the diagram on the main homepage
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.TASK_DIAGRAM_CLICKED = "taskDiagramClicked";

/**
 * Handle clicks to the diagram on the main homepage
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.TASK_DIAGRAM_DOUBLECLICKED = "taskDiagramDoubleClicked";
sas.stress.wkbench.EventBusConstants.PROCESS_DIAGRAM_DOUBLECLICKED = "processDiagramDoubleClicked";

/**
 * Fired when a hierarchy is deleted.
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.HIERARCHY_DELETED = "hierarchyDeleted";

/**
 * Fired when viewing all models in the global view
 *
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.VIEW_MODELS = "viewModels";

/**
 * Fired when viewing Model details from the global view.
 *
 * Event Parameters:
 * model - {object} the model to be viewed
 *
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.VIEW_MODEL_DETAILS = "viewModelDetails";

/**
 * Fired when deleting a model in the global view
 *
 * Event Parameters:
 * modelKey - {string} the model key of the model to delete
 *
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.DELETE_MODELS = "deleteModels";

/**
 * Fired when viewing model groups in the global view
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.VIEW_MODEL_GROUPS = "viewModelGroups";

/**
 * Fired when saving or creating new model group in the global view
 * @type {string}
 */
sas.stress.wkbench.EventBusConstants.EDIT_MODEL_GROUP = "editModelGroup";

/**
 * Fired when filing package is created.
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.CREATE_PACKAGE = "createPackage";
/**
 * Fired when filing package is created.
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.DELETE_PACKAGE = "deletePackage";
/**
 * Fired when filing package is deleted.
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.PACKAGE_SELECTION_CHANGED = "packageSelectionChanged";

/**
 * Fired when viewing all archives
 *
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.VIEW_ARCHIVES = "viewArchives";

/**
 * Fired when creating a new archive
 *
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.CREATE_ARCHIVE = "createArchive";

/**
 * Fired when notification has been sent
 * @type (String)
 */
sas.stress.wkbench.EventBusConstants.UPDATE_NOTIFICATIONS = "updateNotifications";
