jQuery.sap.require("sap.ui.core.routing.Router");
jQuery.sap.require("sas.risk.common.utils.NavChecker");
jQuery.sap.require("sas.hc.m.MessageDialog");
jQuery.sap.require("sas.stress.wkbench.StressLocales");
//jQuery.sap.require("sas.stress.wkbench.ViewManager");

sas.stress.wkbench.StressUtil = {

    dialogSmall: "33%",
    dialogMedium: "50%",
    dialogLarge: "90%",
    _graphWindows: {},
    _graphWindowIDtoKeyStorageMap: {},

    calculateColumnAlias: function (columnIndex) {
        columnIndex = columnIndex;
        if (columnIndex < 0) {
            return "";
        }
        var calc = function (index) {
            var over = Math.floor((index) / 26);
            var remainder = index % 26;
            var result = "";
            if (over > 0) {
                result += calc(over - 1);
            }
            return result + String.fromCharCode(65 + remainder);
        };
        return calc(columnIndex);
    },
    hashString: function(string) {
        var hash = 0, i, chr;
        if (string.length === 0) return hash;
        for (i = 0; i < string.length; i++) {
            chr   = string.charCodeAt(i);
            hash  = ((hash << 5) - hash) + chr;
            hash |= 0; // Convert to 32bit integer
        }
        return hash;
    },
    validateDatePicker:function(elemId) {
        sap.ui.getCore().attachParseError(
            function(oEvent) {
                var oElement = oEvent.getParameter("element");
                if (oElement.getId() === elemId) {
                    oElement.setValueState(sap.ui.core.ValueState.Error);
                }
            });

        sap.ui.getCore().attachValidationSuccess(
            function(oEvent) {
                var oElement = oEvent.getParameter("element");
                if (oElement.getId() === elemId) {
                    oElement.setValueState(sap.ui.core.ValueState.Success);
                }
            });
    },
    handleDatePickerChange:function(event, required) {
        var validDate = event.getParameter("valid");
        var datePicker = event.getSource();
        if (required && datePicker.getEnabled() && datePicker.getValue().length < 1) {
            validDate = false;
        }
        if (validDate) {
            datePicker.setValueState(sap.ui.core.ValueState.None);
        } else {
            datePicker.setValueState(sap.ui.core.ValueState.Error);
        }
    },
    getCaretPosition:function(elemId,ignoreGrandChild){ // S1342467
        var elem = ignoreGrandChild===false?document.getElementById(elemId+"-inner"):document.getElementById(elemId); // RQSSTR-786
        var iCaretPos = 0;
        if (elem) {
            // S1342467.. there is case when the firstChild is the only required
            //elem = elem.firstChild?(ignoreGrandChild?elem.firstChild:elem.firstChild.firstChild):elem;      // the 2nd child is the text S1311981
            //elem=ignoreGrandChild===undefined?elem:((ignoreGrandChild===true)?elem.firstChild:elem.firstChild.firstChild.firstChild);
            if (document.selection) {//IE Support
                elem.focus();
                var oSel = document.selection.createRange();
                oSel.moveStart('character', -elem.value.length);
                iCaretPos = oSel.text.length;
            }/*else if (elem.value.length){
             iCaretPos=elem.value.length;
             } */else if (elem.selectionStart || elem.selectionStart === '0') {
                iCaretPos = elem.selectionStart;
            }
        }
        return iCaretPos;
    },
    setCaretPosition: function(elemId, caretPos,ignoreGrandChild) { // S1342467
        var elem = ignoreGrandChild===false?document.getElementById(elemId+"-inner"):document.getElementById(elemId); // RQSSTR-786
        if (elem) {
            // S1342467.. there is case when the firstChild is the only required
            //elem = elem.firstChild?(ignoreGrandChild?elem.firstChild:elem.firstChild.firstChild):elem;      // the 2nd child is the text S1311981
            //elem=ignoreGrandChild===undefined?elem:((ignoreGrandChild===true)?elem.firstChild:elem.firstChild.firstChild);
            caretPos = (caretPos === undefined) ? elem.value.length : caretPos;
            if (elem != null) {
                if (elem.createTextRange) {
                    var range = elem.createTextRange();
                    range.move('character', caretPos);
                    range.select();
                } else {
                    elem.focus();
                    if (elem.selectionStart !== undefined) {
                        elem.selectionStart=elem.selectionEnd=caretPos;
                        //elem.setSelectionRange(caretPos, caretPos);
                    }
                }
            }
        }
    },
    _userName : "",
    _userDisplayName: "",
    setUserName : function (userName) {
        sas.stress.wkbench.StressUtil._userName = userName;
    },
    getUserName : function () {
        var userName = "";
        var oUserInfo = sas.hc.ui.core.util.UserInfo.instance;
        if (oUserInfo !== undefined) {
            userName = oUserInfo.name; // I don't know what object property to use. Assuming name.
        } else {
            userName = sas.stress.wkbench.StressUtil._userName;
        }
        return userName;
    },
    setUserDisplayName:function (userDisplayName){
        sas.stress.wkbench.StressUtil._userDisplayName=userDisplayName;
    },
    getUserDisplayName:function (){
        var userDisplayName = "";
        var oUserInfo = sas.hc.ui.core.util.UserInfo.instance;
        if (oUserInfo !== undefined) {
            userDisplayName = oUserInfo.displayName;
        } else {
            userDisplayName = sas.stress.wkbench.StressUtil._userDisplayName;
        }
        return userDisplayName;
    },
    _userWorkGroups : [],
    setUserWorkGroups : function (userWorkGroups) {
        sas.stress.wkbench.StressUtil._userWorkGroups = userWorkGroups;
    },
    getUserWorkGroups : function () {
        return sas.stress.wkbench.StressUtil._userWorkGroups;
    },
    _riskWorkGroups : [],
    setRiskWorkGroups : function (riskWorkGroups) {
        sas.stress.wkbench.StressUtil._riskWorkGroups = riskWorkGroups;
    },
    getRiskWorkGroups : function () {
        return sas.stress.wkbench.StressUtil._riskWorkGroups;
    },
    _rb: sap.ui.getCore().getLibraryResourceBundle("sas.stress.wkbench"),
    getBundle: function () {
        return sas.stress.wkbench.StressUtil._rb;
    },
    getSolutionURLs: function (e) {
        var deferred = $.Deferred();
        $.getJSON("rest/sysinfo", function (urls) {
            deferred.resolve(urls);
        }).fail(function (jqxhr, textStatus, errorThrown) {
            jQuery.sap.log.error("loading solution URLs FAILURE: " + errorThrown);
            deferred.reject(jqxhr);
        });
        return deferred;
    },
    launchSASScenarioEditor: function (id) {
        $.when(this.getSolutionURLs()).done(function (urls) {
            sas.applicationSwitcher.gotoApp("RiskScenarioManager", urls.scenarioEditorUrl, true);
            sas.applicationSwitcher.sendMessageToApp("RiskScenarioManager", "OpenScenario", {
                "id": id,
                "dataSourceName": ""
            });
        }).fail(function (jqxhr) {
            sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
        });
    },
    _differenceObj: function (obj1, obj2) {
        return _.filter(obj1, function (o1) {
            return !_.some(obj2, function (o2) {
                return o1.equals(o2);
            });
        });
    },
    _isValidName: function (name) {
        // UTF-8 or DBCS characters are not allowed, the other reg ex will allow UTF-8 or DBCS characters
        var isValid = name.match(/[^\w]/gi);
        /* /[`~!@#$%^&*()|+\-=?;:'",.<>\{\}\[\]\\\/ ]/gi*/
        if (isValid && isValid.length) {
            return false;
        }
        return true;
    },
    _getCleanColumnName: function (name) {
        var cleaned = name.replace(/[`~!@#$%^&*()|+\-=?;:'",.<>\{\}\[\]\\\/ ]/gi, "_"); // /[^\w]/gi
        if (cleaned.length > 32) {
            return cleaned.substring(0, 31); //only need 32 characters
        } else {
            return cleaned;
        }
    },
    /**
     * Create a NacChecker and start if needed
     * @param {boolean} start whether or not start immediately
     * @param {sap.ui.core.mvc.View} view the View that the NavChecker needs to destroy when exit
     * @return {sas.risk.common.utils.NavChecker} the navChecker
     */
    createNavChecker: function (start, view) {
        var router = sap.ui.core.routing.Router.getRouter("router");
        var navChecker = new sas.risk.common.utils.NavChecker(sas.config.getAppId(), this._rb.getText("project.dirty.question.txt"), router);
        if (start) {
            if (view && view.destroy) {
                var callback = $.proxy(view.destroy, view);
            }
            navChecker.start(callback);
        }
        return navChecker;
    },

    /**
     * Popup a confirmation that is similar to NavChecker if the page is dirty, and call back to continue
     * @param {boolean} isDirty whether or not the page is dirty
     * @param {function} continueCallback back function if page is not dirty or ok to continue
     * @param {Object} callbackParam callback function's parameter if needed
     */
    confirmBeforeContinue: function (isDirty, continueCallback, callbackParam) {
        if (isDirty) {
            if (confirm(this._rb.getText("project.dirty.question.txt"))) {
                continueCallback(callbackParam);
            }
        } else {
            continueCallback(callbackParam);
        }
    },

    /**
     * Popup a confirmation that is similar to NavChecker if the page is dirty, and call back to continue
     * @param {boolean} isDirty whether or not the page is dirty
     * @return {boolean} if it is ok to continue
     */
    confirmToContinue: function (isDirty) {
        if (isDirty) {
            if (!confirm(this._rb.getText("project.dirty.question.txt"))) {
                return false;
            }
        }
        return true;
    },
    /**
     * Allows setting a custom label for the given sas.hc.m.SearchField element's
     * landmark in the Landmarks dialog. This is particularly necessary for SearchField
     * because there is another search field in the SAS common UI shell which generically
     * appears as "Search" in the Landmarks dialog. This function allows us to create a
     * distinguishable Landmark label for MIP specific search fields (ex: "Search Models",
     * "Search Variables", etc.)
     * See S1221065
     *
     * @param {sas.hc.m.SearchField} quickSearchField search field
     * @param {string} landmarkText - landmark text
     */
    setQuickSearchLandmarkLabel: function(quickSearchField, landmarkText) {
        quickSearchField.onAfterRendering = function() {
            sas.hc.m.SearchField.prototype.onAfterRendering.apply(quickSearchField, arguments);
            $("form", quickSearchField.getDomRef()).attr({
                "data-landmark-label": landmarkText
            });
        };
    },
    /**
     * Handle server error with message popup
     * @param errorResponse errorResponse error response object
     * @param title  (optional; the title for the message)
     */
    handleServerFailure: function (errorResponse,title) {
        var dialogTitle=title||sas.config.appName;
        // TODO: Add custom title parameter
        if (errorResponse) {
            try {
                var responseJSON = errorResponse.responseJSON || errorResponse.response;
                if (!responseJSON && errorResponse.responseText) {
                    responseJSON = JSON.parse(errorResponse.responseText);
                }
                /*
                 * IE11 has an issue when requesting to download files. because of this, the "content-type" is not set..
                 * therefore, the response is a "string" and not a JSON object. if this is the case we need to parse it
                 * to be a JSON object.
                 *
                 * https://connect.microsoft.com/IE/feedback/details/820864/ie11-xmlhttprequest-triggers-readystate-1-event-twice
                 * Srini
                 */
                if (responseJSON && typeof(responseJSON)!=="object"){   // S1341678 HF5
                    responseJSON = JSON.parse(responseJSON);
                }
                if (!responseJSON && errorResponse.message) {
                    responseJSON = errorResponse;
                }
                if (responseJSON) {
                    var remediation = (responseJSON.remediation !== undefined && responseJSON.remediation !== "") ?
                        "\n\n" + this._rb.getText('message.error.remediation.fmt.txt', responseJSON.remediation) :
                        "";
                    var dialog=sas.hc.m.MessageDialog.error({
                        text: responseJSON.message + remediation,
                        detailText: responseJSON.details.join("\n"),
                        title:dialogTitle
                    });
                    dialog.setContentWidth("30rem");
                }
            } catch(ex) {
                var errorMsg = errorResponse.statusText || ex.message;
                sas.hc.m.MessageDialog.error({
                    text: errorMsg,
                    title:dialogTitle
                });
            }
        } else {
            sas.hc.m.MessageDialog.error({
                text: this._rb.getText('error.message.txt'),
                title:dialogTitle
            });
        }
    },

    /**
     * Handle server error with message popup
     * @param warningResponse warningResponse error response object
     * @param title  (optional; the title for the message)
     */
    handleWarningMessage: function (warningResponse) {
        var dialogTitle=warningResponse.title ||sas.config.appName;
        if (warningResponse) {
            try {
                var responseJSON = warningResponse.responseJSON || warningResponse.response;
                if (!responseJSON && warningResponse.responseText) {
                    responseJSON = JSON.parse(warningResponse.responseText);
                }
                /*
                 * IE11 has an issue when requesting to download files. because of this, the "content-type" is not set..
                 * therefore, the response is a "string" and not a JSON object. if this is the case we need to parse it
                 * to be a JSON object.
                 *
                 * https://connect.microsoft.com/IE/feedback/details/820864/ie11-xmlhttprequest-triggers-readystate-1-event-twice
                 * Srini
                 */
                if (responseJSON && typeof(responseJSON)!=="object"){   // S1341678 HF5
                    responseJSON = JSON.parse(responseJSON);
                }
                if (!responseJSON && warningResponse.message) {
                    responseJSON = warningResponse;
                }
                if (responseJSON && responseJSON.length>0) {
                    var responseDetails;
                    for (var i=0;i<responseJSON.length;i++){
                        if (i==0)
                            responseDetails = responseJSON[i] + "\n";
                        else
                            responseDetails += responseJSON[i] + "\n";
                    }
                    var dialog=sas.hc.m.MessageDialog.warning({
                        text: responseDetails,
                        title:dialogTitle,
                        press: function() {
                            sas.hc.m.MessageDialog.createCloseTab();
                        }
                    });
                    dialog.setContentWidth("30rem");
                }
            } catch(ex) {
                var errorMsg = warningResponse.statusText || ex.message;
                sas.hc.m.MessageDialog.error({
                    text: errorMsg,
                    title:dialogTitle
                });
            }
        } else {
            sas.hc.m.MessageDialog.error({
                text: this._rb.getText('error.message.txt'),
                title:dialogTitle
            });
        }
    },

    /*
     * Common method for downloading files
     *
     * @param {Object} the response of the download request
     * @param {String} the filename
     * @private
     */
    _downloadHandler: function (response, filename) {
        if (window.navigator.msSaveBlob) {
            window.navigator.msSaveBlob(response, filename);
        } else {
            var downloadUrl = URL.createObjectURL(response);
            var a = document.createElement("a");
            a.href = downloadUrl;
            a.download = decodeURIComponent((filename+'').replace(/\+/g, '%20'));   // fixes for S1188266
            a.textContent = "error message";
            document.body.appendChild(a);
            a.click();
        }
    },
    /*
     * Commmon Method that is shared between wkbench/Taskdownload and reports/downloadReport
     * @param {Integer} attachmentId
     * @returns {*}
     * @private
     */
    _downloadAttachment: function (attachmentId) {
        // fixes for S1188266
        //$("#xlsFrame").attr('src', 'rest/attachments/' + attachmentId);
        var deferred = $.Deferred();
        var exportURL = 'rest/attachments/' + attachmentId;

        var xhr = new XMLHttpRequest();
        xhr.open("GET", exportURL, true);
        xhr.responseType = "blob";
        xhr.onload = function (e) {
            switch (this.status) {
                case 200:
                {
                    var contentDispositionHeader = xhr.getResponseHeader("content-disposition");
                    var fileName = contentDispositionHeader.slice(contentDispositionHeader.indexOf("filename")).replace("filename=\"", "").replace("\"", "");
                    sas.stress.wkbench.StressUtil._downloadHandler(this.response, fileName);
                    deferred.resolve();
                }
                    break;
                default:
                {
                    jQuery.sap.log.error(e.target.statusText);
                    sas.stress.wkbench.StressUtil._downloadHandler(this.response, "Error.txt");
                    deferred.reject(e.target.statusText);
                }
                    break;
            }
        };
        xhr.onerror = function (e) {
            console.log(e);
            //alert('Unable to download excel.');
            deferred.reject(e.target.statusText);
        };
        xhr.send(); //

        return deferred;
    },
    getNameVersion:function(name,version){
        if (version) {
            var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
            return rb.getText("hierarchy.NameVersion.fmt.txt", [name, version]);
        }
        return name;
    },
    getConfirmationMessage: function (confirmationText, itemNames) {

        //if (itemNames && itemNames.length > 0) {
            confirmationText += "\n\n";
            var rb = this._rb;
            _.each(itemNames, function (itemName) {
                confirmationText += rb.getText("list.bullet.txt") + itemName + "\n";
            });
        //}
        return confirmationText;
    },
    /*
     * S1302379... returns the locale specific list separator
     * @returns {string}
     */
    whatListSeparator:function() {
        /*
         http://stackoverflow.com/questions/1011628/detecting-regional-settings-list-separator-from-web
         */
        var list = ["a", "b"], str;
        var locale = sap.ui.getCore().getConfiguration().getLocale();           // fixes for S1302379
        var separators=sas.stress.wkbench.StressLocales._separators[locale.toLocaleString()];  // does it exist
        var listSeparator=undefined;  // default
        if (separators){
            listSeparator= separators[0];
        }
        if (list.toLocaleString) {
            str = list.toLocaleString();
            str=str.substring(1,2);
            if (listSeparator===undefined||str===listSeparator){
                //console.warn("List Separators same between system and browser locales?: System::'"+str+"'   Browser::'"+listSeparator+"'. Using system locale specific.");
                return str;    // return the system separator...
            }
        }
        //console.warn("List Separators different between system and browser locales: System::'"+str+"'   Browser::'"+listSeparator+"'. Using browser locale specific");
        return listSeparator;
    },
    /*
     * S1302379...  returns the locale specific decimal separator
     * @returns {number}
     */
    whatDecimalSeparator:function () {
        /*
         http://stackoverflow.com/questions/1074660/with-a-browser-how-do-i-know-which-decimal-separator-does-the-client-use
         n = /^1(.+)1$/.exec(n.toLocaleString())[1]
         */
        var n = 1.1;
        var locale = sap.ui.getCore().getConfiguration().getLocale();           // fixes for S1302379
        var separators=sas.stress.wkbench.StressLocales._separators[locale.toLocaleString()];  // does it exist
        var decimalSeparator=undefined;  // default
        if (separators){
            decimalSeparator= separators[1];
        }
        var formatter=sap.ui.core.format.NumberFormat.getCurrencyInstance({decimals:1}, locale);            // fixes for S1302379
        n = formatter.format(n).substring(1, 2);
        if (n!==decimalSeparator){
            //console.warn("Decimal Separators different between browser and pre-defined locales: Browser::'"+n+"'   Pre-defined::'"+decimalSeparator+"'. Using Pre-defined locale specific");
            return decimalSeparator;
        }
        //console.warn("Decimal Separators same between browser and pre-defined locales?: Browser::'"+n+"'   Pre-defined::'"+decimalSeparator+"'. Using browser locale specific.");
        return n;
    },
    /*http://stackoverflow.com/questions/1144783/how-to-replace-all-occurrences-of-a-string-in-javascript*/
    replaceAll:function(str, find, replace) {
        return str.replace(new RegExp(sas.stress.wkbench.StressUtil.escapeRegExp(find), 'g'), replace);
    },
    escapeRegExp:function(str) {
        return str.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
    },
    unFormatFormula:function(formula){
        var locale= sap.ui.getCore().getConfiguration().getLocale();
        var unParsedValue=formula;
        if (locale.toLocaleString().indexOf("en")===-1/*&&overlay.value.parsedFormula==undefined*/) { // fixes for S1302379
            console.warn("Language is not en-*... updating the formula to be en-*");
            unParsedValue=sas.stress.wkbench.StressUtil.replaceAll(unParsedValue,sas.stress.wkbench.StressUtil.whatDecimalSeparator(),".");
            unParsedValue=sas.stress.wkbench.StressUtil.replaceAll(unParsedValue,sas.stress.wkbench.StressUtil.whatListSeparator(),",");
        }
        return unParsedValue;
    },
    /**
     *
     */
    loadAndProcessSheetsData:function(filteredSheets,isDirty){
        var defs=[];
        _.each(filteredSheets, function (s) {
            var info = s.getInfo();
            if (info && !s.errored) {  // if the sheet is loaded.. load it's data
                defs.push(info.getFilters().loadCellData(isDirty));
            }
        });
        if (defs.length) {
            $.when.apply($, defs).done(function () {
                var i;
                for (i = 0; i < filteredSheets.length; i++) {
                    var info = filteredSheets[i].getInfo();//.getSheetScenario(scenarioId);
                    if (info&&!filteredSheets[i].errored) {
                        info.getFilters().getData().processOverlays();
                    }
                }
            });
        }
    },
    getPeriodTypeResourceString:function(interval,resourceModel) {
        if (resourceModel && interval) {
            return resourceModel.getProperty("modelgroup.periodtype." + interval.toLowerCase() + ".txt");
        }
        return interval;
    },
    /**
     * S1386434.. the method to do the good things for the filter..
     *
     * @param rb
     * @param filterString
     * @param partialResourceKey
     * @param value
     * @returns {*}
     * @private
     */
    _matchFilterValue:function(rb, filterString, partialResourceKey, value){
        //var key = "scenario.period." + periodType.toLowerCase() + ".label.txt";
        var match;
        if (value) {
            // found the underlying data.. get the localized version of the same and lower case it
            var resourceKey, periodTypeResourceString;
            if (partialResourceKey&&partialResourceKey.length>0){
                resourceKey=partialResourceKey+value.toLowerCase()+".label.txt";
                periodTypeResourceString=rb.getProperty(resourceKey).toLocaleLowerCase();
                if (periodTypeResourceString===resourceKey){    // S1389118 S1388881
                    periodTypeResourceString= value;
                }
            }else{
                resourceKey=sas.stress.wkbench.StressUtil.getPeriodTypeResourceString(value, rb).toLocaleLowerCase();
                periodTypeResourceString=rb.getProperty(resourceKey).toLocaleLowerCase();
            }

            // try to match it
            match = (periodTypeResourceString.indexOf(filterString) !== -1);
        }
        return match;
    },
    /**
     * S1386434: the custom filter for items that ar localized on the UI causing issues with search
     *
     * @param key
     * @param rb
     * @param filterString
     * @param partialResourceKey
     * @returns {sap.ui.model.Filter}
     */
    createCustomFilter:function(key, rb, filterString, partialResourceKey){
        var customFilter = new sap.ui.model.Filter({
            path: key,
            test: $.proxy(sas.stress.wkbench.StressUtil._matchFilterValue, sas.stress.wkbench.StressUtil, rb, filterString.toLocaleLowerCase(), partialResourceKey)
        });
        return customFilter;

    },

    /**
     * Returns the number of digits after the decimal point
     * @param num
     * @returns {number}
     */
    decimalPlaces:function (num) {
        var match = (''+num).match(/(?:\.(\d+))?(?:[eE]([+-]?\d+))?$/);
        if (!match) { return 0; }
        return Math.max(
            0,
            // Number of digits right of decimal point.
            (match[1] ? match[1].length : 0)
                // Adjust for scientific notation.
            - (match[2] ? +match[2] : 0));
    },

    /**
     * Store the child window that is created..
     *
     * @param graphWindow
     */
    storeGraphWindow: function (key, sheetId, graphWindow){
        sas.stress.wkbench.StressUtil._graphWindows[key] = graphWindow;
        sas.stress.wkbench.StressUtil._graphWindowIDtoKeyStorageMap[key] = sheetId;
    },

    /**
     * handler for closing the main window... the child windows will be closed.
     *
     * @private
     */
    _onWindowUnload: function() {
        // remove the items form local storage and close the child windows
        _.each (sas.stress.wkbench.StressUtil._graphWindows, function(graphWindow, key) {
            var storageKey = sas.stress.wkbench.StressUtil._graphWindowIDtoKeyStorageMap[key];
            localStorage.removeItem(storageKey);
            if (graphWindow !== window) {
                graphWindow.close();
                sas.stress.wkbench.StressUtil._graphWindows[key] = undefined;
            }
        });
        sas.stress.wkbench.StressUtil._graphWindows= {};
        sas.stress.wkbench.StressUtil._graphWindowIDtoKeyStorageMap= {};
    },
    /**
     * S1421622
     *
     * Update the diagram bread crumb by removing the items except for the Root.
     *      If the item KEY DOES NOT match the nodeId remove it
     * (TODO: DEFECT against commons, the breadcrumb styling is not right, if user navigates to one level back)
     * @param nodeId
     * @private
     */
    _updateDiagramBreadCrumb: function (diagramBreadCrumb, nodeId, processName) {
        // remove the un-wanted items from the bread crumb
        // go through the items and if the Key does not match the current nodeId remove it
        var dbc = diagramBreadCrumb;
        var items = dbc.getItems();
        var length = items.length - 1;
        if (nodeId === "Root"){ // if at Root.. remove all and add Root
            diagramBreadCrumb.removeAllItems();
            diagramBreadCrumb.addBreadcrumbItem("Root", processName);

            return;
        }
        var item,
            key,
            text;
        for (var idx = length; idx >=0; idx--){
            item = items[idx];
            var key = item.getProperty("key");
            if (key !== "Root" && key !== nodeId){
                dbc.removeItem(item);
            }
        }
        item = dbc.getItems()[dbc.getItems().length - 1];
        key = item.getProperty("key");
        text = item.getProperty("text");
        dbc.removeItem(item);
        dbc.addBreadcrumbItem(key, text);   // workaround for bread crumb last item
    }
};