/**
 * Created by sinsrj on 1/24/2018.
 */

jQuery.sap.require({ modName: "sas.stress.wkbench.view.SelectSheetsForDownload", type: "controller" });

jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.UserPrefs");
jQuery.sap.require("sas.stress.wkbench.model.Project");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.risk.common.widgets.HelpLabel");
jQuery.sap.require("sas.risk.common.widgets.SelectTable");
jQuery.sap.require("sas.risk.common.widgets.WidgetFactory");

jQuery.sap.require("sas.risk.common.widgets.RiskPage");

jQuery.sap.require("sas.stress.wkbench.widget.SelectSheetTemplatesWithCategoryFilter");

sap.ui.jsview("sas.stress.wkbench.view.SelectSheetsForDownload", {
    getControllerName: function () {
        return "sas.stress.wkbench.view.SelectSheetsForDownload";
    },

    createContent: function (controller) {
        var rb=sas.stress.wkbench.StressUtil.getBundle();

        this.okButton= new sas.hc.m.Button({
            id: "AddRemoveSheetTemplatesView.saveProjectButton",
            text: rb.getText("button.export.action.label"),
            enabled: "{/isTrue}",
            press: $.proxy(controller.handleOKButtonPress, controller)
        });

        this.cancelButton = new sas.hc.m.Button({
            text: rb.getText("button.cancel.action.label"),
            press: $.proxy(controller.cancelAddRemoveSheetTemplates, controller)
        });

        return this._createSheetTemplatesTable(controller, rb);
    },
    _createSheetTemplatesTable: function (controller, rb) {
        var NO_VERSION = "__NO__VERSION__";

        /*this.workSheetList = new sas.risk.common.widgets.SelectTable({
         id: this.createId("AddRemoveSheetTemplatesView.workSheetList"),
         nameAttribute: "nameVersion",
         listItems: "{/worksheets}",
         listName:  rb.getText("project.worksheets.name.txt"),
         visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
         //minAutoRowCount: 5,            //visibleRowCount: 4,
         //columnHeaderVisible: true,
         layoutData: new sas.hc.m.FlexItemData({ growFactor: 2 }),
         selectionChange: $.proxy(controller.toggleEditProjectDialogSaveButton, controller)
         });

         var worksheetVersion = new sas.hc.m.Text({wrapping: false}).bindProperty("text", {
         path: "version",
         formatter: function (version) {
         return (version === NO_VERSION) ? "" : version ;
         }
         });

         this.workSheetList.addColumn(new sas.hc.ui.table.Column({
         label: new sas.hc.m.Label({ text: rb.getText("project.worksheets.worksheetVersion.txt") }),
         template: worksheetVersion,
         sortProperty: "version"
         }));

         this.workSheetList.bindRows("/worksheets");*/

        this.workSheetList = new sas.stress.wkbench.widget.SelectSheetTemplatesWithCategoryFilter({
            height: "100%",
            sheetTemplates: "/worksheets",
            inputTemplates: "{/sheetDefinitions}",
            categories: "/categories",
            selectedCategoryName: "{/selectedCategoryName}",
            selectedCategoryItem: "{/selectedCategory}",
            readyCallback: $.proxy(controller.handleTestWidgetReady, controller),
            selectionChange: $.proxy(controller.toggleEditProjectDialogSaveButton, controller)
        }).addStyleClass("riskReportsFacetPanel");

        return this.workSheetList;
    },
    attachClosing: function (callBack, listener) {
        this.attachEvent(this.getId() + "_CLOSING", callBack, listener);
    },

    destroy: function () {
        sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
    }
});