jQuery.sap.require("sas.stress.wkbench.ViewManager");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.StressAPI");

//FIXME: This entire logic is flawed from the server and the repercussions are being FELT here as seen in the logic
sap.ui.controller("sas.stress.wkbench.view.TaskSASScriptParameters",{
	onInit: function () {
		var self=this;
		var view = this.getView();
		var viewData = view.getViewData();

		this.i18N = new sap.ui.model.resource.ResourceModel({bundleName: "sas.stress.scripts.messagebundle"});
		view.setModel(this.i18N, "i18N");

		this.task=viewData.task;
		var script=viewData.script;

		this._validValues=new Array(script.runtimeParameters.length);
		this._validValues.fill(true, 0, script.runtimeParameters.length);

		// set the model
		// the script == ..._fromJSON, we need to  toJSON it
		var defaultParameters=[];
		_.each(script.runtimeParameters,function(parameter){
			var values;
			var defaultParameter={name:"",value:"",description:""};

			defaultParameter.orderNum=parameter.orderNum;
			defaultParameter.name=parameter.name;
			defaultParameter.description=parameter.description;

			// FIXME: somehow no ID in the DB... and orderNum starts with 0...
			defaultParameter.parameterId=parameter.orderNum+1;

			defaultParameter.value=parameter.lastUsedValue?parameter.lastUsedValue:parameter.defaultValue;
			defaultParameter.typeCd=parameter.type;
			defaultParameter.defaultValue=parameter.defaultValue;
			defaultParameter.definition=parameter.definition;

			defaultParameter.errors=parameter.errors;

			// FIXME: we had decided no parsing on client and here we are...
			if (parameter.lastUsedValue) {
				if (parameter.lastUsedValue.indexOf("\n") >= 0) {
					// values[0]=id, values[1]=name, values[2]=version
					values = parameter.lastUsedValue.split("\n");
				} else {
					defaultParameter.lastUsedValue = parameter.lastUsedValue;
				}
			}else{
				defaultParameter.lastUsedValue = parameter.defaultValue?parameter.defaultValue:"";
			}

			if (defaultParameter.typeCd.toLowerCase()==="freeform" /*&& defaultParameter.value.length*/){ // S1388739
				self._validValues[parameter.orderNum]=true;
			}else {
				//defaultParameter.lastUsedValue=parameter.lastUsedValue?parameter.lastUsedValue&&parameter.type.toLowerCase()!=="systemobject":parameter.defaultValue;
				defaultParameter.allowableValues = parameter.allowableValues;
				var allowableValue = _.find(defaultParameter.allowableValues, function (value) {
					var listNameVersion = sas.stress.wkbench.StressUtil.getNameVersion(value.name.trim(), value.version);
					// S1385228... the values are now "TYPE/nID\nNAME\nVersion" and it breaks down as ["TYPE", "ID", "NAME", "VERSION"]
					// therefore, values[2] == "NAME" and values[3]=="VERSION"
					var lastUsedObjectName=values ? values[2].trim() : (defaultParameter.lastUsedValue?defaultParameter.lastUsedValue:"");
					var lastNameVersion = sas.stress.wkbench.StressUtil.getNameVersion(values ? values[2] : lastUsedObjectName, values ? values[3] : undefined);
					return listNameVersion === lastNameVersion;
				});
				if (allowableValue) {
					defaultParameter.selectedKey = allowableValue.id.toString();
					self._validValues[parameter.orderNum] = true;
				} else {
					defaultParameter.selectedKey = "";
					self._validValues[parameter.orderNum] = false;
					if (parameter.type.toLowerCase()==="sascode"&&parameter.errors.length>0){
						//	if the parameter === SASCode and it has fialied to execute... we still need to execute the script
						defaultParameter.value="";
						self._validValues[parameter.orderNum]=false; // true; S1418507
					}
				}
			}

			defaultParameters.push(defaultParameter);
		});
		var thescript={
			id:script.scriptId,
			//key:script.key,
			name:script.name,
			version:script.version,
			/*description:script.description,
			code:script.code,*/

			defaultParameters:defaultParameters,

			/*created:script.created,
			createdByUserId:script.createdByUserId,
			updated:script.updated,
			updatedByUserId:script.updatedByUserId*/
		};
		var model=new sas.risk.common.models.RiskJSONModel({script:thescript});	//S1382503
		view.parametersTable.setModel(model);
		view.workGroupSelect.removeAllItems();

        _.each(sas.stress.wkbench.StressUtil.getRiskWorkGroups(), function (workGroup) {
            view.workGroupSelect.addItem(
                new sas.hc.ui.core.Item({
                    key: workGroup,
                    text: workGroup
                })
            );
        });

        var taskParms = this.task && this.task.parms;
        var scriptParms = this.task && this.task.script;

        var defaultWorkGroup = taskParms && taskParms.workGroupName;
        var lastWorkGroup = scriptParms && scriptParms.workGroupName;

        var allowOverrideWorkGroup = taskParms && taskParms.allowOverridingWorkGroupName;

        if (!defaultWorkGroup) defaultWorkGroup = "Public";

        var finalWorkGroup = (lastWorkGroup) ? lastWorkGroup : defaultWorkGroup;

        view.workGroupSelect.setSelectedKey(finalWorkGroup);
        view.workGroupSelect.setEnabled(allowOverrideWorkGroup === true);

        view.setModel(model);
		this._toggleOKButton();

		new sas.risk.common.utils.LayoutService(view.parametersTable, "TaskScriptParametersTable");
	},
	_parameterLiveChange:function(e){
		var newValue= e.getParameter("newValue");
		var valueInput=e.getSource();
		var row=e.getSource().getParent().getParent();
		// fixes for S1383071
		var customDataParameterIndex = _.find(e.getSource().getCustomData(), function (customData) {
			return customData.getKey() === "parameterIndex";
		});
		/*var customDataParameterType = _.find(e.getSource().getCustomData(), function (customData) {
			return customData.getKey() === "parameterType";
		});*/
		var parameterIndex = customDataParameterIndex?customDataParameterIndex.getValue():row.getIndex();
		/*if (newValue.length===0&&customDataParameterType.toLowerCase()!=="freeform"){
			this._validValues[parameterIndex]=false;    // S1383071.. missed this the last time when fixed
			valueInput.setValueState(sap.ui.core.ValueState.Error);
			valueInput.setValueStateText(this.i18N.getProperty("error.invalid.runtime.value.txt"));
		}else{*/
			this._validValues[parameterIndex]=true;
		//}
		this._toggleOKButton();
	},
	runSASScriptTask:function(e){
		var view=this.getView();
		var data=view.parametersTable.getModel().getData();
		var that=this;
		var workGroup = view.workGroupSelect.getSelectedKey();
		// run the task
		sas.stress.wkbench.StressAPI.runTask(this.task,data.script,workGroup)
			.done(function(data){
				that.task.script=data.script;
				view.fireEvent(view.getId() + "_CLOSING", {"view": view, "action": "DONE", response: "Done", data:data});
			})
			.fail(function (e) {
				view.fireEvent(view.getId() + "_CLOSING", {"view": view, "action": "DONE", response: e});
			});

		//view.fireEvent(view.getId() + "_CLOSING", { "view": view, "action": "OK" });
	},
	cancel:function(e){
		var view = this.getView();
		view.fireEvent(view.getId() + "_CLOSING", { "view": view, "action": "CANCEL" });
	},
	_selectDefaultValue:function(e){
		console.log(e);

		var selectedKey= e.getParameter("selectedItem").getKey();
		var row=e.getSource().getParent().getParent();
		// fixes for S1383071
		var customData = _.find(e.getSource().getCustomData(), function (customData) {
			return customData.getKey() === "parameterIndex";
		});
		var parameterIndex = customData?customData.getValue():row.getIndex();
		if (selectedKey==="0"||selectedKey===""){
			this._validValues[parameterIndex]=false;
		}else {
			this._validValues[parameterIndex]=true;

			var ctx = this.getView().parametersTable.getContextByIndex(row.getIndex());
			var object = ctx.getObject();
			var lastRunValue = "";
			var allowableValue = _.find(object.allowableValues, function (value) {
				return value.id === Number(selectedKey);
			});
			if (object.typeCd.toLowerCase() === "systemobject") {
				if (allowableValue) {
					lastRunValue += allowableValue.objectTypeCode;
					lastRunValue += "\n" + allowableValue.id;
					lastRunValue += "\n" + allowableValue.name;
					if (allowableValue.objectTypeCode.toLowerCase()!=="project"){
						lastRunValue += "\n" + allowableValue.version || "\"\"";
					}
				}
			} else {
				if (allowableValue) {
					lastRunValue = allowableValue.name.trim();
				}
			}

			object.value = lastRunValue;
		}
		this._toggleOKButton();
	},
	_toggleOKButton:function(){
		var isAnyInValid=_.find(this._validValues,function(value){
			return value===false;
		});
		var valid=(isAnyInValid===undefined?true:isAnyInValid);
		this.getView().okButton.setEnabled(valid);
	},
	onLogButton:function(e){
		var row=e.getSource().getParent().getParent();
		var parameterIndex = row.getIndex();
		var ctx = this.getView().parametersTable.getContextByIndex(parameterIndex);
		var object = ctx.getObject();
		var errors=object.errors;

		var rb=sas.stress.wkbench.StressUtil.getBundle();
		var executionLogDlgView=sas.stress.wkbench.ViewManager.loadExecutionLogDialogView(object.name, "error", errors, rb);
		var logDialog = new sas.hc.m.Dialog({
			id:"SASCodeParameterTypeExecutionLog",
			title: rb.getText("task.execution.log.dialog.header.title"),
			content: executionLogDlgView,
			endButton: executionLogDlgView.endbutton,
			afterClose: function () {
				logDialog.destroy();
			},
			contentHeight: "30rem",
			contentWidth: "84rem",
			initialFocus: executionLogDlgView.endbutton,
			resizable:true
		});
		executionLogDlgView.attachClosing(function(){
			logDialog.close();
			this.destroy();
		},logDialog);
		logDialog.open();
	}
});